# LibAquarius_FOUND - true if library and headers were found
# LibAquarius_INCLUDE_DIRS - include directories
# LibAquarius_LIBRARIES - librarys

set(LibAquarius_LIBRARY aquarius)
set(LibAquarius_INCLUDE_DIR ${SALINITY_SOURCE_DIR}/src/libaquarius)

set(LibAquarius_LIBRARIES ${LibAquarius_LIBRARY})
set(LibAquarius_INCLUDE_DIRS ${LibAquarius_INCLUDE_DIR})

find_package(HDF5 REQUIRED COMPONENTS C Fortran HL)
list(APPEND LibAquarius_LIBRARIES ${HDF5_LIBRARIES})
list(APPEND LibAquarius_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})

find_package(LibHdf5utils REQUIRED)
list(APPEND LibAquarius_LIBRARIES ${LibHdf5utils_LIBRARIES})
list(APPEND LibAquarius_INCLUDE_DIRS ${LibHdf5utils_INCLUDE_DIRS})

set(LibAquarius_FOUND TRUE)

mark_as_advanced(FORCE LibAquarius_INCLUDE_DIR LibAquarius_LIBRARY)

