# PUGIXML_FOUND - true if library and headers were found
# PUGIXML_INCLUDE_DIRS - include directories
# PUGIXML_LIBRARIES - library directories

#
# set PUGIXML_LOCATION to the base install dir for PugiXML lib
#

find_path(PUGIXML_INCLUDE_DIR pugixml.hpp
	HINTS ${PUGIXML_LOCATION}/include)

find_library(PUGIXML_LIBRARY 
    NAMES pugixml
    HINTS ${PUGIXML_LOCATION}/lib)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(PUGIXML DEFAULT_MSG PUGIXML_LIBRARY PUGIXML_INCLUDE_DIR)
if(${PUGIXML_FOUND})
  set(PUGIXML_LIBRARIES ${PUGIXML_LIBRARY})
  set(PUGIXML_INCLUDE_DIRS ${PUGIXML_INCLUDE_DIR})
endif()

mark_as_advanced(PUGIXML_INCLUDE_DIR PUGIXML_LIBRARY)
