#!/bin/csh -f

    alias doy 'date -u -d "\!*" +%Y%j'

    # Input L0 file
    echo Processing: $1

    # Get base directory
    set dir=$2

    #Get attitude file
    set attfile=$3

    # Get DOY of L0 file
    set j=`basename $1`
    set yr=`echo $j | cut -c1-4`
    set doy=`echo $j | cut -c1-8`
    set doy=`doy $doy | cut -c 5-7`

    # ephfile is a temporary file consisting of concatenated SAC ephem files
    set ephname=`get_aquarius_eph.csh $1 $2`
    echo " "
    echo ephname: $ephname

    check_eph_times.csh $ephname
    if ($status == 110) then
	exit 110
    endif

    # Echo calling l1agen sequence
    echo l1agen_aquarius $1 ${dir}/L1A/$yr/$doy $ephname ${attfile}

    # Process L0 file
    l1agen_aquarius $1 ${dir}/L1A/$yr/$doy $ephname ${attfile}

    rm $ephname
exit

