c     4/6/2005 version updated 7/3/2010.  magnetic field table now goes up to 2020.

      subroutine fd_earth_magnetic_field(lyear,idayjl,xlat,xlon, b)
      implicit none

        integer(2) imagnetic(3,1440,720,8)
        integer(4) istart,lyear,idayjl
        real(4) xlat,xlon,b(3),cdate,brief
        real(4)    a1,a2,b1,b2,c1,c2
        integer(4) i1,i2,j1,j2,k1,k2

        data istart/1/

        if(istart.eq.1) then
        istart=0
        call openbig(3,'TABLES/mk_magnetic_field_table.dat','old')
        read(3) imagnetic
        close(3)
        endif
                                                                       
c     check inputs                                                      

      if(lyear .lt.1985 .or. lyear .ge.2020) stop 'error1 fd_earth_magnetic_field, pgm stopped'                                                                       
      if(idayjl.lt.1    .or. idayjl.gt. 366) stop 'error2 fd_earth_magnetic_field, pgm stopped'                                                                       
      if(xlon.lt.0..or.xlon.gt.360.)         stop 'error3 fd_earth_magnetic_field, pgm stopped'                       
      if(abs(xlat).gt.90.)                   stop 'error4 fd_earth_magnetic_field, pgm stopped'                                   

c     do time,lat,lon interpolation 

      if(lyear.eq.4*int(lyear/4)) then
        cdate=lyear + (idayjl-1)/366.d0
        else
        cdate=lyear + (idayjl-1)/365.d0
        endif

      brief=0.2*(cdate-1985)
      i1=1+brief                                                        
      i2=i1+1                                                           
      a1=i1-brief                                                       
      a2=1.-a1 

        if(i1.lt.1 .or. i2.gt.8)               stop 'error5 fd_earth_magnetic_field, pgm stopped'

      brief=4*(xlat+89.875)
      j1=1+brief                                                        
      j2=j1+1                                                           
      b1=j1-brief                                                       
      b2=1-b1
      if(j1.eq.  0) j1=  1
      if(j2.eq.721) j2=720
c
      brief=4*(xlon-0.125) 
      k1=1+brief                                                       
      k2=k1+1                                                           
      c1=k1-brief                                                       
      c2=1-c1                                                          
      if(k1.eq.   0) k1=1440
      if(k2.eq.1441) k2=   1 
c                                                                       
       b=             
     1 a1*b1*(c1*imagnetic(:,k1,j1,i1)+c2*imagnetic(:,k2,j1,i1))+                 
     2 a1*b2*(c1*imagnetic(:,k1,j2,i1)+c2*imagnetic(:,k2,j2,i1))+                 
     3 a2*b1*(c1*imagnetic(:,k1,j1,i2)+c2*imagnetic(:,k2,j1,i2))+                 
     4 a2*b2*(c1*imagnetic(:,k1,j2,i2)+c2*imagnetic(:,k2,j2,i2)) 
                      
      b=2*b   !convert to nt

      return                                                            
      end                                                               
