        subroutine fd_land(iscan,dorbit, fland,gland)
      use l2_module
        implicit none

        integer(4), intent(in)  :: iscan
        real(8),    intent(in)  :: dorbit
        real(4),    intent(out) :: fland(360),gland(360)

        integer(4) icel,jcel,jcel1,jcel2,i1,i2
        real(4) a1,a2
        real(4) flandx(ncel),glandx(ncel)
        real(8) brief,orbitx
 
      do icel=1,ncel
        jcel=363 - 2*icel
        if(jcel.eq.361) jcel=1
      orbitx=orbit(iscan) + (jcel-1)*dorbit/360.d0 - iorbit0
      brief=2880*mod(orbitx,117.d0)
      if(brief.gt.116.999999d0*2880) brief=116.999999d0*2880
      i1=int(1+brief)
      i2=i1+1
      a1=i1-brief
      a2=1.-a1  
      if(i1.lt.1 .or. i2.gt.nzangtot1) stop 'i oob in fd_land'  
        if(i2.eq.nzangtot1) i2=1  !use wrap around rather than element 2881 for perfect cycle
      flandx(icel)=2.e-5*(a1*ifpt_lnd(icel,i1) + a2*ifpt_lnd(icel,i2)) + 0.5
      glandx(icel)=2.e-5*(a1*ifrc_lnd(icel,i1) + a2*ifrc_lnd(icel,i2)) + 0.5
        enddo  !icel
     
c     ========================================================================================================
c     ================== map 180 cells of simulated data onto the 360 smap cells  ============================
c     ============ scan angle for simulated data rotated in the opposite direction as real data ============== 
c     ========================================================================================================

        do jcel=1,359,2
        icel=181 - int((jcel-1)/2)
        if(icel.gt.180) icel=icel-180
        fland(jcel)=flandx(icel)
        gland(jcel)=glandx(icel)
        enddo
        
        do jcel=2,360,2
        jcel1=jcel-1
        if(jcel.ne.360) then
        jcel2=jcel+1
        else
        jcel2=1
        endif
        fland(jcel)=0.5*(fland(jcel1)+fland(jcel2))
        gland(jcel)=0.5*(gland(jcel1)+gland(jcel2))
        enddo

      return
        end     

