      subroutine fd_ta_galaxy(iscan,dorbit, dtaout)
      use l2_module
      use filename_module

      implicit none
        
      integer(4), parameter:: ntab=6 !there are 6 galaxy tables:  direct and 5 reflected winds tables

      integer(4), intent(in)  :: iscan
      real(8),    intent(in)  :: dorbit
      real(4),    intent(out) :: dtaout(3,360,ntab)

      integer(4) icel,jcel,jcel1,jcel2,izang1,izang,i,j1,j2
      real(4) a1,a2,b1,b2
      real(4) dta(2,3,ncel,ntab)
      real(8) brief,orbitx,zangx,deltime,days
      integer(4), save :: last_j1=0, last_j2=0
      real(4) , save :: buf1(nzang,3,ncel,6)
      real(4) , save :: buf2(nzang,3,ncel,6)
      integer(8) offset

      do icel=1,ncel
         jcel=363 - 2*icel
         if(jcel.eq.361) jcel=1

         orbitx=orbit(iscan) + (jcel-1)*dorbit/360.d0 
         zangx=360.d0*orbitx
         zangx=mod(zangx,360.d0)
         call fixang8(zangx)
         if(zangx.lt.0 .or. zangx.gt.360) stop 'zangx oob in fd_ta_galaxy, pgm stopped'

         brief=4*zangx
         if(brief.gt.1439.99) brief=1439.99
         izang1=1+brief
         a1=izang1-brief
         a2=1-a1
         if(izang1.lt.1 .or. izang1.gt.nzang-1) stop 'izang1 oob in fd_ta_galaxy, pgm stopped'

         do i=1,2
            izang=izang1+i-1

            deltime=(utc_2000(iscan)-time_galaxy(izang))/86400.d0 !convert to days
            days=deltime - sidereal_year*floor(deltime/sidereal_year)
            if(days.lt.0 .or. days.gt.sidereal_year)  stop 'days oob in fd_ta_galaxy, pgm stopped' ! i may have to cut some slack here

            brief=(nomega-1)*days/sidereal_year
            if(brief.gt.1439.99) brief=1439.99
            j1=1+brief
            j2=j1+1
            b1=j1-brief
            b2=1-b1
            if(j1.lt.1 .or. j2.gt.nomega) stop 'j oob in fd_ta_galaxy, pgm stopped'
            if(j2.eq.nomega) j2=1 !use wrap around rather than element 1441 for perfect cycle, but the dif is extremely small 

!            write(*,*) 'gal indx: ', j1,izang,icel
            if (j1 .ne. last_j1) then
               open(3,file=galaxy_file,form='unformatted',access='stream',status='old',action='read')
               offset = (int8(j1-1)*nzang*3*ncel*6)*4 + 8*nzang + 4*nzang*ncel + 1
               READ(3, POS=offset) buf1
               close(3)
               last_j1 = j1
            endif

            if (j2 .ne. last_j2) then
               open(3,file=galaxy_file,form='unformatted',access='stream',status='old',action='read')
               offset = (int8(j2-1)*nzang*3*ncel*6)*4 + 8*nzang + 4*nzang*ncel + 1
               READ(3, POS=offset) buf2
               close(3)
               last_j2 = j2
            endif
            dta(i,:,icel,:) = b1*buf1(izang,:,icel,:) + b2*buf2(izang,:,icel,:)
! JMG      dta(i,:,icel,:)=(b1*tagal_tab(j1,izang,:,icel,:)  + b2*tagal_tab(j2,izang,:,icel,:))/500.

         enddo                  !i
      enddo                     !icel

        
      do jcel=1,359,2
         icel=181 - int((jcel-1)/2)
         if(icel.gt.180) icel=icel-180
         dtaout(:,jcel,:)=a1*dta(1,:,icel,:) + a2*dta(2,:,icel,:)
      enddo
        
      do jcel=2,360,2
         jcel1=jcel-1
         if(jcel.ne.360) then
            jcel2=jcel+1
         else
            jcel2=1
         endif
         dtaout(:,jcel,:)=0.5*(dtaout(:,jcel1,:)+dtaout(:,jcel2,:))
      enddo

      return
      end     
