        subroutine fd_toa_land_corr(iscan,dorbit, dtaout)
      use l2_module
        implicit none

        integer(4), intent(in)  :: iscan
        real(8),    intent(in)  :: dorbit
        real(4),    intent(out) :: dtaout(2,360)
        
        character(120) filename
        
        integer(4) icel,jcel,jcel1,jcel2,i1,i2,j1,j2,i1sv,i2sv
        real(4) a1,a2,b1,b2
        real(4) dta(2,ncel)
        real(8) brief,orbitx,xday,xmon

        integer(2) idtb1(ncel,nzangtot2,2)
        integer(2) idtb2(ncel,nzangtot2,2)
        
      integer(4) lyear,idayjl,imon,idaymo !year, julian day, month (1-12), day of month (1=31), second of day (0-86399)
        real(8) secyr,secdy                         !seconds in year, second of day
     
      data i1sv,i2sv/-1,-1/

        call fd_date_2000(utc_2000(iscan),   secyr,lyear,idayjl,imon,idaymo,secdy)
        xday=idayjl-1+int(secdy)/86400.d0 !truncate secdy to make sure it does not = 86400 
        if(lyear.eq.4*int(lyear/4)) then
        xmon=12.d0*xday/366.d0
        else
        xmon=12.d0*xday/365.d0
        endif
        if(xmon.lt.0 .or. xmon.ge.12.)   stop 'xmon oob in fd_tb_toa_land_corr, pgm stopped'
        
      brief=xmon-0.5
      i1=1+brief
      i2=i1+1
      a1=i1-brief
      a2=1.-a1
        if(i1.eq. 0) i1=12
        if(i2.eq.13) i2= 1
        
        if(i1.ne.i1sv) then
        if(i1.eq.i2sv) then
        idtb1=idtb2
        else
        write(filename,9001) i1
 9001 format('TABLES/land_corr_tables_',i2.2,'.dat')
      call openbig(3,filename,'old')
      read(3) idtb1
        close(3)
        endif
        endif
        
        if(i2.ne.i2sv) then
        if(i2.eq.i1sv) then
        idtb2=idtb1
        else
        write(filename,9001) i2
      call openbig(3,filename,'old')
      read(3) idtb2
        close(3)
        endif
        endif
        
        i1sv=i1
        i2sv=i2
        
      do icel=1,ncel
        jcel=363 - 2*icel
        if(jcel.eq.361) jcel=1
      orbitx=orbit(iscan) + (jcel-1)*dorbit/360.d0 - iorbit0
      brief=1440*mod(orbitx,117.d0)
      if(brief.gt.116.999999d0*1440) brief=116.999999d0*1440
      j1=int(1+brief)
      j2=j1+1
      b1=j1-brief
      b2=1.-b1  
      if(j1.lt.1 .or. j2.gt.nzangtot2) stop 'j oob in fd_toa_land_corr'         
        if(j2.eq.nzangtot2) j2=1  !use wrap around rather than element 1441 for perfect cycle
      dta(:,icel)=0.01*(a1*(b1*idtb1(icel,j1,:)+b2*idtb1(icel,j2,:)) + a2*(b1*idtb2(icel,j1,:)+b2*idtb2(icel,j2,:)))
        enddo  !icel

c     ========================================================================================================
c     ================== map 180 cells of simulated data onto the 360 smap cells  ============================
c     ============ scan angle for simulated data rotated in the opposite direction as real data ============== 
c     ========================================================================================================

        do jcel=1,359,2
        icel=181 - int((jcel-1)/2)
        if(icel.gt.180) icel=icel-180
        dtaout(:,jcel)=dta(:,icel)
        enddo
        
        do jcel=2,360,2
        jcel1=jcel-1
        if(jcel.ne.360) then
        jcel2=jcel+1
        else
        jcel2=1
        endif
        dtaout(:,jcel)=0.5*(dtaout(:,jcel1)+dtaout(:,jcel2))
        enddo


      return
        end     
