c     aug 31 2015 change sept 23 2015
c     1.  \\Ops1p\u changed to \\Galaxy1\h everywhere
c     2.  thomas oob ta filter applied
c     3.  sun azimuth and zenith outputed

c     aug 13 2015 changed aug 31 2015.  thomas small adjustments to thtnad and yaw implemented, and i no longer call correct_ems_ant

c     version changed aug 13 2015.  kflag_sun removed.  it was redundant with iflag_sun.  problem with assigning minus sign wrongly was correct.    

c     july 9 2015 changed july 23 2015.  minus sign appended to sunglt when sun is not visible

      ! include '../../../src/l2agen_smap/smap_id_module.f'
      ! include '../../../src/l2agen_smap/filename_module_l2a.f'              
      ! include '../../../src/l2agen_smap/l2_module_smap.f'             
      
      program make_smap_l2a 
                                                                          
      use l2_module   
      implicit none                                                 
      real(8) start_time
      real(8) secyr,secdy
      integer(4) lyear,idayjl,imon,idaymo
      integer(4) iorbit_file,iexist     
      integer(4) ibad,kbad
        
      character(120) filename_rss_l1a_asc, filename_rss_l1a_dsc

!      allocate (tasun_tab(nomega,nzang,3,ncel,2))
!      allocate (tagal_tab(nomega,nzang,3,ncel,6))
        
      open(7,file='make_smap_l2a_error_log.txt',status='unknown',position='append')
      write(7,*) 'processing begins anew'
        
      ksat=36
!      write(*,*) 'now reading in large arrays, takes a few minutes because of array allocation'
      call readin_data_files
!      write(*,*) 'arrays allocated, now beginning processing'

      CALL getarg(1, filename_rss_l1a_asc)
      CALL getarg(2, filename_rss_l1a_dsc)
!      filename_rss_l1a_asc='r07531a.dat'
!      filename_rss_l1a_dsc='r07531d.dat'

      call read_rss_l1a(filename_rss_l1a_asc, filename_rss_l1a_dsc, start_time)
        
      if(numscan.lt.35) then
         write(*,*) 'Less than 35 scans'
         call exit(1)
      endif

        
      call fd_date_2000(start_time, secyr,lyear,idayjl,imon,idaymo,secdy)
      
c       write(6,6002) ksat,iorbit,numscan,lyear,imon,idaymo,secdy
      write(*,6002) ksat,iorbit,numscan,lyear,imon,idaymo,secdy
 6002 format('processing ',i3,i6,i6,i5,2i3,f12.4)
      
cx    call correct_ems_ant
      call smap_geolocation_scans
      call smap_geolocation_cells     
      call resample_along_scan
      call fd_geoloc_ta(start_time) 
      
      end                                                     


      subroutine fd_geoloc_ta(start_time)
      use l2_module
      use filename_module
      implicit none

        
      real(8) start_time

      character(120) filename_l2a 
        
c       integer(4) iexist

      integer(4) iscan,jscan,k_dscan,itrg,itrg_tot,ierror,lflag,iscansv
      integer(4) ilat,ilon,idir,klon,klon_end
      integer(4) idx,itab,ipol
        
      real(8) ru(3)
      real(8) x_eci(3),y_eci(3),z_eci(3),scpos_plumb(3)
      real(8) scpos_eci(3),rpy(3)
      real(8) scpos0(3),scvel0(3)
      real(8) rotangle,days,np(3,3)
      real(8) scpos_j2000(3)
      real(8) observation_time,time_since_scan_start
      real(8) xlat,xlon,xlon_rot,b(3),rearth,range,r,dorbit
        
      real(4) alpha
      integer(4) istart,iexist
        
      real(4) tmin1,tmin2,diflon
      real(4) xlatmin,xlatmax
      real(8) cel1,cel2,cel3
      real(8) coslat
      real(8) sinbeta,cosbeta
      real(8) bx,by,bz

      real(8) dissq
      real(8) deltim,dellon,dtim_dzang,dlon_dzang,node_time_sv
      
      real(4) dta_sun(3,360,2),dta_gal(3,360,6),dta_lnd(2,360),fland(360),gland(360) 
      
c     node table variables
      real(8) node_time
      real(8) node_long,node_local_time
      real(4) xlon_node1,xlon_node2

      real(4) sind, cosd
      real(8) dsind, dcosd, dtand, datand, datan2d

      data istart/1/

c     ==============================================================================================================
c     ================================== begin execution ===========================================================
c     ==============================================================================================================
 
      if(istart.eq.1) then
         istart=0

c     precompute cel#_earth to save a little cpu
         do ilat=1,nlat
            do ilon=1,nlon
               xlat=-90.125 + 0.25*ilat
               xlon= -0.125 + 0.25*ilon
               xlat=datand(ffac*dtand(xlat)) !convert to geocentric
               coslat=dcosd(xlat)
               cel1_earth(ilon,ilat)=coslat*dcosd(xlon)
               cel2_earth(ilon,ilat)=coslat*dsind(xlon)
               cel3_earth(ilon,ilat)=dsind(xlat)
            enddo
         enddo
         
      endif

c     ==============================================================================================================
c     ========================================= find node parameters ===============================================
c     ==============================================================================================================
      tmin1=1.e30; tmin2=1.e30
      iscansv=-99999
      xlatmin=1.e30; xlatmax=-1.e30
      node_time=-1.e30; node_long=-999; node_local_time=-999

      do iscan=1,numscan
         if(iflag_l0(iscan).ne.0) cycle
        
         if(abs(frcrev(iscan)).lt.tmin1) then
            tmin1=abs(frcrev(iscan))
            xlon_node1=scloc(2,iscan) - dlon(iscan) !take it back to begin of orbit
            call fixang4( xlon_node1)
         endif
         if(abs(frcrev(iscan)-1).lt.tmin2) then
            tmin2=abs(frcrev(iscan)-1)
            xlon_node2=scloc(2,iscan) + dlon_tot - dlon(iscan) - 360. !take it forward to end of orbit
            call fixang4( xlon_node2)
         endif
        
         if(scloc(1,iscan).lt.xlatmin) xlatmin=scloc(1,iscan)
         if(scloc(1,iscan).gt.xlatmax) xlatmax=scloc(1,iscan)

c     find node time, longitude, and local time      
         if(iscan-iscansv.le.5) then !allow gap of 5 scans, do not move this statment else next statement as oob iscansv
            if(zang(iscansv).lt.90.d0 .and. zang(iscan).ge.90.d0)  then  
               deltim=utc_2000(iscan)-utc_2000(iscansv)
               dellon= scloc(2,iscan)- scloc(2,iscansv)
               if(dellon.lt.-180.d0) dellon=dellon+360.d0
               if(dellon.gt. 180.d0) dellon=dellon-360.d0
               dtim_dzang=deltim/(zang(iscan)-zang(iscansv))
               dlon_dzang=dellon/(zang(iscan)-zang(iscansv))
               node_time=utc_2000(iscansv) + (90.d0-zang(iscansv))*dtim_dzang 
               node_long= scloc(2,iscansv) + (90.d0-zang(iscansv))*dlon_dzang
               node_local_time=mod(node_time,86400.d0) + node_long*240.d0
               node_local_time=mod(node_local_time,86400.d0)/3600.d0 !change from seconds to hours
            endif
         endif
        
         iscansv=iscan 
      enddo                     !iscan
        
      if(tmin1.gt.1.e29) then
         write(*,6001) iorbit
 6001    format('make_smap_l2a did not process orbit: all scans flagged bad ',i7)
         return
      endif

c     ==============================================================================================================
c     ========================================== update node table =================================================
c     ==============================================================================================================
      if(node_time.gt.-1.e29) then
         write(*,1001) iorbit, xlon_node1, xlon_node2, xlatmin, xlatmax, node_long, node_local_time, node_time-node_time_sv
 1001    format('updating node table ',i7,5f8.3,f12.6,f20.3)
         call open_direct(81,filename_node,'old','readwrite','denywr',32,10) !32 is record length, 10 is seconds to wait
         write(81,rec=iorbit) node_time, node_long, node_local_time, xlon_node1, xlon_node2
         close(81)
      else 
         write(*,1002) iorbit, xlon_node1, xlon_node2, xlatmin, xlatmax
 1002    format('node table not updated ',i7,5f8.3)
      endif
      
      node_time_sv=node_time
        
c     ==============================================================================================================
c     ========================================== write header to l2a file ==========================================
c     ==============================================================================================================
      xlon_node1=0.25*int(4*xlon_node1) !change to even step of 0.25
      xlon_node2=0.25*int(4*xlon_node2) !change to even step of 0.25
        
      diflon=xlon_node2-xlon_node1
      call fixang4(diflon)      !makes diflon between 0 and 360
      diflon=diflon-720.
      klon_end=floor(-4*diflon) !this is the cell right before xlon_node2,  xlon_node2 is contained in next orbit file
      if(klon_end.lt.1440 .or. klon_end.gt.1560) stop 'klon_end oob, pgm stopped' ! 1560=360 deg plus 30 deg

      call getarg(3, filename_l2a)
      call get_smap_l2a_filename(iorbit, filename_l2a,iexist) 
      call openbig(4,filename_l2a,'replace')
      write(4) vernum,iorbit,start_time,xlon_node1,xlon_node2,klon_end  

c     ==============================================================================================================
c     ========================================== loop through iscan ================================================
c     ==============================================================================================================
      dissq_target=1.e30

      do iscan=1,numscan
         if(iflag_l0(iscan).ne.0) cycle
        
c     ==============================================================================================================
c     ================================================= compute dorbit =============================================
c     ==============================================================================================================
         dorbit=scan_period(iscan)/orbit_period !begin with default value for dorbit
        
         lflag=0
         do jscan=iscan-1,iscan+1,2
            if(jscan.lt.1 .or. jscan.gt.numscan) cycle
            if(iflag_l0(jscan).eq.0) then
               if(jscan.eq.iscan-1) dorbit=orbit(iscan)-orbit(jscan)
               if(jscan.eq.iscan+1) dorbit=orbit(jscan)-orbit(iscan)
               lflag=1
               exit
            endif
         enddo
        
         if(abs(dorbit*orbit_period-scan_period(iscan)).gt.0.05) then
            write(*,*) dorbit,scan_period(iscan),dorbit*orbit_period-scan_period(iscan)
            stop 'error in dorbit in fd_geoloc_ta, pgm stopped'
         endif
         if(lflag.eq.0) write(*,*) 'using deflault dorbit',iorbit,iscan
        
c     ==============================================================================================================
c     ======================= compute sun, galaxy, and land corrections ============================================
c     ==============================================================================================================
         call fd_ta_sun(       iscan,dorbit, dta_sun)
         call fd_ta_galaxy(    iscan,dorbit, dta_gal)
         call fd_toa_land_corr(iscan,dorbit, dta_lnd)  
         call fd_land(         iscan,dorbit, fland,gland)
        
         idx=0
         do itab=1,2
            do ipol=1,3
               idx=idx+1
               buf_rsp(idx,:,iscan)=dta_sun(ipol,:,itab)
            enddo
         enddo
        
         do itab=1,6
            do ipol=1,3
               idx=idx+1
               buf_rsp(idx,:,iscan)=dta_gal(ipol,:,itab)
            enddo
         enddo
        
         do ipol=1,2
            idx=idx+1
            buf_rsp(idx,:,iscan)=dta_lnd(ipol,:)
         enddo
        
         idx=idx+1
         buf_rsp(idx,:,iscan)=fland
         idx=idx+1
         buf_rsp(idx,:,iscan)=gland
        
c     ==============================================================================================================
c     ============================= compute target locations =======================================================
c     ==============================================================================================================
         scpos0=scpos(:,iscan)
         scvel0=scvel(:,iscan)
         rpy=   scrpy(:,iscan)
         days=utc_2000(iscan)/86400.d0 - 0.5d0 !days essentially constant over scan and hence days, np, and np_inv need only be found once per scan
         call fd_precession(days, np) !i do not bother doing the nutation.

         do itrg=1,ncel_trg
            alpha=0.5*(itrg-1)
        
            if(itrg.ge.181 .and. itrg.le.540) then
               idir=2
            else
               idir=1
            endif

            do k_dscan=-3,3
               itrg_tot=7*(itrg-1) + k_dscan + 4       
        
               time_since_scan_start=scan_period(iscan)*alpha/360.d0  + scan_period(iscan)*k_dscan/7.d0
               observation_time = utc_2000(iscan) + time_since_scan_start  
               call get_gm_angle(observation_time,days, rotangle)
               scpos_j2000 = scpos0 + time_since_scan_start*scvel0
               scpos_eci=matmul(np,scpos_j2000)
        
               call fd_scpos_plumb(re,rp,ffac,scpos_eci, scpos_plumb)
               call get_sc_axes_from_rpy(scpos_plumb,y0(:,iscan),rpy(1),rpy(2),rpy(3) ,x_eci,y_eci,z_eci)

               cosbeta=cosd(beta)                                                                      
               sinbeta=sind(beta)                                                                      
               bx= sinbeta*cosd(alpha) !input alpha defined relative to the x axes,  alpha=-90 denotes bx=0, by=1
               by=-sinbeta*sind(alpha) !input alpha defined relative to the x axes , alpha=-90 denotes bx=0, by=1
               bz=cosbeta                                 
               b=bx*x_eci + by*y_eci + bz*z_eci                            

               r=sqrt(dot_product(scpos_eci,scpos_eci))
               ru=scpos_eci/r
               call loccel_range(r,ru(1),ru(2),ru(3),b(1),b(2),b(3),re,rp, cel1,cel2,cel3,rearth,range,ierror)
               if(ierror.ne.0) stop 'no earth intersection2, pgm stopped'

               coslat=sqrt(cel1*cel1+cel2*cel2) !cosine of geocentric lat                                 
               xlat=datand(cel3/(ffac*coslat)) !geodetic cell latitude
               xlon=datan2d(cel2,cel1)                                              
               xlon_rot=xlon - rotangle !convert from inertial to earth
               call fixang8( xlon_rot)
               cel1=coslat*dcosd(xlon_rot) !account for earth rotation
               cel2=coslat*dsind(xlon_rot) !account for earth rotation

c     ==============================================================================================================
c     ============================= compute distance from target to earth cell =====================================
c     ==============================================================================================================

               ilat=1+int(4*(xlat+90.))                                                                                    
               ilon=1+int(4*xlon_rot)
               if(ilat.lt.1 .or. ilat.gt.nlat) stop 'error in ilat in fd_geoloc_ta, pgm stopped'
               if(ilon.lt.1 .or. ilon.gt.nlon) stop 'error in ilon in fd_geoloc_ta, pgm stopped'
               dissq=(cel1-cel1_earth(ilon,ilat))**2 + (cel2-cel2_earth(ilon,ilat))**2 + (cel3-cel3_earth(ilon,ilat))**2
               if(dissq.gt.1.e-5)       stop 'dissq.gt.1.e-5,pgm stopped' 

c     ==============================================================================================================
c     ================================= compute west longitude index klon ==========================================
c     ==============================================================================================================

               diflon=xlon_rot-xlon_node1
               call fixang4(diflon) !makes diflon between 0 and 360

               if(abs(diflon-dlon(iscan)).gt.180) diflon=diflon-360
               if(abs(diflon-dlon(iscan)).gt.180) diflon=diflon-360
               if(abs(diflon-dlon(iscan)).gt.180.001) stop 'abs(diflon-dlon).gt.180' !see memo6

               klon=1+floor(-4*diflon) 
               if(klon.lt.nlon1 .or. klon.gt.nlon2) stop 'klon oob in fd_geoloc_ta, pgm stopped'

c     ==============================================================================================================
c     ================= replace data in earth grid is this target is closer to center of earth grid  ===============
c     ==============================================================================================================

               if(dissq.lt.dissq_target(klon,ilat,idir)) then
                  dissq_target(  klon,ilat,idir)=dissq
                  xlat_target(   klon,ilat,idir)=xlat
                  xlon_target(   klon,ilat,idir)=xlon_rot
                  iscn_target(   klon,ilat,idir)=iscan
                  itrg_target(   klon,ilat,idir)=itrg_tot 
                  rcell_target(1,klon,ilat,idir)=cel1
                  rcell_target(2,klon,ilat,idir)=cel2
                  rcell_target(3,klon,ilat,idir)=cel3
               endif

            enddo               !k_dscan
         enddo                  !itrg
         
      enddo                     !iscan
  
c     ==============================================================================================================
c     ============================= resample ta and output l2a data ================================================
c     ==============================================================================================================
      call resample_ta(start_time,klon_end)

      close(4)

      return
      end             
      


      subroutine resample_ta(start_time,klon_end) 
      use l2_module
      implicit none

      integer(4), parameter :: npar1=25 !number of non-resampled parameters
      integer(4), parameter :: npar2=36 !number of resampled parameters
      integer(4), parameter :: npar=npar1+npar2+1 ! 1 extra parameters asum(0) that are outputted
 
      integer(4) ipol,nout,idx,ix
      integer(4) idir,ilat,klon,klon_end
      integer(4) iscan,k_dscan,iscanx,icelx
      integer(4) itrg,itrg_tot,iobs
      real(4) buf(npar)

      real(8) start_time
      real(4) cel1_target,cel2_target,cel3_target
      real(4) xwt

      integer(4) ierror
      real(8) observation_time,zangx,xlat,xlon_rot,thtinc,azim, sunglt,suninc,sunzam,moonglt, galxlat,galxlon, pra,frdang
      real(4) xlat_ion,xlon_ion

      real(8) asum(0:npar2)
        

      do idir=1,2               !1 is fore look, 2 is aft look

c     quick scan to find nout
         nout=0
         do klon=1,klon_end
            do ilat=1,nlat
               if(dissq_target(klon,ilat,idir).gt.1.e29) cycle !this cell was not seen
               iscan=iscn_target(   klon,ilat,idir)
               if(iscan.le.idscan_max .or. iscan.ge.numscan-idscan_max+1)   cycle !do not use extreme begin and end scans
               nout=nout+1
            enddo               !ilat
         enddo                  !klon

         write(4) idir,nout

         do klon=1,klon_end
            do ilat=1,nlat
               if(dissq_target(klon,ilat,idir).gt.1.e29) cycle !this cell was not seen
               iscan=iscn_target(   klon,ilat,idir)
               if(iscan.le.idscan_max .or. iscan.ge.numscan-idscan_max+1)   cycle !do not use extreme begin and end scans
        

               cel1_target=rcell_target(1,klon,ilat,idir) !target location
               cel2_target=rcell_target(2,klon,ilat,idir) !target location
               cel3_target=rcell_target(3,klon,ilat,idir) !target location 
               itrg_tot   = itrg_target(  klon,ilat,idir) 

               itrg=1 + int((itrg_tot-1)/7)
               k_dscan=itrg_tot - 7*(itrg-1) - 4       

               if(itrg.gt.ncel_trg)       stop 'itrg.gt.ncel_trg in resample_ta, pgm stopped'
               if(iabs(k_dscan).gt.3)     stop 'iabs(k_dscan).gt.3 in resample_ta, pgm stopped'
               if(nobs_tab(itrg).eq.0)    stop 'nobs_tab(itrg).eq.0 in resample_ta, pgm stopped'
               if(iflag_l0(iscan).ne.0)   stop 'bad scan in resample_ta, pgm stopped' !previous qc should always prevent this from happening

               call smap_geolocation_target(iscan,k_dscan,itrg, 
     &              ierror,observation_time,zangx,xlat,xlon_rot,thtinc,azim, sunglt,suninc,sunzam,moonglt, galxlat,galxlon,
     &              pra,frdang,xlat_ion,xlon_ion)
               if(ierror.ne.0) stop 'no earth intersection in resample_ta, pgm stopped'

               buf( 1)=ilat
               buf( 2)=klon
               buf( 3)=itrg_tot
               buf( 4)=iscan
               buf( 5)=6378.*sqrt(dissq_target(klon,ilat,idir))
               buf( 6)=observation_time-start_time
               buf( 7)=zangx
               buf( 8)=xlat_target(klon,ilat,idir)
               buf( 9)=xlon_target(klon,ilat,idir)
               buf(10)=thtinc
               buf(11)=azim
               buf(12)=pra
               buf(13)=sunglt
               buf(14)=moonglt
               buf(15)=galxlat
               buf(16)=galxlon
               buf(17)=frdang
               buf(18)=xlat_ion
               buf(19)=xlon_ion !this index must equal npar1
               buf(20:21)=ant_loss(:,iscan)
               buf(22:23)=ant_temp(:,iscan)
               buf(24)=alpha_sun(iscan)
               buf(25)= beta_sun(iscan)

c     ==========================================================================================================
c     ============================ loop through dif ta resolutions, find resampe ta ============================
c     ==========================================================================================================
               
               asum=0

               do iobs=1,nobs_tab(itrg)
                  xwt=rsp_weight_field(iobs,itrg_tot)
                  if(xwt.eq.0) cycle
                  iscanx=iscn_tab(iobs,itrg) + iscan
                  icelx= icel_tab(iobs,itrg)
                  if(abs(iscanx-iscan).gt.idscan_max)    stop 'abs(iscn_tab(iobs,itrg)).gt.idscan_max in resample_ta, pgm stopped'
                  if(icelx.lt.1 .or. icelx.gt.360)       stop 'icelx oob in resample_ta, pgm stopped'
                  if(iscanx.lt.1 .or. iscanx.gt.numscan) stop 'iscanx oob in resample_ta, pgm stopped'  

c     x    if(ta_rsp(1,icelx,iscanx).le.0 .or. iflag_rsp( icelx,iscanx).ne.0) cycle  !check vpol, if missing the other ta are missing
                  if(minval(ta_rsp(:,icelx,iscanx)).lt.-1.e29 .or. iflag_rsp( icelx,iscanx).ne.0) cycle !if any channel for ta or tf is missing do not used  
    
                  asum(0)=asum(0) + xwt
                  idx=0
                  do ipol=1,8
                     idx=idx+1
                     asum(idx)=asum(idx) + xwt*ta_rsp(ipol,icelx,iscanx)  
                  enddo
        
                  do ix=1,28
                     idx=idx+1
                     asum(idx)=asum(idx) + xwt*buf_rsp(ix,icelx,iscanx)   
                  enddo
!                  write(*,*) iobs, asum(9)
        
                  if(idx.ne.npar2) stop 'idx oob, pgm stopped'
               enddo            !iobs
        
               buf(npar)=asum(0)
        
               if(asum(0).lt.1.e-3) then !avoid dividing by zero
                  buf(npar1+1:npar-1)=1.e30 
                  write(4) buf
                  cycle
               endif
        
               asum(1:npar2)=asum(1:npar2)/asum(0)    
               buf(npar1+1:npar-1)=asum(1:npar2)  
        
               write(4) buf

            enddo               !klon
         enddo                  !ilat

      enddo                     !idir 
 
      return
      end
 
      ! include '../../../src/l2agen_smap/io_filenames.f'     
      ! include '../../../src/l2agen_smap/readin_data_files.f'
      ! include '../../../src/l2agen_smap/read_rss_l1a.f'
      ! include '../../../src/l2agen_smap/correct_ems_ant.f'
      ! include '../../../src/l2agen_smap/resample_along_scan.f'
      
      ! include '../../../src/l2agen_smap/smap_oob_check_ocean.f'
      ! include '../../../src/l2agen_smap/fd_ta_sun.f'
      ! include '../../../src/l2agen_smap/fd_ta_galaxy.f'
      ! include '../../../src/l2agen_smap/fd_tb_toa_land_corr.f'
      ! include '../../../src/l2agen_smap/fd_land.f'
      
      ! include '../../../src/l2agen_smap/smap_geolocation_scans.f' 
      ! include '../../../src/l2agen_smap/smap_geolocation_cells.f'
      ! include '../../../src/l2agen_smap/smap_geolocation_target.f'
      ! include '../../../src/l2agen_smap/smap_geolocation_routines.f'
      ! include '../../../src/l2agen_smap/pre_nut_routines.f'
      
      ! include '../../../src/l2agen_smap/fd_earth_magnetic_field.f'
          
      ! include '../../../src/l2agen_smap/sun_vector.f'
      ! include '../../../src/l2agen_smap/moon_vector.f'

      ! include '../../../src/l2agen_smap/fd_median.f'
      ! include '../../../src/l2agen_smap/math_routines.f'
      ! include '../../../src/l2agen_smap/estima1x.f'
      ! include '../../../src/l2agen_smap/bittes.for'

      ! include '../../../src/l2agen_smap/find_month_day.f'
      ! include '../../../src/l2agen_smap/fd_date_2000.f'
      ! include '../../../src/l2agen_smap/openbig.for'
      ! include '../../../src/l2agen_smap/openbig_try.f'
      ! include '../../../src/l2agen_smap/open_file_routines.f'
      ! include '../../../src/l2agen_smap/file_exist_simple.f'
