c     5/9/2008 version updated 2/4/2014.  routine minang4 and minang8 added

c     11/10/2007 version updated on 5/9/2008.  The fixang routines were made more robust to 
c     floating point inconsistencies

      subroutine cross_norm(x, y, z)
        real(8) x(3),y(3),z(3),xmag
        
      z(1)=x(2)*y(3)-x(3)*y(2)
      z(2)=x(3)*y(1)-x(1)*y(3)
      z(3)=x(1)*y(2)-x(2)*y(1)
        
      xmag=sqrt(dot_product(z,z))
        z=z/xmag
      return
      end subroutine cross_norm
 
 
 
        real(8) function dot_product_unit8(a,b)
        implicit none
        real(8) a(3),b(3),dot
        dot=dot_product(a,b)
        if(dot.lt.-1.) dot=-1.
        if(dot.gt. 1.) dot= 1.
        dot_product_unit8=dot
        return
        end
 
 
        subroutine invert_3by3(a, ainv,det)
        implicit none
        real(8) a(3,3),ainv(3,3)
        real(8) q1,q2,q3,det
 
      q1=a(2,2)*a(3,3)-a(3,2)*a(2,3)
      q2=a(3,2)*a(1,3)-a(1,2)*a(3,3)
      q3=a(1,2)*a(2,3)-a(2,2)*a(1,3)
      det=a(1,1)*q1 + a(2,1)*q2 + a(3,1)*q3
      if(abs(det).lt.1.e-30) return
 
        ainv(1,1)=q1
        ainv(1,2)=q2
        ainv(1,3)=q3
 
        ainv(2,1)=a(3,1)*a(2,3)-a(2,1)*a(3,3)
        ainv(2,2)=a(1,1)*a(3,3)-a(3,1)*a(1,3)
        ainv(2,3)=a(2,1)*a(1,3)-a(1,1)*a(2,3)
 
        ainv(3,1)=a(2,1)*a(3,2)-a(3,1)*a(2,2)
        ainv(3,2)=a(3,1)*a(1,2)-a(1,1)*a(3,2)
        ainv(3,3)=a(1,1)*a(2,2)-a(2,1)*a(1,2)
 
      ainv=ainv/det
 
        return
        end
 
 
 
 
 
 
 
 
 
        subroutine fixang4( angle)
        implicit none
        real(4) angle
        angle=angle-360.d0*floor(angle/360.d0)   !very small negative angle result in 360, thus i do the following to make sure
cx      if(angle.lt.  0) angle=angle+360  
cx      if(angle.ge.360) angle=angle-360
        if(angle.lt.0 .or. angle.gt.359.9999) angle=0
        return
        end
 
 
 
 
        subroutine fixang8( angle)
        implicit none
        real(8) angle
        angle=angle-360.d0*floor(angle/360.d0)  !very small negative angle result in 360, thus i do the following to make sure
cx      if(angle.lt.  0) angle=angle+360
cx      if(angle.ge.360) angle=angle-360
        if(angle.lt.0 .or. angle.gt.359.9999999999d0) angle=0
        return
        end     
 
 
 
 
        subroutine minang4( angle)
        implicit none
        real(4) angle
        if(angle.lt.-180.) angle=angle+360.
        if(angle.gt. 180.) angle=angle-360.
        return
        end
 
 
 
        subroutine minang8( angle)
        implicit none
        real(8) angle
        if(angle.lt.-180.) angle=angle+360.
        if(angle.gt. 180.) angle=angle-360.
        return
        end
