
      ! this routine extracts the necessary variables nad fields form Piepmeier's L1B SMAP TB HDF5 files
      ! and writes them out as binary arrays
      
      
!      include 'smap_id_module.f'
!      include 'smap_l1b_module.f'
      
      program mk_rss_L1A_smap
      use smap_l1b_module
      implicit none
      
      character(200) fdir,fname_in,filename_in
      character(32) aorbit
      character(200) filename_l1a
      logical(4) lexist
      
      integer(4) iasc,vernum
      character(1) casc
	  
      real(4), dimension(3, maxscan) :: scpos,scvel,scrpy,sclla
      real(4), dimension(maxcel, maxscan, nch) :: ta,ta_filtered
      integer(4), dimension(maxcel, maxscan, nch) :: tb_qual_flag
      
      
!      fdir='./TEST_FILES/'
      CALL getarg(1, filename_in)
!      filename_in = 'SMAP_L1B_TB_07531_A_20160629T113354_R13080_001.h5'
      !filename_in = 'SMAP_L1B_TB_07531_D_20160629T122309_R13080_001.h5'
      
      
!      fname_in=trim(fdir)//trim(filename_in)
      inquire(file=filename_in,exist=lexist)
      if (.not.(lexist)) then
      write(*,*) filename_in
      write(*,*) ' does not exist'
      stop
      endif

      
      scpos=-9999.
      scvel=-9999.
      scrpy=-9999.
      sclla=-9999.
      ta=-9999.
      ta_filtered=-9999.
      
      
	  
      call read_smap_l1b(0,filename_in)
      write(*,*) 'HDF5 interface activated'
      
      
      casc=filename_in(19:19)
      if (casc.eq.'A') then
        iasc=1
      elseif (casc.eq.'D') then
        iasc=2
      else
        write(*,*) 'In mk_rss_L1A_smap: Misread of filename: '//trim(filename_in)
        stop
      endif
         
      read(filename_in(38:42),*) vernum
      
      call read_smap_l1b(1,filename_in)
      write(*,*) 'Opened/Read/Closed file: '//filename_in
	  
      scpos(1,1:numscans)=x_pos(1:numscans)
      scpos(2,1:numscans)=y_pos(1:numscans)
      scpos(3,1:numscans)=z_pos(1:numscans)
	  
      scvel(1,1:numscans)=x_vel(1:numscans)
      scvel(2,1:numscans)=y_vel(1:numscans)
      scvel(3,1:numscans)=z_vel(1:numscans)
	  
      scrpy(1,1:numscans)=roll(1:numscans)
      scrpy(2,1:numscans)=pitch(1:numscans)
      scrpy(3,1:numscans)=yaw(1:numscans)
	  
      sclla(1,1:numscans)=sc_nadir_lat(1:numscans)
      sclla(2,1:numscans)=sc_nadir_lon(1:numscans)
      sclla(3,1:numscans)=sc_geodetic_alt_ellipsoid(1:numscans)
	  
      ta(1:ncel,1:numscans,1)=ta_v(1:ncel,1:numscans)
      ta(1:ncel,1:numscans,2)=ta_h(1:ncel,1:numscans)
      ta(1:ncel,1:numscans,3)=ta_3(1:ncel,1:numscans)
      ta(1:ncel,1:numscans,4)=ta_4(1:ncel,1:numscans)
         
      ta_filtered(1:ncel,1:numscans,1)=ta_filtered_v(1:ncel,1:numscans)
      ta_filtered(1:ncel,1:numscans,2)=ta_filtered_h(1:ncel,1:numscans)
      ta_filtered(1:ncel,1:numscans,3)=ta_filtered_3(1:ncel,1:numscans)
      ta_filtered(1:ncel,1:numscans,4)=ta_filtered_4(1:ncel,1:numscans)
         
      tb_qual_flag(1:ncel,1:numscans,1)=tb_qual_flag_v(1:ncel,1:numscans)
      tb_qual_flag(1:ncel,1:numscans,2)=tb_qual_flag_h(1:ncel,1:numscans)
      tb_qual_flag(1:ncel,1:numscans,3)=tb_qual_flag_3(1:ncel,1:numscans)
      tb_qual_flag(1:ncel,1:numscans,4)=tb_qual_flag_4(1:ncel,1:numscans)
	  
      ! output file
!      if(iasc.eq.1) then
!      write(aorbit,9001) revNumber
! 9001 format('r',i5.5,'a_adps.dat') 
!      else
!      write(aorbit,9002) revNumber
! 9002 format('r',i5.5,'d_adps.dat') 
!      endif
      
!      filename_l1a=trim(fdir)//aorbit
      CALL getarg(2, filename_l1a)
      open(26,file=filename_l1a,form='unformatted',access='stream',action='write')
      write(26)    revNumber,iasc,ncel,numscans,vernum, &
                   antenna_scan_time,footprints_per_scan,scpos,scvel,scrpy,sclla, &
                   tb_time_seconds,antenna_scan_angle,tb_lat,tb_lon,ta,ta_filtered, &
                   cal_loss1_reflector,cal_temp1_reflector,tb_qual_flag
      close(26)
      
      call read_smap_l1b(2,fname_in)
      write(*,*) 'HDF5 interface deactivated'
      
      write(*,*) 'normal end'
      end
      
!      include 'read_smap_l1b.f90'
	  
