c     8/13/2015 revised 8/31/2015.  0.25 is subtracted from yaw

c     revised on 8/13/2015 to flag scans that have oob alpha
      subroutine read_rss_l1a(filename_rss_l1a_asc, filename_rss_l1a_dsc, start_time)
      use l2_module                                                                                              
      implicit none
        
      integer(4), parameter :: nscans=1000  !size of rss_l1a arrays 
      real(4), parameter :: scan_period0=4.1097  !nominal scan period
      real(4), parameter :: alpha_step0=1.5      !nominal alpha step
      
      
      real(8), parameter :: d_time=4.d0  !arbitary, could have be 1 sec
c      integer(4), parameter :: maxcelx=maxcel+10

      integer(1), dimension(       maxscan)   :: iasc_scanz
      integer(4), dimension(       maxscan)   :: numcelz
      real(8),    dimension(       maxscan)   :: utc_2000z
      real(4),    dimension(     3,maxscan)   :: scposz,scvelz,scrpyz,scloc_jplz
      real(8),    dimension(maxcel,maxscan)   :: time_obsz
      real(4),    dimension(maxcel,maxscan)   :: alpha_inz,xlat_jplz,xlon_jplz
      real(4),    dimension(maxcel,maxscan,4) :: taz,tfz
      real(4),    dimension(     2,maxscan)   :: ant_lossz,ant_tempz
      integer(4), dimension(maxcel,maxscan,4) :: iflag_qcz

      
      integer(4) iorbit_file,iexist,ibad
      real(8) start_time
        
      character(120) filename_rss_l1a_asc, filename_rss_l1a_dsc
        
      integer(4) iexist_asc,iexist_dsc,numscan2
      integer(4) iasc_file,iasc,iend,iwrite 
      integer(4) numcel0,numscan0
      integer(4) iscan,icel,jscan,kscan,iscan_dsc
      integer(4) ncell,nstep
        
      real(8) scpos0(3),scvel0(3)
      real(8) ut1_2000,rotangle,days,np(3,3),np_inv(3,3),det 
      real(8) scposx(3),rotanglex
      
      real(4) d_alpha

      real(8) time0,timex,dtime
      
      real(8) asum(0:1),amin,amax


      integer(4) istokes, ibitsx(16,4)
        
c     ===========================================================================================================
c     ============================ see if both asc and dsc input files exists ===================================       
c     ===========================================================================================================
!      call get_smap_rss_l1a_filename(iorbit_file,1, filename_rss_l1a,iexist_asc) 
      iasc_file = 1

      iexist_asc = 1
      iexist_dsc = 1

 10   continue      
        
      open(3,file=filename_rss_l1a_asc,form='unformatted',access='stream',status='old',action='read')

c     ===========================================================================================================
c     ==================================== read in data from first file =========================================       
c     ===========================================================================================================
      read(3) iorbit,iasc,numcel0,numscan0,vernum
        
!      if(iorbit.ne.iorbit_file .or. iasc.ne.iasc_file)  stop 'error in asc iorbit, pgm stopped'
      if(numscan0.lt.1 .or. numscan0.gt.maxscan)        stop 'asc numscan0 oob, pgm stopped'
      if( numcel0.lt.1 .or.  numcel0.gt.maxcel)         stop 'asc numcel0  oob, pgm stopped'

c     suffix z means values read in that may need to be shifted because of time gaps
      read(3)  utc_2000z(  1:nscans)
      read(3)    numcelz(  1:nscans)
      read(3)     scposz(:,1:nscans)
      read(3)     scvelz(:,1:nscans)
      read(3)     scrpyz(:,1:nscans)
      read(3) scloc_jplz(:,1:nscans)
      read(3)  time_obsz(:,1:nscans)
      read(3)  alpha_inz(:,1:nscans)
      read(3)  xlat_jplz(:,1:nscans)
      read(3)  xlon_jplz(:,1:nscans)
      read(3)        taz(:,1:nscans,1)
      read(3)        taz(:,1:nscans,2)
      read(3)        taz(:,1:nscans,3)
      read(3)        taz(:,1:nscans,4)
      read(3)        tfz(:,1:nscans,1)
      read(3)        tfz(:,1:nscans,2)
      read(3)        tfz(:,1:nscans,3)
      read(3)        tfz(:,1:nscans,4)
      read(3)  ant_lossz(:,1:nscans)
      read(3)  ant_tempz(:,1:nscans)
      read(3)  iflag_qcz(:,1:nscans,1)
      read(3)  iflag_qcz(:,1:nscans,2)
      read(3)  iflag_qcz(:,1:nscans,3)
      read(3)  iflag_qcz(:,1:nscans,4)
      close(3)
        
      if(maxval(utc_2000z).le.0) then !no data, treat as missing file
         if(iasc_file.eq.1) iexist_asc=0
         if(iasc_file.eq.2) iexist_dsc=0
         goto 10
      endif
        

      if(utc_2000z(1).lt.0) then
         write(*,7001) iorbit
         write(7,7001) iorbit
 7001    format('first scan missing for asc orbit ', i7)
      endif
        
c     pack data, find numscan and assign iasc_scan 'first scan missing for asc orbit, pgm stopped'
      jscan=0; ibad=0; iend=0; iwrite=0
      do iscan=1,nscans
        
         if(utc_2000z(iscan).le.0 .and.jscan.ne.0) iend=1
        

         if(utc_2000z(iscan).gt.0) then
        
            if(iend.eq.1 .and. iwrite.eq.0) then
               write(*,7011) iorbit
               write(7,7011) iorbit
 7011          format('data after last data for asc ',i7)
               iwrite=1
            endif
        
            jscan=jscan+1
            utc_2000z(jscan)=utc_2000z(iscan)
        
            if(jscan.gt.1) then
               dtime=utc_2000z(jscan)-utc_2000z(jscan-1)
               nstep=nint(dtime/scan_period0)
               if(nstep.lt.  1)        ibad=1
               if(nstep.le.100 .and. abs(nstep*scan_period0-dtime).gt.0.01) ibad=1
            endif
        
            numcelz(  jscan)=  numcelz(iscan)
            scposz(:, jscan) =scposz(:,iscan)
            scvelz(:, jscan)= scvelz(:,iscan)
            scrpyz(:, jscan)= scrpyz(:,iscan)
            scloc_jplz(:,jscan)= scloc_jplz(:,iscan)
            time_obsz( :,jscan)=  time_obsz(:,iscan)
            alpha_inz( :,jscan)=  alpha_inz(:,iscan)
            xlat_jplz( :,jscan)=  xlat_jplz(:,iscan)
            xlon_jplz( :,jscan)=  xlon_jplz(:,iscan)
            taz(:,jscan,:)=             taz(:,iscan,:)
            tfz(:,jscan,:)=             tfz(:,iscan,:)
            ant_lossz(:,jscan)=   ant_lossz(:,iscan)
            ant_tempz(:,jscan)=   ant_tempz(:,iscan)
            iflag_qcz(:,jscan,:)= iflag_qcz(:,iscan,:)
            iasc_scanz(jscan)=iasc_file
         endif
      enddo                     !iscan
        
      
      if(ibad.eq.1) then
         if(iasc_file.eq.1) iexist_asc=0
         if(iasc_file.eq.2) iexist_dsc=0
         goto 10
      endif
        
        
      
      numscan=jscan
      start_time=utc_2000z(1)+ 43200.d0
        
c     ===========================================================================================================
c     ==================================== read in data from second file ========================================       
c     ===========================================================================================================
      if(iexist_asc.eq.1 .and. iexist_dsc.eq.1) then
         open(3,file=filename_rss_l1a_dsc,form='unformatted',access='stream',status='old',action='read')
!         call openbig(3,filename_rss_l1a_dsc,'old'); iasc_file=2
         iasc_file = 2
         read(3) iorbit,iasc,numcel0,numscan0,vernum
!        if(iorbit.ne.iorbit_file .or. iasc.ne.iasc_file)  stop 'error in dsc iorbit, pgm stopped'
         if(numscan0.lt.1 .or. numscan0.gt.maxscan)        stop 'dsc numscan0 oob, pgm stopped'
         if( numcel0.lt.1 .or.  numcel0.gt.maxcel)         stop 'dsc numcel0  oob, pgm stopped'
        
c     here i use module buffer (no suffix z) for temporary storage
         read(3)  utc_2000(  1:nscans)
         read(3)    numcel(  1:nscans)
         read(3)     scpos(:,1:nscans)
         read(3)     scvel(:,1:nscans)
         read(3)     scrpy(:,1:nscans)
         read(3) scloc_jpl(:,1:nscans)
         read(3)  time_obs(:,1:nscans)
         read(3)  alpha_in(:,1:nscans)
         read(3)  xlat_jpl(:,1:nscans)
         read(3)  xlon_jpl(:,1:nscans)
         read(3)        ta(:,1:nscans,1)
         read(3)        ta(:,1:nscans,2)
         read(3)        ta(:,1:nscans,3)
         read(3)        ta(:,1:nscans,4)
         read(3)        tf(:,1:nscans,1)
         read(3)        tf(:,1:nscans,2)
         read(3)        tf(:,1:nscans,3)
         read(3)        tf(:,1:nscans,4)
         read(3)  ant_loss(:,1:nscans)
         read(3)  ant_temp(:,1:nscans)
         read(3)  iflag_qc(:,1:nscans,1)
         read(3)  iflag_qc(:,1:nscans,2)
         read(3)  iflag_qc(:,1:nscans,3)
         read(3)  iflag_qc(:,1:nscans,4)
         close(3)

         if(maxval(utc_2000).le.0) goto 100 !no data
        
         if(utc_2000(1).lt.0) then
            write(*,7002) iorbit
            write(7,7002) iorbit
 7002       format('first scan missing for dsc orbit ', i7)
         endif

c     pack data, find numscan2
         jscan=0; ibad=0; iend=0; iwrite=0
         do iscan=1,nscans

            if(utc_2000(iscan).le.0 .and.jscan.ne.0) iend=1
        
            if(utc_2000(iscan).gt.0) then
        
               if(iend.eq.1 .and. iwrite.eq.0) then
                  write(*,7012) iorbit
                  write(7,7012) iorbit
 7012             format('data after last data for dsc ',i7)
                  iwrite=1
               endif

               jscan=jscan+1
               utc_2000(jscan)=utc_2000(iscan)
        
               if(jscan.gt.1) then
                  dtime=utc_2000(jscan)-utc_2000(jscan-1)
                  nstep=nint(dtime/scan_period0)
                  if(nstep.lt.  1)                                             ibad=1
                  if(nstep.le.100 .and. abs(nstep*scan_period0-dtime).gt.0.01) ibad=1
               endif
        
               numcel(  jscan)=  numcel(iscan)
               scpos(:, jscan) =scpos(:,iscan)
               scvel(:, jscan)= scvel(:,iscan)
               scrpy(:, jscan)= scrpy(:,iscan)
               scloc_jpl(:,jscan)= scloc_jpl(:,iscan)
        time_obs( :,jscan)=  time_obs(:,iscan)
        alpha_in( :,jscan)=  alpha_in(:,iscan)
        xlat_jpl( :,jscan)=  xlat_jpl(:,iscan)
        xlon_jpl( :,jscan)=  xlon_jpl(:,iscan)
        ta(:,jscan,:)=             ta(:,iscan,:)
        tf(:,jscan,:)=             tf(:,iscan,:)
        ant_loss(:,jscan)=   ant_loss(:,iscan)
        ant_temp(:,jscan)=   ant_temp(:,iscan)
        iflag_qc(:,jscan,:)= iflag_qc(:,iscan,:)
      endif
      enddo                     !iscan
        
      if(ibad.eq.1) goto 100    !no data
        
      numscan2=jscan

        
c     ===========================================================================================================
c     ======================================== search for overlapping scan ======================================       
c     ===========================================================================================================
      iscan_dsc=0
      do iscan=1,numscan
         if(utc_2000z(iscan).le.0) stop 'error1 with asc utc_2000, pgm stopped'
         if(abs(utc_2000z(iscan)-utc_2000(1)).lt.0.01) iscan_dsc=iscan
      enddo                     !iscan
        
      if(iscan_dsc.eq.0) then

         if(utc_2000(1).le.utc_2000z(numscan)) then !there is indeed an overlap
            write(*,7021) iorbit,utc_2000(1),utc_2000z(numscan)
            write(7,7021) iorbit,utc_2000(1),utc_2000z(numscan)
 7021       format('no matching scans in overlap area, pgm stopped ', i7, 2f16.3)
            stop

         else
            iscan_dsc=numscan+1 !there is a gap between asc and dsc
         endif
      endif




c     ===========================================================================================================
c     ================================== move dsc data into z buffers ===========================================       
c     ===========================================================================================================
      do iscan=1,numscan2
         jscan=iscan_dsc + iscan-1 
         numscan=jscan
         if(numscan.gt.maxscan)  stop 'numscan.gt.maxscan, pgm stopped'
         utc_2000z(jscan)=utc_2000(iscan)
         numcelz(  jscan)=  numcel(iscan)
         scposz(:, jscan) =scpos(:,iscan)
         scvelz(:, jscan)= scvel(:,iscan)
         scrpyz(:, jscan)= scrpy(:,iscan)
         scloc_jplz(:,jscan)= scloc_jpl(:,iscan)
         time_obsz( :,jscan)=  time_obs(:,iscan)
         alpha_inz( :,jscan)=  alpha_in(:,iscan)
         xlat_jplz( :,jscan)=  xlat_jpl(:,iscan)
         xlon_jplz( :,jscan)=  xlon_jpl(:,iscan)
         taz(:,jscan,:)=             ta(:,iscan,:)
         tfz(:,jscan,:)=             tf(:,iscan,:)
         ant_lossz(:,jscan)=   ant_loss(:,iscan)
         ant_tempz(:,jscan)=   ant_temp(:,iscan)
         iflag_qcz(:,jscan,:)= iflag_qc(:,iscan,:)
         iasc_scanz(jscan)=iasc_file
      enddo                     !iscan
        
      endif


c     ===========================================================================================================
c     ============================ merging asc and dsc completed, begin processing===============================       
c     ===========================================================================================================
 100  continue
  
        
c     done using module buffers as temporary, now reinitialize to missing values to be safe     
      iflag_l0=10               !flag as missing
      utc_2000=-1.e30
      iasc_scan=0
      numcel=0
      scpos=0
      scvel=0
      scrpy=0
      scpos=0
      scloc_jpl=0
      time_obs=-1.e30
      alpha_in=0
      xlat_jpl=0
      xlon_jpl=0
      ta=0
      tf=0
      ant_loss=0
      ant_temp=0
        

c     ===========================================================================================================
c     ====================== convert time to begin jan 2000 0Z, fix greenich problem ============================       
c     ===========================================================================================================
      do iscan=1,numscan
         if(utc_2000z(iscan).le.0) stop 'error with utc_2000, pgm stopped'
         utc_2000z( iscan)=utc_2000z( iscan) + 43200.d0
      
         scrpyz(3,iscan)=scrpyz(3,iscan) - 0.25
      
         do icel=1,numcelz(iscan)
            if(time_obsz(icel,iscan).le.0) stop 'error with time_obsz, pgm stopped'
            time_obsz(icel,iscan)=time_obsz(icel,iscan) + 43200.d0
            if(abs(alpha_inz(icel,iscan)).gt.720) then
               alpha_inz(icel,iscan)=1.e30
            else
               call fixang4( alpha_inz(icel,iscan))
            endif
            call fixang4( xlon_jplz(icel,iscan))
         enddo                  !icel
      enddo                     !iscan


c     ===========================================================================================================
c     ================================ fill time gaps with blank scans ==========================================       
c     ===========================================================================================================
      jscan=0
      do iscan=1,numscan
        
         if(iscan.gt.1) then
            dtime=utc_2000z(iscan)-utc_2000z(iscan-1)
            nstep=nint(dtime/scan_period0)
        
            if(nstep.lt.1)                                               stop 'nstep.lt.1, in read_rss_l1a, pgm stopped'
            if(nstep.le.100 .and. abs(nstep*scan_period0-dtime).gt.0.01) then
               write(*,7022) iorbit,nstep,nstep*scan_period0-dtime
               write(7,7022) iorbit,nstep,nstep*scan_period0-dtime
 7022          format('nstep error, pgm stopped ',i7,i7,f10.3) 
               stop
            endif
        
            if(nstep.gt.1) then !put in zero pads
               write(*,7003) iorbit,iasc_scanz(iscan),iscan,nstep
               write(7,7003) iorbit,iasc_scanz(iscan),iscan,nstep
 7003          format('gap in orbit scans ',4i7) 
 
               do kscan=iscan,iscan+nstep-2
                  jscan=jscan+1
                  iflag_l0(jscan)=10 !flag as missing
                  utc_2000(jscan)=utc_2000z(iscan-1) + dtime*(kscan-iscan+1)/dble(nstep)
                  iasc_scan(jscan)=0
                  numcel(   jscan)=0
                  scpos(:,  jscan)=0
                  scvel(:,  jscan)=0
                  scrpy(:,  jscan)=0
                  scpos(:,  jscan)=0
                  scloc_jpl(:,jscan)=0
                  time_obs(:, jscan)=-1.e30
                  alpha_in(:, jscan)=0
                  xlat_jpl(:, jscan)=0
                  xlon_jpl(:, jscan)=0
                  ta(:,jscan,:)=0
                  tf(:,jscan,:)=0
                  ant_loss(:,jscan)=0
                  ant_temp(:,jscan)=0
                  iflag_qc(:,jscan,:)=0
               enddo
            endif
         endif
        
         jscan=jscan+1
         if(jscan.gt.maxscan) stop 'too many scans after filling in missing scans, pgm stopped'
        
         iflag_l0( jscan)=0
         utc_2000( jscan)= utc_2000z(iscan)
         iasc_scan(jscan)=iasc_scanz(iscan)
         numcel(   jscan)=   numcelz(iscan)
         scpos(:,  jscan) = scposz(:,iscan)
         scvel(:,  jscan)=  scvelz(:,iscan)
         scrpy(:,  jscan)=  scrpyz(:,iscan)
         scloc_jpl(:,jscan)= scloc_jplz(:,iscan)
         time_obs( :,jscan)=  time_obsz(:,iscan)
         alpha_in( :,jscan)=  alpha_inz(:,iscan)
         xlat_jpl( :,jscan)=  xlat_jplz(:,iscan)
         xlon_jpl( :,jscan)=  xlon_jplz(:,iscan)
         ta(:,jscan,:)=             taz(:,iscan,:)
         tf(:,jscan,:)=             tfz(:,iscan,:)
         ant_loss(:,jscan)=   ant_lossz(:,iscan)
         ant_temp(:,jscan)=   ant_tempz(:,iscan)
         iflag_qc(:,jscan,:)= iflag_qcz(:,iscan,:)
        
         do icel=1,numcel(jscan)
        
            do istokes=1,4
               call bittes(iflag_qc(icel,jscan,istokes), ibitsx(:,istokes))
               if(ibitsx(4,istokes).eq.1 .and.  nint(tf(icel,jscan,istokes)).ne.-9999) stop 'qc error1, pgm stopped' 
               if(ibitsx(4,istokes).eq.0 .and.  nint(tf(icel,jscan,istokes)).eq.-9999 .and. 
     &              nint(ta(icel,jscan,istokes)).ne.-9999)  stop 'qc error2, pgm stopped'
c      if(ibitsx(4,istokes).eq.0 .and.  nint(tf(icel,jscan,istokes)).eq.-9999) then
c      write(*,'(3i7,2f10.2,1x,16i1)') iscan,icel,istokes,ta(icel,jscan,istokes),tf(icel,jscan,istokes),ibitsx(:,istokes)
c      stop 'qc error2, pgm stopped'    
c      endif  
            enddo
        
c      if(ibitsx(4,1).eq.1)     
c      if(abs(ta(icel,jscan,1)-tf(icel,jscan,1)).gt.0.01 .and. ibitsx(3,1).eq.0)        
c       if(iscan.eq.1264) 
c       if(ta(icel,jscan,1).lt.50 .or. ta(icel,jscan,1).gt.330 .or.
c     &   tf(icel,jscan,1).lt.50 .or. tf(icel,jscan,1).gt.330)
c     &  write(*,'(3i7,8f10.1,4i8,1x,16i1)') jscan,icel,numcel(jscan),ta(icel,jscan,:),tf(icel,jscan,:),iflag_qc(icel,jscan,:),
c     &  (ibitsx(ibit,1),ibit=16,1,-1)
         enddo
        
      enddo
        
      numscan=jscan
        
        
c     ===========================================================================================================
c     ==================== find scan_period, fill in missing cells, do consistency checks  ======================       
c     ===========================================================================================================
      asum=0; amin=1.e30; amax=-1.e30
      
      do iscan=1,numscan
      
         if(iscan.eq.numscan) then
            scan_period(iscan)=utc_2000(numscan)-utc_2000(numscan-1)
         else
            scan_period(iscan)=utc_2000(iscan+1)-utc_2000(iscan)
         endif
        
c     sim data had scan period of 5.4545.  full spun up real data should be 4.1, partial spun up will be longer
c     following check provides a wide range.  Since utc time is being used, leap seconds will produce a 1 sec error
c     at some point need to convert to ut1 time
         if(abs(scan_period(iscan)-scan_period0).gt.0.1) then
            write(*,7023) iorbit,iasc_scan(iscan),iscan,numscan,scan_period(iscan)
            write(7,7023) iorbit,iasc_scan(iscan),iscan,numscan,scan_period(iscan)
 7023       format('scan_period oob, pgm stopped ',4i7,f10.4)
            stop 
         endif
        
         if(iflag_l0(iscan).eq.10) cycle !no data, just interpolated time
        
         ncell=numcel(iscan)
      
         if(ncell.gt.maxcel) stop 'numcel .gt. maxcel, pgm stopped'
     
         if(ncell.lt.230) then
            write(*,7004) iorbit,iasc_scan(iscan),iscan,numcel(iscan)
            write(7,7004) iorbit,iasc_scan(iscan),iscan,numcel(iscan)
 7004       format('small numcel ',4i7) 
            iflag_l0(iscan)=9
            cycle
         endif
    
         do icel=1,ncell
            if(alpha_in(icel,iscan).lt.0 .or. alpha_in(icel,iscan).gt.360.) iflag_l0(iscan)=8
         enddo
         if(iflag_l0(iscan).eq.8) then
            write(*,7009) iorbit,iasc_scan(iscan),iscan
            write(7,7009) iorbit,iasc_scan(iscan),iscan
 7009       format('oob alpha ',3i7) 
            cycle
         endif

         d_alpha=alpha_in(ncell,iscan)-alpha_in(1,iscan)
         if(d_alpha.lt.0) d_alpha=d_alpha+360.
         if(d_alpha.lt.0) d_alpha=d_alpha+360. !do twice to be sure
         alpha_step(iscan)=d_alpha/(ncell-1)

         if(abs(alpha_step(iscan)-alpha_step0).gt.0.1) then
            write(*,7005) iorbit,iasc_scan(iscan),iscan,alpha_step(iscan)
            write(7,7005) iorbit,iasc_scan(iscan),iscan,alpha_step(iscan)
 7005       format('oob alpha step ',3i7,f8.3)
            iflag_l0(iscan)=8
            cycle
         endif


         asum(0)=asum(0) + 1
         asum(1)=asum(1) + alpha_step(iscan)
         if(alpha_step(iscan).lt.amin) amin=alpha_step(iscan)
         if(alpha_step(iscan).gt.amax) amax=alpha_step(iscan)

        
c     check for consistency between time_obs and utc_2000
         if(alpha_in(1,iscan).eq.0) then
            d_alpha=0
         else
            d_alpha=360-alpha_in(1,iscan)
         endif
         time0=utc_2000(iscan) - scan_period(iscan)*d_alpha/360.
c     z    if(abs(time0-time_obs(1,iscan)).gt.1.e-3) then
         if(abs(time0-time_obs(1,iscan)).gt.2.e-3) then
            write(*,*) iorbit,iasc_scan(iscan),iscan
            write(*,*) scan_period(iscan)
            write(*,*) time0
            write(*,*) time_obs(1,iscan)
            write(*,7024) iorbit,iasc_scan(iscan),iscan,scan_period(iscan),d_alpha,time0-time_obs(1,iscan)
            write(7,7024) iorbit,iasc_scan(iscan),iscan,scan_period(iscan),d_alpha,time0-time_obs(1,iscan)
 7024 format('abs(time0-time_obs(1,iscan)).gt.2.e-3, pgm stopped ',i7,i3,i5,3(f20.5,1x))
      stop
      endif
      
      
c     check for consistent alpha step along single scan      
      do icel=2,ncell
         d_alpha=alpha_in(icel,iscan)-alpha_in(icel-1,iscan)
         if(d_alpha.lt.0) d_alpha=d_alpha+360
cz    if(abs(d_alpha-alpha_step(iscan)).gt.0.1) then
         if(abs(d_alpha-alpha_step(iscan)).gt.0.2) then
            write(*,7025) iorbit,iasc_scan(iscan),iscan,icel,d_alpha,alpha_step(iscan),d_alpha-alpha_step(iscan)
            write(7,7025) iorbit,iasc_scan(iscan),iscan,icel,d_alpha,alpha_step(iscan),d_alpha-alpha_step(iscan)
 7025       format('abs(d_alpha-alpha_step(iscan)).gt.0.2, pgm stopped ', i7,i3,2i5,3f20.5)
            stop
         endif
      enddo
      
      
      if(iscan.ne.numscan) then
         if(iflag_l0(iscan+1).eq.0) then
            d_alpha=alpha_in(1,iscan+1)-alpha_in(ncell,iscan)
            if(d_alpha.lt.0) d_alpha=d_alpha+360.
            if(d_alpha.lt.0) d_alpha=d_alpha+360. !do twice to be sure
            if(abs(d_alpha/alpha_step(iscan)-3.).gt.0.6) then
               write(*,7006) iorbit,iasc_scan(iscan),iscan,numcel(iscan:iscan+1),alpha_step(iscan),d_alpha,d_alpha/alpha_step(iscan)
               write(7,7006) iorbit,iasc_scan(iscan),iscan,numcel(iscan:iscan+1),alpha_step(iscan),d_alpha,d_alpha/alpha_step(iscan)
 7006          format('strange intra-scan gap ',5i7,3e25.3)
               
            endif
         endif
      endif
      
      enddo                     !iscan
      
      
c     ===========================================================================================================
c     =========================================== check time_obs  ================================================      
c     ===========================================================================================================
      do iscan=1,numscan
         if(iflag_l0(iscan).eq.10 .or. iflag_l0(iscan).eq.8) cycle !no data or oob alpha, just interpolated time
        
         do icel=2,numcel(iscan)
            d_alpha=alpha_in(icel,iscan)-alpha_in(1,iscan)
            if(d_alpha.lt.0) d_alpha=d_alpha+360.
        
            dtime=time_obs(icel,iscan)-time_obs(1,iscan)-(scan_period(iscan)/360.)*d_alpha
            if(abs(dtime).gt.0.002) then
               write(*,7008) iorbit,iasc_scan(iscan),iscan,icel,dtime
               write(7,7008) iorbit,iasc_scan(iscan),iscan,icel,dtime
 7008          format('time error 1 ', i5,i2,2i5,f20.3 )    
               iflag_l0(iscan)=7
               exit
            endif
      
            timex=time_obs(1,iscan) + (scan_period(iscan)/360.)*d_alpha
            if(abs(timex-time_obs(icel,iscan)).gt.0.002) stop 'error2 with time_obs, pgm stopped'
      
         enddo                  !icel
      enddo                     !iscan
       
        
c     =====================================================================================================
c     =============== begin special block for smap, which uses earth fixed reference system ===============     
c     ===== also this is where i putin the 0.2 roll adjustment that the sim data indicated  ===============
c     =====================================================================================================

      do iscan=1,numscan
         if(iflag_l0(iscan).eq.10) cycle !no data, just interpolated time
        
         scrpy(2,iscan)=scrpy(2,iscan) + 0.023 !determined from fine tuning to jpl lat/lon
        
c     here i set ut1 to utc. for the s/c pos and vel this does not matter because of the circular usage
c     ie.  same time is used to convert to j2000 and then back to eci and greenwich.
c     in the geoloc routine there will be a tiny error in sun lon       
         ut1_2000=utc_2000(iscan)
        
         days=ut1_2000/86400.d0 -0.5d0
         call get_gm_angle(ut1_2000,days, rotangle)
        
         call fd_precession(days, np)  
         call invert_3by3(np, np_inv,det)
         if(abs(det-1).gt.1.e-6) stop 'error in np_inv,pgm stopped'

         ut1_2000= ut1_2000 + d_time !convert from begin 93 to begin 2000
         days=ut1_2000/86400.d0 -0.5d0
         call get_gm_angle(ut1_2000,days, rotanglex)

         scpos0=scpos(:,iscan)
         scvel0=scvel(:,iscan)
         scposx=scpos0 + d_time*scvel0
        
         call convert_earthfix_to_2000(rotangle, np_inv, scpos0) 
         call convert_earthfix_to_2000(rotanglex,np_inv, scposx)
         scvel0=(scposx-scpos0)/d_time
      
         scpos(:,iscan)=scpos0
         scvel(:,iscan)=scvel0
      enddo                     !iscan

      return
      end



      subroutine convert_earthfix_to_2000(rotangle,np_inv, x)
      implicit none
      real(8) rotangle,np_inv(3,3),x(3)
      real(8) cosr,sinr,y(3)
      
      real(8) dsind, dcosd

      cosr=dcosd(rotangle)
      sinr=dsind(rotangle)

c       xlon=xlon + rotangle    !convert from earth to inertial
      y(1)=cosr*x(1) - sinr*x(2)
      y(2)=cosr*x(2) + sinr*x(1)
      y(3)=x(3)

      x=matmul(np_inv,y)        !convert eci back to j2000
      return
      end
