c     july 6 2015 changed Sept 23 2015, thomas ta oob checking added
      subroutine resample_along_scan
        use l2_module                                                                                              
      implicit none

        integer(4) iscan,icel,kalpha,ialpha1,ialpha2,i1,i2,kscan,kcel,jcel,iobs
        integer(4) ich,ichx
        integer(4) ioob

        real(4) tax(8)
      real(8) time0,time1,time2,u
      real(8) brief,a1,a2,alpha1,alpha2,da,d_alpha,xwt
        real(8) asum(0:1,8)

      iflag_rsp=1      !missing
      time_rsp=-1.e30  !missing
        ta_rsp=  -1.e30  !no good ta data
      
      do iscan=1,numscan
      if(iflag_l0(iscan).ne.0) cycle

      do icel=2,numcel(iscan)
     
      time1= time_obs(icel-1,iscan)
      alpha1=dble(alpha_in(icel-1,iscan)) !using dble avoids roundoff problema with filling same bin twice
      
      time2= time_obs(icel,iscan)
      alpha2=dble(alpha_in(icel,iscan))  !using dble avoids roundoff problema with filling same bin twice
      
      if(abs(time2-time1-scan_period(iscan)*alpha_step(iscan)/360.).gt.0.001) stop 'time2-time1 oob, pgm stopped'
      
      if(alpha2.lt.alpha1) alpha2=alpha2+360
      d_alpha=alpha2-alpha1
cz    if(abs(d_alpha-alpha_step(iscan)).gt.0.1) then
      if(abs(d_alpha-alpha_step(iscan)).gt.0.2) then
      write(*,*) d_alpha-alpha_step(iscan)
      stop 'abs(da-alpha_step(iscan)).gt.0.2, pgm stopped'
      endif
      
        ialpha1=int(alpha1)
        ialpha2=int(alpha2)
        if(ialpha1.ge.360) stop 'ialpha1.ge.360 , pgm stopped'
        if(ialpha2-ialpha1.lt.1 .or. ialpha2-ialpha1.gt.2) stop 'sampling error1, pgm stopped'
        
        
      do kalpha=ialpha1+1,ialpha2
      
        u=(kalpha-alpha1)/d_alpha
        if(u.lt.0 .or. u.gt.1) stop 'error2 in , pgm stopped'
        time0=(1-u)*time1 + u*time2
        
      kscan=-999
      if(time0.lt.utc_2000(iscan)-0.001d0) then  !when obs is close to zero round off can cause problem, 0.001 fixes this
      if(time0.ge.utc_2000(iscan)-scan_period(iscan)) kscan=iscan-1
      else
      if(time0.lt.utc_2000(iscan)+scan_period(iscan)) kscan=iscan 
      endif
      if(kscan.eq.-999) stop 'kscan not found, pgm stopped' 
      
      if(kscan.eq.0)  cycle  !throw away very first data 
      
      kcel=kalpha+1
      if(kcel.gt.360) kcel=kcel-360
      
      
      if(iflag_rsp(kcel,kscan).eq.0) then
      if(abs(time0-time_rsp( kcel,kscan)).gt.1.d-3)  stop 'resample obs already exist, pgm stopped'
      write(*,1001) iscan,icel
 1001 format('filling resample bin twice due to roundoff error ',2i5)
      endif
      
      iflag_rsp(kcel,kscan)=0
      time_rsp( kcel,kscan)=time0
        
      brief=10*u
      if(brief.gt.9.99) brief=9.99
        i1=1+brief   
        i2=i1+1      
        a1=i1-brief
        a2=1-a1
        if(i1.lt.1 .or. i2.gt.11) stop 'interpolation indices oob, pgm stopped '

      asum=0
        do iobs=1,8
        jcel=icel + iobs - 5
      if(jcel.lt.1 .or. jcel.gt.numcel(iscan)) cycle
        
        da=alpha_in(jcel,iscan)-alpha_in(icel,iscan)
        if(da.lt.-180) da=da+360
        if(da.gt. 180) da=da-360
cz      if(abs(da-alpha_step(iscan)*(iobs-5)).gt.0.1) then
        if(abs(da-alpha_step(iscan)*(iobs-5)).gt.0.2) then
        write(*,*) da-alpha_step(iscan)*(iobs-5)
        stop 'abs(da-alpha_step(iscan)*(iobs-5)).gt.0.2, pgm stopped'
        endif
        
        xwt=a1*rsp_weight_scan(iobs,i1) + a2*rsp_weight_scan(iobs,i2)
        
        do ich=1,8
        if(ich.le.4) then
        ichx=ich
        tax(ich)=ta(jcel,iscan,ichx)
        else
        ichx=ich-4
        tax(ich)=tf(jcel,iscan,ichx)
        endif
        enddo  !ich
        
        
        do ich=1,8
        if(ich.le.4) then
        ichx=ich
! JMG        call SMAP_OOB_check_ocean(tax(1:2), cellat(icel,iscan),cellon(icel,iscan), ioob)
        else
        ichx=ich-4
! JMG        call SMAP_OOB_check_ocean(tax(5:6), cellat(icel,iscan),cellon(icel,iscan), ioob)
        endif
        if(tax(ich).lt.tamin(ichx) .or. tax(ich).gt.tamax(ichx)) cycle
        if(ioob.eq.1) cycle
        asum(0,ich)=asum(0,ich) + xwt
        asum(1,ich)=asum(1,ich) + xwt*tax(ich)
        enddo  !ich
        
        
        enddo  !iobs
        
      do ich=1,8
        if(asum(0,ich).gt.0.9) ta_rsp(ich,kcel,kscan)=asum(1,ich)/asum(0,ich)
        enddo
        
        enddo  !kalpha
        
        enddo  !icel
      enddo  !iscan
        
        
        numscan=numscan-1  !throw away last part of data
        

c     =====================================================================================================
c     ========================================== verify along scan resample ===============================     
c     =====================================================================================================
        
        do kscan=1,numscan  
        if(iflag_rsp(1,kscan).eq.1) cycle
        if(abs(time_rsp(1,kscan)-utc_2000(kscan)).gt.0.001) then
        write(*,*) time_rsp(1,kscan),utc_2000(kscan),time_rsp(1,kscan)-utc_2000(kscan)
        stop 'error1 with resampled1 times, pgm stopped'
        endif
        enddo
        
        return 
        end

        
