c     april 19 2015 change july 23 2015.  minus sign appended to sunglt when sun is not visible

        subroutine smap_geolocation_target(iscan,k_dscan,itrg, 
     &    ierror,observation_time,zangx,xlat,xlon_rot,thtinc,azim, sunglt,suninc,sunazm,moonglt, galxlat,galxlon,
     &    pra,frdang,xlat_ion,xlon_ion)
        use l2_module
        implicit none
 
        integer(4) iscan,jscan,k_dscan,itrg,ierror
        real(8) observation_time,zangx,xlat,xlon_rot,thtinc,azim, sunglt,suninc,sunazm,moonglt, galxlat,galxlon, pra,frdang
      real(4) xlat_ion,xlon_ion
        
      real(8) time_since_scan_start
      real(8) rotangle,days,np(3,3),np_inv(3,3),det 
      real(8) scpos0(3),scvel0(3),rpy(3)
      real(8) scpos_j2000(3),scpos_eci(3),scpos_plumb(3)
      real(8) x_eci(3),y_eci(3),z_eci(3)
      real(8) sunvec(3),moonvec(3)
      real(8) b(3),refl(3),range,rearth
      real(4) alpha,dsdh,k_earth(3),bmag_earth(3),tec
      real(8) dorbit
      integer(4) lflag
      
      real(8)  secyr,secdy
      integer(4) lyear,idayjl,imon,idaymo

      real(8) dasind, datan2d
  
        call fd_date_2000(utc_2000(iscan),   secyr,lyear,idayjl,imon,idaymo,secdy) !lyear,idayjl need for magnetic field
        
        scpos0=scpos(:,iscan)
        scvel0=scvel(:,iscan)
      rpy=   scrpy(:,iscan)
        days=utc_2000(iscan)/86400.d0 - 0.5d0 !days essentially constant over scan and hence days, np, and np_inv need only be found once per scan
        call fd_precession(days, np)  !i do not bother doing the nutation.  

        call invert_3by3(np, np_inv,det)
        if(abs(det-1).gt.1.e-6) stop 'error in np_inv,pgm stopped'

        alpha=0.5*(itrg-1)
        time_since_scan_start=scan_period(iscan)*alpha/360.d0  + scan_period(iscan)*k_dscan/7.d0
        observation_time = utc_2000(iscan) + time_since_scan_start  
        call get_gm_angle(observation_time,days, rotangle)
        scpos_j2000 = scpos0 + time_since_scan_start*scvel0
        scpos_eci=matmul(np,scpos_j2000)
        
      call fd_scpos_plumb(re,rp,ffac,scpos_eci, scpos_plumb)
        call get_sc_axes_from_rpy(scpos_plumb,y0(:,iscan),rpy(1),rpy(2),rpy(3) ,x_eci,y_eci,z_eci)
        
c     ==============================================================================================================
c     ================================================= compute dorbit =============================================
c     ==============================================================================================================
        dorbit=scan_period(iscan)/orbit_period  !begin with default value for dorbit
        
        lflag=0
        do jscan=iscan-1,iscan+1,2
        if(jscan.lt.1 .or. jscan.gt.numscan) cycle
        if(iflag_l0(jscan).eq.0) then
        if(jscan.eq.iscan-1) dorbit=orbit(iscan)-orbit(jscan)
        if(jscan.eq.iscan+1) dorbit=orbit(jscan)-orbit(iscan)
        lflag=1
        exit
        endif
        enddo
        
        if(abs(dorbit*orbit_period-scan_period(iscan)).gt.0.05) stop 'error in dorbit in smap_geolocation_target, pgm stopped'
        
        zangx=zang(iscan) + 360.*dorbit*time_since_scan_start/scan_period(iscan)
      call fixang8(zangx)  
        
        sunvec=sund(:,iscan)
        moonvec=moond(:,iscan)           

        call fd_cell_parameters(3,re,rp,ffac,
     &                        rotangle,scpos_eci,x_eci,y_eci,z_eci,beta,alpha,sunvec,moonvec,
     &                        b,refl,xlat,xlon_rot,range,rearth,thtinc,azim,pra,suninc,sunazm,sunglt,moonglt,
     &                        dsdh, xlat_ion, xlon_ion, k_earth,ierror)

        if(ierror.ne.0) return

c     iflag_sun(iscan)=1 if sun is visible from spacecraft, otherwise it = 0
        if(iflag_sun(iscan).eq.0) sunglt=-sunglt  !sunglt is between 0 and 180, assigning minus sign means sun is not visible

        refl=matmul(np_inv,refl) !convert reflection vector back to j2000
        
c     following probably not needed.  it just protects asind
        if(refl(3).lt.-1) refl(3)=-1
        if(refl(3).gt. 1) refl(3)= 1
        
      galxlat=dasind(refl(3))                    !geocentric latitude
      galxlon=datan2d(refl(2),refl(1))
      call fixang8(galxlon)  
      
c     =========================================================================================================================================
c     ================================================== new block to compute rotation angle ==================================================
c     =========================================================================================================================================
      call fd_earth_magnetic_field(lyear,idayjl,       xlat_ion,xlon_ion, bmag_earth)  !nanotelas
cx      call fd_earth_tec_field(     lyear,idayjl,isecdy,xlat_ion,xlon_ion,   tec) !tec is in units of 1.e-16 electrons/sqmeter which is called a tecu
      tec=1
      frdang=faraday_factor*(xtec_scale*tec)*dot_product(bmag_earth,k_earth)*dsdh  !faraday rotation angle in degrees

        return
        end
