      ! updated for new L1B format by jscott on 2015.02.23
      !
      ! written by jscott on 2015.01.29

      module smap_l1b_module
      use smap_id_module
      implicit none

      integer(4), parameter :: maxscan_l1b=maxscan
      integer(4), parameter :: maxsize=2000000  !had to reduce to 2 Gb to stay within memory requirements
      integer(4), parameter :: max_node=100000
      
      integer(4) numscans  !this equals number_of_scans_in unless subsequent processing reduces it to remove bad scans
      integer(4) ncel
	  

      integer(4) revNumber
	  
      real(4) antenna_earth_azimuth(maxcel,maxscan)
      real(4) antenna_look_angle(maxcel,maxscan)
      real(4) antenna_scan_angle(maxcel,maxscan)
      real(4) antenna_sidelobe_correction_3(maxcel,maxscan)
      real(4) antenna_sidelobe_correction_4(maxcel,maxscan)
      real(4) antenna_sidelobe_correction_h(maxcel,maxscan)
      real(4) antenna_sidelobe_correction_v(maxcel,maxscan)
      real(4) atm_correction_h(maxcel,maxscan)
      real(4) atm_correction_v(maxcel,maxscan)
      real(4) atm_loss_h(maxcel,maxscan)
      real(4) atm_loss_v(maxcel,maxscan)
      real(4) earth_boresight_azimuth(maxcel,maxscan)
      real(4) earth_boresight_incidence(maxcel,maxscan)
      real(4) faraday_rotation_angle(maxcel,maxscan)
      real(4) faraday_rotation_correction_h(maxcel,maxscan)
      real(4) faraday_rotation_correction_v(maxcel,maxscan)
      real(4) galactic_direct_correction_h(maxcel,maxscan)
      real(4) galactic_direct_correction_v(maxcel,maxscan)
      real(4) galactic_reflected_correction_3(maxcel,maxscan)
      real(4) galactic_reflected_correction_4(maxcel,maxscan)
      real(4) galactic_reflected_correction_h(maxcel,maxscan)
      real(4) galactic_reflected_correction_v(maxcel,maxscan)
      real(4) lunar_direct_phi(maxcel,maxscan)
      real(4) lunar_direct_theta(maxcel,maxscan)
      real(4) lunar_specular_correction_3(maxcel,maxscan)
      real(4) lunar_specular_correction_4(maxcel,maxscan)
      real(4) lunar_specular_correction_h(maxcel,maxscan)
      real(4) lunar_specular_correction_v(maxcel,maxscan)
      real(4) lunar_specular_lat(maxcel,maxscan)
      real(4) lunar_specular_lon(maxcel,maxscan)
      real(4) lunar_specular_phi(maxcel,maxscan)
      real(4) lunar_specular_reflection_coefficient_h(maxcel,maxscan)
      real(4) lunar_specular_reflection_coefficient_v(maxcel,maxscan)
      real(4) lunar_specular_theta(maxcel,maxscan)
      real(4) nedt_3(maxcel,maxscan)
      real(4) nedt_4(maxcel,maxscan)
      real(4) nedt_h(maxcel,maxscan)
      real(4) nedt_v(maxcel,maxscan)
      real(4) polarization_rotation_angle(maxcel,maxscan)
      real(4) solar_direct_correction_h(maxcel,maxscan)
      real(4) solar_direct_correction_v(maxcel,maxscan)
      real(4) solar_direct_phi(maxcel,maxscan)
      real(4) solar_direct_theta(maxcel,maxscan)
      real(4) solar_specular_correction_3(maxcel,maxscan)
      real(4) solar_specular_correction_4(maxcel,maxscan)
      real(4) solar_specular_correction_h(maxcel,maxscan)
      real(4) solar_specular_correction_v(maxcel,maxscan)
      real(4) solar_specular_lat(maxcel,maxscan)
      real(4) solar_specular_lon(maxcel,maxscan)
      real(4) solar_specular_phi(maxcel,maxscan)
      real(4) solar_specular_reflection_coefficient_h(maxcel,maxscan)
      real(4) solar_specular_reflection_coefficient_v(maxcel,maxscan)
      real(4) solar_specular_theta(maxcel,maxscan)
      real(4) specular_declination(maxcel,maxscan)
      real(4) specular_right_ascension(maxcel,maxscan)
      real(4) surface_water_fraction_mb(maxcel,maxscan)
      real(4) ta_3(maxcel,maxscan)
      real(4) ta_4(maxcel,maxscan)
      real(4) ta_h(maxcel,maxscan)
      real(4) ta_v(maxcel,maxscan)
      real(4) ta_filtered_3(maxcel,maxscan)
      real(4) ta_filtered_4(maxcel,maxscan)
      real(4) ta_filtered_h(maxcel,maxscan)
      real(4) ta_filtered_v(maxcel,maxscan)
      real(4) tb_3(maxcel,maxscan)
      real(4) tb_4(maxcel,maxscan)
      real(4) tb_h(maxcel,maxscan)
      real(4) tb_v(maxcel,maxscan)
      real(4) tb_declination(maxcel,maxscan)
      real(4) tb_upwelling(maxcel,maxscan)
      real(4) tb_lat(maxcel,maxscan)
      real(4) tb_lon(maxcel,maxscan)
      real(4) cal_loss12_radome(2,maxscan)
      real(4) cal_loss1_reflector(2,maxscan)
      real(4) cal_loss2_feed(maxscan)
      real(4) cal_loss3_omt(2,maxscan)
      real(4) cal_loss4_coupler(2,maxscan)
      real(4) cal_loss5_diplexer(2,maxscan)
      real(4) cal_nd_phase(maxscan)
      real(4) cal_rx_phase(maxscan)
      real(4) cal_temp12_radome(maxscan)
      real(4) cal_temp1_reflector(2,maxscan)
      real(4) cal_temp2_feed(maxscan)
      real(4) cal_temp3_omt(2,maxscan)
      real(4) cal_temp4_coupler(2,maxscan)
      real(4) cal_temp5_diplexer(2,maxscan)
      real(4) cal_temp_nd(maxscan)
      real(4) cal_temp_ref(2,maxscan)
      real(4) cal_temp_xnd(maxscan)
      real(4) cal_tempref_offset(2,maxscan)
      real(4) cal_tnd(2,maxscan)
      real(4) cal_tref(2,maxscan)
      real(4) cal_txnd(2,maxscan)
      real(4) cal_xnd_phase(maxscan)
      real(4) pitch(maxscan)
      real(4) roll(maxscan)
      real(4) sc_alongtrack_velocity(maxscan)
      real(4) sc_geodetic_alt_ellipsoid(maxscan)
      real(4) sc_nadir_angle(maxscan)
      real(4) sc_nadir_lat(maxscan)
      real(4) sc_nadir_lon(maxscan)
      real(4) sc_radial_velocity(maxscan)
      real(4) x_pos(maxscan)
      real(4) x_vel(maxscan)
      real(4) y_pos(maxscan)
      real(4) y_vel(maxscan)
      real(4) yaw(maxscan)
      real(4) z_pos(maxscan)
      real(4) z_vel(maxscan)
      integer(4) tb_mode_flag(maxcel,maxscan)
      integer(4) tb_qual_flag_3(maxcel,maxscan)
      integer(4) tb_qual_flag_4(maxcel,maxscan)
      integer(4) tb_qual_flag_h(maxcel,maxscan)
      integer(4) tb_qual_flag_v(maxcel,maxscan)
      integer(4) tb_right_ascension(maxcel,maxscan)
      integer(4) antenna_scan_mode_flag(maxscan)
      integer(4) antenna_scan_qual_flag(maxscan)
      integer(4) footprints_per_scan(maxscan)
      integer(4) tbs_per_scan(maxscan)
      real(8) tb_time_seconds(maxcel,maxscan)
      real(8) antenna_scan_time(maxscan)
      character(24) tb_time_utc(maxcel,maxscan)
      character(24) antenna_scan_time_utc(maxscan)
      
      end      module smap_l1b_module
      