! TM 09/15/2015
! check SMAP TA filtered
! open ocean
! compare with average TF map 

      subroutine SMAP_OOB_check_ocean(xtf, xlat, xlon, ioob)
      implicit none

      real(4), dimension(2), intent(in)           ::  xtf ! filtered SMAP antenna temperature
                                                ! 1=v-pol    2=h-pol
      real(4), intent(in)                         ::  xlat, xlon                                                
                                       
      integer(4), intent(out)                     ::  ioob

      integer(4)                                  ::  ilat, ilon

      integer(4), save                            ::  istart=1
      integer(4), dimension(1440,720),   save     ::  nmap_oob
      real(8),    dimension(4,1440,720), save     ::  tf_map_oob, tf2_map_oob
      real(8),    dimension(  1440,720), save     ::  gland_map_oob, gice_map_oob

      character(len=200), parameter ::  oob_map_file =  '\\thomas\c\smap\l2_algo_development\maps\data\map_tf_ave_qc.dat'

      real(4), parameter                          ::  xthr = 40.0 
      ! changed from 18.0 to 40.0 on 04/09/2016 to test hurricane
      ! allow 18 K deviation from mean (hurricanes!)
      
      
      real(4), dimension(2)                       ::  dtf

      if (istart==1) then
      open(unit=3,form='unformatted',access='stream',file=oob_map_file,status='old',action='read')
      read(3) nmap_oob
      read(3) tf_map_oob
      read(3) tf2_map_oob
      read(3) gland_map_oob
      read(3) gice_map_oob
      istart=0
      endif

      ioob=0 ! default

      ilat = nint((xlat -(-89.875))*4.0) + 1
      ilon = nint((xlon -   0.125 )*4.0) + 1
      if (ilat<1)   ilat=1
      if (ilat>720) ilat=720
      if (ilon<1)   ilon=ilon+1440
      if (ilon>1440)ilon=ilon-1440


      if (nmap_oob(ilon,ilat) < 1) return ! no map entry. return with default

      if (gland_map_oob(ilon,ilat)>0.002) return ! do not check close to land
      if ( gice_map_oob(ilon,ilat)>0.001) return ! do not check close to sea ice


      dtf(1:2) = xtf(1:2) - tf_map_oob(1:2,ilon,ilat)

      if (abs(dtf(1))>xthr .or. abs(dtf(2))>xthr) ioob=1

      return
      end subroutine SMAP_OOB_check_ocean                        
