#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <string>

#define SSS_UNCERTAINTIES __sss_uncertainties_module_MOD_read_sss_uncertainties

extern "C" void SSS_UNCERTAINTIES(int32_t *iorbit, 
                                  char *l2_uncertainties_filename, 
                                  float *, double *,
                                  float *, float *, float *, float *,
                                  float *, float *, int32_t *);

extern "C" void fd_date_2000_(double *, double *, int *, int *, int *, int*,
			   double *); 

using namespace std;

int main ( int argc, char *argv[]) {

  int32_t ierror;

  float sec_of_day[5000], cellat_unc[5000][3], cellon_unc[5000][3];
  float dSSS[5000][3][20], dlambda[5000][3][20], dSSS_dlambda[5000][3][20];
  float dSSS_tot[5000][3][3];
  double time_utc_2000[5000];

  string aqpertFile;
  aqpertFile = basename( argv[1]);

  int32_t orbitNumber = atoi(aqpertFile.substr(8,6).c_str());

  SSS_UNCERTAINTIES(&orbitNumber, argv[1],
                    &sec_of_day[0], &time_utc_2000[0],
                    &cellat_unc[0][0], &cellon_unc[0][0],
                    &dSSS[0][0][0], &dlambda[0][0][0], &dSSS_dlambda[0][0][0],
                    &dSSS_tot[0][0][0], &ierror);

  int lyear, idayjl, isecdy, idum, imon, idom;
  float lsecdy=-1;
  double secdy, dumd;
  char datetimestr[35], databuf[1024];
  for (int i=0; i<5000; i++) {
    fd_date_2000_(&time_utc_2000[i], &dumd, &lyear, &idum, 
                  &imon, &idom, &secdy);

    if (time_utc_2000[i] < -9000) 
      break;

    int16_t hr, mn, sc;
    hr = (int) (secdy / 3600);
    mn = (int) ((secdy - hr*3600) / 60);
    sc = (int) (secdy - hr*3600 - mn*60);

    sprintf(datetimestr, "%04d-%02d-%02dT%02d:%02d:%02d", 
            lyear, imon, idom, hr, mn, sc);
    if (i == 0) {
      cout << "start_time=" << datetimestr << endl;
    }
  }

  cout << "stop_time=" << datetimestr << endl;

  return 0;
}

