C--$Header: /u/caretr2/scatsim/CVSROOT/L1A_to_L2/L1A_load_RFI_flags.f,v 1.4 2011/08/29 19:03:03 fore Exp $
c*****************************************************************      
      subroutine L1A_load_RFI_flags( L1A_HDF_file, RFI_FLAGS_VPOL,
     $ RFI_FLAGS_HPOL )
c*****************************************************************      
c**   
c**   FILE NAME: L1A_load_RFI_flags.f
c**   
c**   DATE WRITTEN: 8/13/2009
c**   
c**   PROGRAMMER:
c**   
c**   FUNCTIONAL DESCRIPTION:  
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**     
c*****************************************************************   
      implicit none
      include 'L1A.inc'
c     PARAMETER STATEMENTS
c     INPUT VARIABLES
      character*320 L1A_HDF_file

c     OUTPUT VARIABLES
      integer*1 RFI_FLAGS_VPOL(3,8,MAX_NUM_BLOCKS) ! set to 1 if RFI, 0 if no RFI
      integer*1 RFI_FLAGS_HPOL(3,8,MAX_NUM_BLOCKS) ! set to 1 if RFI, 0 if no RFI

c     LOCAL VARIABLES

c     L1A Attributes
      integer NUM_XYZ_EMPH
      integer NUM_ATT_EMPH
      integer NUM_BLOCKS      
      real*8  blk_sec( MAX_NUM_BLOCKS )

c     L1A RFI
      integer*1 scatter_headers(8,MAX_NUM_BLOCKS)
      integer*1     scatter_rfi(4,MAX_NUM_BLOCKS)
      
      integer i_beam
      integer i_seq
      integer i_block
      integer lnblnk

      integer ierr
c     DATA STATEMENTS
c     COMMON BLOCKS
c     FUNCTION STATEMENTS
c     PROCESSING STEPS
      
      ierr = L1A_HDF5_get_sizes( NUM_BLOCKS, 
     $                           NUM_XYZ_EMPH, 
     $                           NUM_ATT_EMPH, 
     $                           L1A_HDF_file( 1:lnblnk(L1A_HDF_file) ) // char(0) )
      if(ierr.lt.0) write(6,*) 'L1A_load_RFI_flags: ERROR: L1A_HDF5_get_sizes returned: ', ierr      
      
      ierr = L1A_HDF5_get_RFI( scatter_headers, 
     $                         scatter_rfi,
     $                         L1A_HDF_file( 1:lnblnk(L1A_HDF_file) ) // char(0) )
      if(ierr.lt.0) write(6,*) 'L1A_load_RFI_flags: ERROR: L1A_HDF5_get_RFI returned: ', ierr
      
      do i_block = 1, NUM_BLOCKS
        ! replace z"AD" with -83 due to the lack of unsigned int types in F77
        ! 8/29/2011 AGF
        if( scatter_rfi(1,i_block) .eq. -83 )then ! FSW patch installed
          !write(6,*) 'RFI PATCH INSTALLED', scatter_rfi(1,i_block)
          do i_seq = 1, 8
            do i_beam = 1, 3

C--Most significant bit (bit 7) is sequence 1, least sig. bit (bit 0) is seq. 8
C--as per AQ-385-0262C_D-29915C_HR.xls
              if( btest( scatter_rfi(i_beam+1,i_block), 8-i_seq ) )then
                RFI_FLAGS_HPOL(i_beam,i_seq,i_block) = 1
              else
                RFI_FLAGS_HPOL(i_beam,i_seq,i_block) = 0
              endif
              
              if( btest( scatter_headers(i_seq,i_block), 7-i_beam ) )then
                RFI_FLAGS_VPOL(i_beam,i_seq,i_block) = 1
              else
                RFI_FLAGS_VPOL(i_beam,i_seq,i_block) = 0
              endif
              
            enddo
          enddo
          
C--If FSW patch not installed, then the bits in the headers are for
C--H and V pol RFI flagging (as per AQ-385-0262C_D-29915C_HR.xls)
        else
          !write(6,*) 'RFI PATCH NOT INSTALLED', scatter_rfi(1,i_block)  
          do i_seq = 1, 8
            do i_beam = 1, 3
              if( btest( scatter_headers(i_seq,i_block), 7-i_beam ) )then
                RFI_FLAGS_HPOL(i_beam,i_seq,i_block) = 1
                RFI_FLAGS_VPOL(i_beam,i_seq,i_block) = 1
              else
                RFI_FLAGS_HPOL(i_beam,i_seq,i_block) = 0
                RFI_FLAGS_VPOL(i_beam,i_seq,i_block) = 0
              endif
            enddo
          enddo        
        endif
        
      enddo
      end
