C--$Header: /mnt/caretr2/scatsim/CVSROOT/L1A_to_L2/L1B.inc,v 1.8 2009/10/16 14:57:21 fore Exp $
C-------------------------------------------------------------------------
C     L1B include file:
C     Includes declarations of variables used to flag L1B data.
C     Also includes the definitions of which bits mean what
C     Any subroutines needing this data can include this source file...
C-------------------------------------------------------------------------
C--Consistent with version 2, dated 8/7/2009 "Scatterometer Quality Flags.doc"
C--Updated 9/15/2009 as discussed with APF.
      integer*2 L1B_QF_BAD_DATA              /z"8000"/ ! bit 15 (most-significant-bit)
      integer*2 L1B_QF_BAD_CAL               /z"4000"/ ! bit 14
      integer*2 L1B_QF_BAD_TIME_TAG          /z"2000"/ ! bit 13
      integer*2 L1B_QF_GEOLOCATION_ERROR     /z"1000"/ ! bit 12
      integer*2 L1B_QF_HARDWARE_PROBLEM      /z"0C00"/ ! bits 10 and 11
      integer*2 L1B_QF_LAND_ICE              /z"0200"/ ! bit 9
      integer*2 L1B_QF_NEGATIVE_SIGMA0       /z"0100"/ ! bit 8
      integer*2 L1B_QF_HIGH_BACKSCATTER      /z"0080"/ ! bit 7
      integer*2 L1B_QF_RFI                   /z"0060"/ ! bit 5 and 6
      integer*2 L1B_QF_POINTING_ERROR        /z"0010"/ ! bit 4
      integer*2 L1B_QF_BEAM_OFF_EARTH        /z"0008"/ ! bit 3
      integer*2 L1B_QF_CAL_LEVEL             /z"0006"/ ! bit 1 and 2
      integer*2 L1B_QF_ANOMALOUS_TEMPS       /z"0001"/ ! bit 0
      
C--Other helper macros for the multi-bit flags
      integer*2 L1B_QF_CAL_LEVEL_1           /z"0002"/ ! just bit 1
      integer*2 L1B_QF_CAL_LEVEL_2           /z"0004"/ ! just bit 2
      integer*2 L1B_QF_CAL_LEVEL_3           /z"0006"/ ! both bits 1 and 2
      
      integer*2 L1B_QF_RFI_none               /z"0000"/ ! both 5 and 6 unset
      integer*2 L1B_QF_RFI_instr_only         /z"0020"/ ! just bit 5
      integer*2 L1B_QF_RFI_outlier_only       /z"0040"/ ! just bit 6
      integer*2 L1B_QF_RFI_instr_and_outlier  /z"0060"/ ! both bits 5 and 6

      integer*2 L1B_QF_HARDWARE_PROBLEM_SCAT  /z"0400"/ ! bit 10
      integer*2 L1B_QF_HARDWARE_PROBLEM_OTHER /z"0800"/ ! bit 11
      integer*2 L1B_QF_HARDWARE_PROBLEM_BOTH  /z"0C00"/ ! both bits 10 and 11
      
C--To test a flag:
C   if( L1B_test_flag( L1B_flag, flag_mask, flag_value )
C
C--To test what cal level we used do: iand( L1B_quality_flag, L1B_QF_CAL_LEVEL )
C
C--To set flag_mask bits to the value flag_value, do:
C-- L1B_set_flag( L1B_flag, flag_mask, flag_value )

C--To clear all bits that are 1 in flag_mask, do:
C- L1B_clear_flag( L1B_flag, flag_mask )


C-------------------------------------------------------------------------
C
C All of the below variables should be read in from the file "L1B_limits_MM-DD-YYYY.txt"
C  at runtime via subroutine: L1B_read_limits
C
C-------------------------------------------------------------------------

      real*8 SC_LVPS_BOX_TEMP_limits(2)
      real*8 SC_SSPA_RF_DCK_TMP_limits(2)
      real*8 SC_SCG_TMP_limits(2)
      real*8 SC_SBE_LNA_TMP_limits(2)
      real*8 SC_SBE_TX_CHN_TMP_limits(2)
      real*8 SC_SBE_RX_CHN_TMP_limits(2)
      real*8 SC_SFE_TX_LOAD_TMP_limits(2)
      real*8 SC_SBE_STP_ATTEN_TMP_limits(2)
      real*8 SC_SFE_LBK_ATTEN_TMP_limits(2)
      real*8 SC_SFE_LBK_SW_TMP_limits(2)
      real*8 SC_SFE_BM_SW_TMP_limits(2)
      real*8 SC_SFE_GND_MON_limits(2)
      real*8 SC_SFE_N15_VLT_MON_limits(2)
      real*8 SC_SBE_PLM1_TUNG_VLT_limits(2)
      real*8 SC_SBE_PLM2_TUNG_VLT_limits(2)
      real*8 SC_8MHZ_STLO_OUT_PWR_LVL_limits(2)
      real*8 SC_16MHZ_PWR_LVL_limits(2)
      real*8 SC_SBE_PLM1_PWR_LVL_limits(2)
      real*8 SC_SBE_PLM2_PWR_LVL_limits(2)
      real*8 SC_SBE_TX_EXCTR_PWR_MON_limits(2)
      real*8 SC_LVPS_CNVRTR_CURR_limits(2)
      real*8 SC_SSPA_OUTPT_STG_VLT_limits(2)
      real*8 SC_SSPA_INTRM_STG_VLT_limits(2)
      real*8 SC_SSPA_INPT_STG_VLT_limits(2)
      real*8 SC_SFE_P5V_MON_limits(2)
      real*8 SC_SCG_P5V_MON_limits(2)
      real*8 SC_SBE_P5V_MON_limits(2)
      real*8 SC_SBE_P12V_NSW_MON_limits(2)
      real*8 SC_STS_FIFO_ERR_limits(2)
      real*8 SC_STS_SCAT_LVPS_OVR_CUR_limits(2)
      real*8 SC_STS_SCAT_LVPS_BUS_VLT_limits(2)
      real*8 SC_STS_CG_LTCH_PRM_limits(2)
      real*8 SC_STS_CG_LTCH_RED_limits(2)
      real*8 ET_OMT1_H_PROBE_TMP_limits(2)
      real*8 ET_OMT1_V_PROBE_TMP_limits(2)
      real*8 ET_OMT2_H_PROBE_TMP_limits(2)
      real*8 ET_OMT2_V_PROBE_TMP_limits(2)
      real*8 ET_OMT3_H_PROBE_TMP_limits(2)
      real*8 ET_OMT3_V_PROBE_TMP_limits(2)
      real*8 ET_DPLX_1H_TMP_limits(2)
      real*8 ET_DPLX_1V_TMP_limits(2)
      real*8 ET_DPLX_2H_TMP_limits(2)
      real*8 ET_DPLX_2V_TMP_limits(2)
      real*8 ET_DPLX_3H_TMP_limits(2)
      real*8 ET_DPLX_3V_TMP_limits(2)
      real*8 ET_CPLR_1H_TMP_limits(2)
      real*8 ET_CPLR_1V_TMP_limits(2)
      real*8 ET_CPLR_2H_TMP_limits(2)
      real*8 ET_CPLR_2V_TMP_limits(2)
      real*8 ET_CPLR_3H_TMP_limits(2)
      real*8 ET_CPLR_3V_TMP_limits(2)
      real*8 ET_SFE_H1_COAX_TMP_limits(2)
      real*8 ET_SFE_H2_COAX_TMP_limits(2)
      real*8 ET_SFE_H3_COAX_TMP_limits(2)
      real*8 ET_SFE_V1_COAX_TMP_limits(2)
      real*8 ET_SFE_V2_COAX_TMP_limits(2)
      real*8 ET_SFE_V3_COAX_TMP_limits(2)
      real*8 IE_ICDS_TLM_CAL_RES1_limits(2)
      real*8 IE_ICDS_TLM_CAL_RES2_limits(2)
      real*8 IE_ICDS_TLM_CAL_RES3_limits(2)
      real*8 IE_ICDS_TLM_CAL_RES4_limits(2)

      real*8 LB_PWR_limits(2,4,3)
      
      real*8 ECHO_PWR_limits(2,4,3)
      real*8 NOISE_PWR_limits(2,2,3)
      real*8 CND_PWR_limits(2,3)
      real*8 Gain_limits(2,3)
      real*8 LOOK_ANGLE_limits(2,3)
      real*8 LAND_FRACTION_limits(2)
      real*8 ICE_FRACTION_limits(2)
      real*8 TIME_TAG_ERROR_limits(2)

      
      common /L1B_limits/ SC_LVPS_BOX_TEMP_limits,
     $                    SC_SSPA_RF_DCK_TMP_limits,
     $                    SC_SCG_TMP_limits,
     $                    SC_SBE_LNA_TMP_limits,
     $                    SC_SBE_TX_CHN_TMP_limits,
     $                    SC_SBE_RX_CHN_TMP_limits,
     $                    SC_SFE_TX_LOAD_TMP_limits,
     $                    SC_SBE_STP_ATTEN_TMP_limits,
     $                    SC_SFE_LBK_ATTEN_TMP_limits,
     $                    SC_SFE_LBK_SW_TMP_limits,
     $                    SC_SFE_BM_SW_TMP_limits,
     $                    SC_SFE_GND_MON_limits,
     $                    SC_SFE_N15_VLT_MON_limits,
     $                    SC_SBE_PLM1_TUNG_VLT_limits,
     $                    SC_SBE_PLM2_TUNG_VLT_limits,
     $                    SC_8MHZ_STLO_OUT_PWR_LVL_limits,
     $                    SC_16MHZ_PWR_LVL_limits,
     $                    SC_SBE_PLM1_PWR_LVL_limits,
     $                    SC_SBE_PLM2_PWR_LVL_limits,
     $                    SC_SBE_TX_EXCTR_PWR_MON_limits,
     $                    SC_LVPS_CNVRTR_CURR_limits,
     $                    SC_SSPA_OUTPT_STG_VLT_limits,
     $                    SC_SSPA_INTRM_STG_VLT_limits,
     $                    SC_SSPA_INPT_STG_VLT_limits,
     $                    SC_SFE_P5V_MON_limits,
     $                    SC_SCG_P5V_MON_limits,
     $                    SC_SBE_P5V_MON_limits,
     $                    SC_SBE_P12V_NSW_MON_limits,
     $                    SC_STS_FIFO_ERR_limits,
     $                    SC_STS_SCAT_LVPS_OVR_CUR_limits,
     $                    SC_STS_SCAT_LVPS_BUS_VLT_limits,
     $                    SC_STS_CG_LTCH_PRM_limits,
     $                    SC_STS_CG_LTCH_RED_limits,
     $                    ET_OMT1_H_PROBE_TMP_limits,
     $                    ET_OMT1_V_PROBE_TMP_limits,
     $                    ET_OMT2_H_PROBE_TMP_limits,
     $                    ET_OMT2_V_PROBE_TMP_limits,
     $                    ET_OMT3_H_PROBE_TMP_limits,
     $                    ET_OMT3_V_PROBE_TMP_limits,
     $                    ET_DPLX_1H_TMP_limits,
     $                    ET_DPLX_1V_TMP_limits,
     $                    ET_DPLX_2H_TMP_limits,
     $                    ET_DPLX_2V_TMP_limits,
     $                    ET_DPLX_3H_TMP_limits,
     $                    ET_DPLX_3V_TMP_limits,
     $                    ET_CPLR_1H_TMP_limits,
     $                    ET_CPLR_1V_TMP_limits,
     $                    ET_CPLR_2H_TMP_limits,
     $                    ET_CPLR_2V_TMP_limits,
     $                    ET_CPLR_3H_TMP_limits,
     $                    ET_CPLR_3V_TMP_limits,
     $                    ET_SFE_H1_COAX_TMP_limits,
     $                    ET_SFE_H2_COAX_TMP_limits,
     $                    ET_SFE_H3_COAX_TMP_limits,
     $                    ET_SFE_V1_COAX_TMP_limits,
     $                    ET_SFE_V2_COAX_TMP_limits,
     $                    ET_SFE_V3_COAX_TMP_limits,
     $                    IE_ICDS_TLM_CAL_RES1_limits,
     $                    IE_ICDS_TLM_CAL_RES2_limits,
     $                    IE_ICDS_TLM_CAL_RES3_limits,
     $                    IE_ICDS_TLM_CAL_RES4_limits,
     $                    LB_PWR_limits,
     $                    ECHO_PWR_limits,
     $                    NOISE_PWR_limits,
     $                    CND_PWR_limits,
     $                    Gain_limits,
     $                    LOOK_ANGLE_limits,
     $                    LAND_FRACTION_limits,
     $                    ICE_FRACTION_limits,
     $                    TIME_TAG_ERROR_limits