C--$Header: /mnt/caretr2/scatsim/CVSROOT/L1A_to_L2/L1B_load_housekeeping.f,v 1.2 2009/10/05 14:30:08 fore Exp $
c*****************************************************************      
      subroutine L1B_load_housekeeping( i_block,
     $                                  external_temperatures_eu,
     $                                  scat_telemetry_eu,
     $                                  L1B_housekeeping )
c*****************************************************************      
c**   
c**   FILE NAME: L1B_load_housekeeping.f
c**   
c**   DATE WRITTEN: 8/17/2009
c**   
c**   PROGRAMMER: Alex Fore
c**   
c**   FUNCTIONAL DESCRIPTION:  Populates the L1B_housekeeping array
c**    from the converted L0 telemetry arrays.
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**     
c*****************************************************************   
      implicit none
      include 'L1A.inc'
c     PARAMETER STATEMENTS
c     INPUT VARIABLES
      integer   i_block
      real*4    external_temperatures_eu(      38, MAX_NUM_BLOCKS )
      real*4    scat_telemetry_eu(             38, MAX_NUM_BLOCKS )
      
c     OUTPUT VARIABLES
      real*4    L1B_housekeeping(35)
      
c     LOCAL VARIABLES
      integer ii
c     DATA STATEMENTS
c     COMMON BLOCKS
c     FUNCTION STATEMENTS
c     PROCESSING STEPS
      
      L1B_housekeeping( 1 ) = scat_telemetry_eu( 18, i_block ) ! SC_SBE_STP_ATTEN_TMP
      L1B_housekeeping( 2 ) = scat_telemetry_eu( 19, i_block ) ! SC_SFE_LBK_ATTEN_TMP
      L1B_housekeeping( 3 ) = scat_telemetry_eu( 20, i_block ) ! SC_SFE_LBK_SW_TMP
      L1B_housekeeping( 4 ) = scat_telemetry_eu( 21, i_block ) ! SC_SFE_BM_SW_TMP
      
      do ii=1,6 ! OMT probe temp (1H,1V,2H,2V,3H,3V)
        L1B_housekeeping( 4+ii ) = external_temperatures_eu( ii, i_block )
      enddo

      do ii=1,6 ! diplexer (1H,1V,2H,2V,3H,3V)
        L1B_housekeeping( 10+ii ) = external_temperatures_eu( 12+ii, i_block )
      enddo
      
      do ii=1,6 ! coupler (1H,1V,2H,2V,3H,3V)
        L1B_housekeeping( 16+ii ) = external_temperatures_eu( 18+ii, i_block )
      enddo
      
      L1B_housekeeping( 23 ) = scat_telemetry_eu( 11, i_block ) ! SC_LVPS_BOX_TEMP
      L1B_housekeeping( 24 ) = scat_telemetry_eu( 12, i_block ) ! SC_SSPA_RF_DCK_TMP
      L1B_housekeeping( 25 ) = scat_telemetry_eu( 13, i_block ) ! SC_SCG_TMP
      L1B_housekeeping( 26 ) = scat_telemetry_eu( 14, i_block ) ! SC_SBE_LNA_TMP
      L1B_housekeeping( 27 ) = scat_telemetry_eu( 15, i_block ) ! SC_SBE_TX_CHN_TMP
      L1B_housekeeping( 28 ) = scat_telemetry_eu( 16, i_block ) ! SC_SBE_RX_CHN_TMP
      L1B_housekeeping( 29 ) = scat_telemetry_eu( 17, i_block ) ! SC_SFE_TX_LOAD_TMP
      
      do ii=1,6 ! diplexer to SFE coax (H1,H2,H3,V1,V2,V3)
        L1B_housekeeping(29+ii) = external_temperatures_eu( ii+6, i_block )
      enddo
      end