C--$Header: /u/caretr2/scatsim/CVSROOT/L1A_to_L2/L1B_populate_output_buffer.f,v 1.5 2011/10/17 12:38:43 fore Exp $
c*****************************************************************      
      subroutine L1B_populate_output_buffer( i_block,
     $                                       block_start,
     $                                       NUM_BLOCKS,
     $                                       L1B_time, 
     $                                       L1B_xyz_mj2k, 
     $                                       L1B_vxyz_mj2k,
     $                                       L1B_roll,
     $                                       L1B_pitch,
     $                                       L1B_yaw,
     $                                       L1B_KPC,
     $                                       L1B_SNR,
     $                                       L1B_Noise,
     $                                       L1B_Noise_Pwr,
     $                                       L1B_sig0,
     $                                       L1B_lat_echo_center,
     $                                       L1B_lon_echo_center,
     $                                       L1B_lat_beam_edge,
     $                                       L1B_lon_beam_edge,
     $                                       L1B_ant_azi_rel_north,
     $                                       L1B_pol_roll_angle,
     $                                       L1B_inc_angle,
     $                                       L1B_land_fraction,
     $                                       L1B_ice_fraction,     
     $                                       L1B_housekeeping,
     $                                       L1B_quality_flag,
     $                                       L2_prefix )
c*****************************************************************      
c**   
c**   FILE NAME:
c**   
c**   DATE WRITTEN:
c**   
c**   PROGRAMMER:
c**   
c**   FUNCTIONAL DESCRIPTION:  
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**     
c*****************************************************************   
      implicit none
      include 'L1A.inc'
c     PARAMETER STATEMENTS
c     INPUT VARIABLES
      integer   i_block
      integer   block_start
      integer   NUM_BLOCKS
C--Populated block by block for L1A -> L1B
      real*8    L1B_time
      real*8    L1B_xyz_mj2k(3)
      real*8    L1B_vxyz_mj2k(3)
      real*8    L1B_roll
      real*8    L1B_pitch
      real*8    L1B_yaw
      real*8    L1B_KPC(4,3,8)
      real*8    L1B_SNR(4,3,8)
      real*8    L1B_Noise(2,3,8)
      real*8    L1B_Noise_Pwr(2,3,8)
      real*8    L1B_sig0(4,3,8)
      real*8    L1B_lat_echo_center(3,8)
      real*8    L1B_lon_echo_center(3,8)
      real*8    L1B_lat_beam_edge(4,3)
      real*8    L1B_lon_beam_edge(4,3)
      real*8    L1B_ant_azi_rel_north(3)
      real*8    L1B_pol_roll_angle(3)
      real*8    L1B_inc_angle(3)
      real*8    L1B_land_fraction(3)
      real*8    L1B_ice_fraction(3)        
      real*4    L1B_housekeeping(35)
      integer*2 L1B_quality_flag(4,3,8)

      character*320 L2_prefix

c     OUTPUT VARIABLES
c     LOCAL VARIABLES
      integer i_beam
      integer i_seq
      integer i_chan
      integer ii

      real*8 r_time(MAX_NUM_BLOCKS)
      real*8 r_xyz(3,MAX_NUM_BLOCKS)
      real*8 r_vxyz(3,MAX_NUM_BLOCKS)
      real*8 r_roll(MAX_NUM_BLOCKS)
      real*8 r_yaw(MAX_NUM_BLOCKS)
      real*8 r_pitch(MAX_NUM_BLOCKS)
      real*8 r_ant_azi_rel_north(3,MAX_NUM_BLOCKS)
      real*8 r_pol_roll(3,MAX_NUM_BLOCKS)
      real*8 r_inc_angle(3,MAX_NUM_BLOCKS)
      real*8 r_lat_edge(4,3,8,MAX_NUM_BLOCKS)
      real*8 r_lon_edge(4,3,8,MAX_NUM_BLOCKS)
      real*8 r_sig0(4,3,8,MAX_NUM_BLOCKS)
      real*8 r_Kpc(4,3,8,MAX_NUM_BLOCKS)
      real*8 r_SNR(4,3,8,MAX_NUM_BLOCKS)
      real*8 r_Noise(2,3,8,MAX_NUM_BLOCKS)
      real*8 r_Noise_Pwr(2,3,8,MAX_NUM_BLOCKS)
      real*8 r_lat_echo_center(3,8,MAX_NUM_BLOCKS)
      real*8 r_lon_echo_center(3,8,MAX_NUM_BLOCKS)
      real*8 r_land_fraction(3,MAX_NUM_BLOCKS)
      real*8 r_ice_fraction(3,MAX_NUM_BLOCKS)
      real*4 housekeeping(35,MAX_NUM_BLOCKS)
      integer*2 i_quality_flag(4,3,8,MAX_NUM_BLOCKS)
      
c     DATA STATEMENTS
c     COMMON BLOCKS
c     FUNCTION STATEMENTS
c     PROCESSING STEPS
      save r_time, r_xyz, r_vxyz, r_roll, r_yaw, r_pitch
      save r_ant_azi_rel_north, r_pol_roll, r_inc_angle, r_lat_edge
      save r_lon_edge, r_sig0, r_Kpc, r_SNR, r_Noise
      save r_lat_echo_center, r_lon_echo_center
      save housekeeping, i_quality_flag
      save r_land_fraction, r_ice_fraction
      
C--Copy data to L1B output buffers
      r_time(i_block)  = L1B_time
      r_roll(i_block)  = L1B_roll
      r_yaw(i_block)   = L1B_yaw
      r_pitch(i_block) = L1B_pitch
      
      do ii = 1, 3
        r_xyz(ii,i_block)               = L1B_xyz_mj2k(ii)
        r_vxyz(ii,i_block)              = L1B_vxyz_mj2k(ii)
        r_ant_azi_rel_north(ii,i_block) = L1B_ant_azi_rel_north(ii)
        r_pol_roll(ii,i_block)          = L1B_pol_roll_angle(ii)
        r_inc_angle(ii,i_block)         = L1B_inc_angle(ii)
        r_land_fraction(ii,i_block)     = L1B_land_fraction(ii)
        r_ice_fraction(ii,i_block)      = L1B_ice_fraction(ii)
      enddo
      
      do ii=1,35
        housekeeping(ii,i_block) = L1B_housekeeping(ii)
      enddo
      
      do i_seq = 1, 8
        do i_beam = 1, 3

          r_lat_echo_center(i_beam,i_seq,i_block) = L1B_lat_echo_center(i_beam,i_seq)
          r_lon_echo_center(i_beam,i_seq,i_block) = L1B_lon_echo_center(i_beam,i_seq)

          do i_chan = 1, 4
            r_sig0(i_chan,i_beam,i_seq,i_block) = L1B_sig0(i_chan,i_beam,i_seq)
            r_SNR(i_chan,i_beam,i_seq,i_block)  = L1B_SNR(i_chan,i_beam,i_seq)
            r_Kpc(i_chan,i_beam,i_seq,i_block)  = L1B_KPC(i_chan,i_beam,i_seq)
            
            i_quality_flag(i_chan,i_beam,i_seq,i_block) = L1B_quality_flag(i_chan,i_beam,i_seq)
            
            if( i_chan .le. 2)then
              r_Noise(i_chan,i_beam,i_seq,i_block) = L1B_Noise(i_chan,i_beam,i_seq)
              r_Noise_Pwr(i_chan,i_beam,i_seq,i_block) = L1B_Noise_Pwr(i_chan,i_beam,i_seq)
            endif
            
          enddo
          
          do ii = 1, 4
            r_lat_edge(ii,i_beam,i_seq,i_block) = L1B_lat_beam_edge(ii,i_beam)
            r_lon_edge(ii,i_beam,i_seq,i_block) = L1B_lon_beam_edge(ii,i_beam)
          enddo
        enddo
      enddo
      
C--Write L1B output if this is the last block of the L1A file
      if( i_block .eq. NUM_BLOCKS )then
        call L1B_write_HDF4( 
     $                           r_time, 
     $                           r_xyz, 
     $                           r_vxyz,
     $                           r_roll,
     $                           r_yaw,
     $                           r_pitch,
     $                           r_ant_azi_rel_north,
     $                           r_pol_roll,
     $                           r_inc_angle,
     $                           r_lat_edge,
     $                           r_lon_edge, 
     $                           r_sig0, 
     $                           r_Kpc, 
     $                           r_SNR, 
     $                           r_Noise,
     $                           r_Noise_Pwr,
     $                           r_lat_echo_center,
     $                           r_lon_echo_center, 
     $                           i_quality_flag,
     $                           r_land_fraction,
     $                           r_ice_fraction,
     $                           housekeeping,
     $                           NUM_BLOCKS, 
     $                           block_start,
     $                           L2_prefix  )
      endif
      
      end
