C--$Header: /mnt/caretr2/scatsim/CVSROOT/L1A_to_L2/L1B_populate_temps.f,v 1.3 2009/10/05 20:25:53 fore Exp $
c*****************************************************************      
      subroutine L1B_populate_temps( ext_temps, scat_tlm )
c*****************************************************************      
c**   
c**   FILE NAME: L1B_populate_temps.f
c**   
c**   DATE WRITTEN: 10/1/2009
c**   
c**   PROGRAMMER: Alex Fore
c**   
c**   FUNCTIONAL DESCRIPTION:  Populates the common block with 
c**    instrument temperatures.
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**     
c*****************************************************************   
      implicit none
      include 'L1B_instrument_module_temps.inc'
c     PARAMETER STATEMENTS
      integer stdout, stderr, stdin
      parameter( stdout = 6, stderr = 0, stdin = 5 )
      
c     INPUT VARIABLES
          real*8 ext_temps(38) ! external temperature telemetry
          real*8 scat_tlm(38) ! scatterometer telemetry

c     OUTPUT VARIABLES
c     LOCAL VARIABLES
      integer i_pol
      integer i_beam
c     DATA STATEMENTS
c     COMMON BLOCKS
      integer i_dbg_level
      common /debug/ i_dbg_level
c     FUNCTION STATEMENTS
c     PROCESSING STEPS
      
      
      r_SC_LVPS_BOX_TEMP     = scat_tlm(11)
      r_SC_SSPA_RF_DCK_TMP   = scat_tlm(12)
      r_SC_SCG_TMP           = scat_tlm(13)
      r_SC_SBE_LNA_TMP       = scat_tlm(14)
      r_SC_SBE_TX_CHN_TMP    = scat_tlm(15)
      r_SC_SBE_RX_CHN_TMP    = scat_tlm(16)
      r_SC_SFE_TX_LOAD_TMP   = scat_tlm(17)
      r_SC_SBE_STP_ATTEN_TMP = scat_tlm(18)
      r_SC_SFE_LBK_ATTEN_TMP = scat_tlm(19)
      r_SC_SFE_LBK_SW_TMP    = scat_tlm(20)
      r_SC_SFE_BM_SW_TMP     = scat_tlm(21)

      do i_pol=1,2
        do i_beam=1,3
          r_ET_OMT_PROBE_TMP(i_beam,i_pol) = ext_temps(   2*(i_beam-1)+i_pol)
          r_ET_SFE_COAX_TMP(i_beam,i_pol)  = ext_temps(6+i_beam+3*(i_pol-1))
          r_ET_DPLX_TMP(i_beam,i_pol)      = ext_temps(12+2*(i_beam-1)+i_pol)
          r_ET_CPLR_TMP(i_beam,i_pol)      = ext_temps(18+2*(i_beam-1)+i_pol)
        enddo
      enddo
      
      if( i_dbg_level.ge.2 )then
        write(6,*) 'SC_LVPS_BOX_TEMP: ', r_SC_LVPS_BOX_TEMP
        write(6,*) 'SC_SSPA_RF_DCK_TMP: ', r_SC_SSPA_RF_DCK_TMP
        write(6,*) 'SC_SCG_TMP: ', r_SC_SCG_TMP
        write(6,*) 'SC_SBE_LNA_TMP: ', r_SC_SBE_LNA_TMP
        write(6,*) 'SC_SBE_TX_CHN_TMP: ', r_SC_SBE_TX_CHN_TMP
        write(6,*) 'SC_SBE_RX_CHN_TMP: ', r_SC_SBE_RX_CHN_TMP
        write(6,*) 'SC_SFE_TX_LOAD_TMP: ', r_SC_SFE_TX_LOAD_TMP
        write(6,*) 'SC_SBE_STP_ATTEN_TMP: ', r_SC_SBE_STP_ATTEN_TMP
        write(6,*) 'SC_SFE_LBK_ATTEN_TMP: ', r_SC_SFE_LBK_ATTEN_TMP
        write(6,*) 'SC_SFE_LBK_SW_TMP: ', r_SC_SFE_LBK_SW_TMP
        write(6,*) 'SC_SFE_BM_SW_TMP: ', r_SC_SFE_BM_SW_TMP
        
        write(6,*) 'ET_OMT_PROBE_TMP_1H: ',r_ET_OMT_PROBE_TMP(1,1)
        write(6,*) 'ET_OMT_PROBE_TMP_2H: ',r_ET_OMT_PROBE_TMP(2,1)
        write(6,*) 'ET_OMT_PROBE_TMP_3H: ',r_ET_OMT_PROBE_TMP(3,1)
        write(6,*) 'ET_OMT_PROBE_TMP_1V: ',r_ET_OMT_PROBE_TMP(1,2)
        write(6,*) 'ET_OMT_PROBE_TMP_2V: ',r_ET_OMT_PROBE_TMP(2,2)
        write(6,*) 'ET_OMT_PROBE_TMP_3V: ',r_ET_OMT_PROBE_TMP(3,2)
        
        write(6,*) 'ET_SFE_COAX_TMP_1H: ',r_ET_SFE_COAX_TMP(1,1)
        write(6,*) 'ET_SFE_COAX_TMP_2H: ',r_ET_SFE_COAX_TMP(2,1)
        write(6,*) 'ET_SFE_COAX_TMP_3H: ',r_ET_SFE_COAX_TMP(3,1)
        write(6,*) 'ET_SFE_COAX_TMP_1V: ',r_ET_SFE_COAX_TMP(1,2)
        write(6,*) 'ET_SFE_COAX_TMP_2V: ',r_ET_SFE_COAX_TMP(2,2)
        write(6,*) 'ET_SFE_COAX_TMP_3V: ',r_ET_SFE_COAX_TMP(3,2)
        
        write(6,*) 'ET_DPLX_TMP_1H: ',r_ET_DPLX_TMP(1,1)
        write(6,*) 'ET_DPLX_TMP_2H: ',r_ET_DPLX_TMP(2,1)
        write(6,*) 'ET_DPLX_TMP_3H: ',r_ET_DPLX_TMP(3,1)
        write(6,*) 'ET_DPLX_TMP_1V: ',r_ET_DPLX_TMP(1,2)
        write(6,*) 'ET_DPLX_TMP_2V: ',r_ET_DPLX_TMP(2,2)
        write(6,*) 'ET_DPLX_TMP_3V: ',r_ET_DPLX_TMP(3,2)
        
        write(6,*) 'ET_CPLR_TMP_1H: ',r_ET_CPLR_TMP(1,1)
        write(6,*) 'ET_CPLR_TMP_2H: ',r_ET_CPLR_TMP(2,1)
        write(6,*) 'ET_CPLR_TMP_3H: ',r_ET_CPLR_TMP(3,1)
        write(6,*) 'ET_CPLR_TMP_1V: ',r_ET_CPLR_TMP(1,2)
        write(6,*) 'ET_CPLR_TMP_2V: ',r_ET_CPLR_TMP(2,2)
        write(6,*) 'ET_CPLR_TMP_3V: ',r_ET_CPLR_TMP(3,2)
      endif
      end
