C--$Header: /mnt/caretr2/scatsim/CVSROOT/L1A_to_L2/L1B_read_limits_file.f,v 1.7 2009/10/07 15:46:18 fore Exp $
c*****************************************************************      
      subroutine L1B_read_limits_file( L1B_limits_file )
c*****************************************************************      
c**   
c**   FILE NAME: L1B_read_limits_file.f
c**   
c**   DATE WRITTEN: 8/17/2009
c**   
c**   PROGRAMMER: Alex Fore
c**   
c**   FUNCTIONAL DESCRIPTION:   Populates limit variables declared
c**     in include file L1B.inc.
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG: Updated 9/15/2009 for new limit tables.
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**     
c*****************************************************************   
      implicit none
      include 'L1B.inc'
c     PARAMETER STATEMENTS
c     INPUT VARIABLES
      character*320 L1B_limits_file
c     OUTPUT VARIABLES
c     LOCAL VARIABLES
      character*320 str_line
      character*50 name_tag
      real*8 lower_limit, upper_limit
      integer i_len
      integer ii
c     DATA STATEMENTS
c     COMMON BLOCKS
      integer i_dbg_level
      common /debug/ i_dbg_level
c     FUNCTION STATEMENTS
      integer lnblnk
c     PROCESSING STEPS

      open(30,file=L1B_limits_file,status='old')

100   continue
      read(30,*,end=123) name_tag, lower_limit, upper_limit

      i_len = lnblnk(name_tag)

      write (*,*) name_tag, name_tag(1:i_len)

      if( name_tag(1:i_len) .eq. 'SC_LVPS_BOX_TEMP' ) then
        SC_LVPS_BOX_TEMP_limits(1) = lower_limit
        SC_LVPS_BOX_TEMP_limits(2) = upper_limit
      
      elseif( name_tag(1:i_len) .eq. 'SC_SSPA_RF_DCK_TMP' ) then 
        SC_SSPA_RF_DCK_TMP_limits(1) = lower_limit
        SC_SSPA_RF_DCK_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SCG_TMP' ) then 
        SC_SCG_TMP_limits(1) = lower_limit
        SC_SCG_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_LNA_TMP' ) then 
        SC_SBE_LNA_TMP_limits(1) = lower_limit
        SC_SBE_LNA_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_TX_CHN_TMP' ) then 
        SC_SBE_TX_CHN_TMP_limits(1) = lower_limit
        SC_SBE_TX_CHN_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_RX_CHN_TMP' ) then 
        SC_SBE_RX_CHN_TMP_limits(1) = lower_limit
        SC_SBE_RX_CHN_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SFE_TX_LOAD_TMP' ) then 
        SC_SFE_TX_LOAD_TMP_limits(1) = lower_limit
        SC_SFE_TX_LOAD_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_STP_ATTEN_TMP' ) then 
        SC_SBE_STP_ATTEN_TMP_limits(1) = lower_limit
        SC_SBE_STP_ATTEN_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SFE_LBK_ATTEN_TMP' ) then 
        SC_SFE_LBK_ATTEN_TMP_limits(1) = lower_limit
        SC_SFE_LBK_ATTEN_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SFE_LBK_SW_TMP' ) then 
        SC_SFE_LBK_SW_TMP_limits(1) = lower_limit
        SC_SFE_LBK_SW_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SFE_BM_SW_TMP' ) then 
        SC_SFE_BM_SW_TMP_limits(1) = lower_limit
        SC_SFE_BM_SW_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SFE_GND_MON' ) then 
        SC_SFE_GND_MON_limits(1) = lower_limit
        SC_SFE_GND_MON_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SFE_N15_VLT_MON' ) then 
        SC_SFE_N15_VLT_MON_limits(1) = lower_limit
        SC_SFE_N15_VLT_MON_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_PLM1_TUNG_VLT' ) then 
        SC_SBE_PLM1_TUNG_VLT_limits(1) = lower_limit
        SC_SBE_PLM1_TUNG_VLT_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_PLM2_TUNG_VLT' ) then 
        SC_SBE_PLM2_TUNG_VLT_limits(1) = lower_limit
        SC_SBE_PLM2_TUNG_VLT_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_8MHZ_STLO_OUT_PWR_LVL' ) then 
        SC_8MHZ_STLO_OUT_PWR_LVL_limits(1) = lower_limit
        SC_8MHZ_STLO_OUT_PWR_LVL_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_16MHZ_PWR_LVL' ) then 
        SC_16MHZ_PWR_LVL_limits(1) = lower_limit
        SC_16MHZ_PWR_LVL_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_PLM1_PWR_LVL' ) then 
        SC_SBE_PLM1_PWR_LVL_limits(1) = lower_limit
        SC_SBE_PLM1_PWR_LVL_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_PLM2_PWR_LVL' ) then 
        SC_SBE_PLM2_PWR_LVL_limits(1) = lower_limit
        SC_SBE_PLM2_PWR_LVL_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_TX_EXCTR_PWR_MON' ) then 
        SC_SBE_TX_EXCTR_PWR_MON_limits(1) = lower_limit
        SC_SBE_TX_EXCTR_PWR_MON_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_LVPS_CNVRTR_CURR' ) then 
        SC_LVPS_CNVRTR_CURR_limits(1) = lower_limit
        SC_LVPS_CNVRTR_CURR_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SSPA_OUTPT_STG_VLT' ) then 
        SC_SSPA_OUTPT_STG_VLT_limits(1) = lower_limit
        SC_SSPA_OUTPT_STG_VLT_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SSPA_INTRM_STG_VLT' ) then 
        SC_SSPA_INTRM_STG_VLT_limits(1) = lower_limit
        SC_SSPA_INTRM_STG_VLT_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SSPA_INPT_STG_VLT' ) then 
        SC_SSPA_INPT_STG_VLT_limits(1) = lower_limit
        SC_SSPA_INPT_STG_VLT_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SFE_P5V_MON' ) then 
        SC_SFE_P5V_MON_limits(1) = lower_limit
        SC_SFE_P5V_MON_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SCG_P5V_MON' ) then 
        SC_SCG_P5V_MON_limits(1) = lower_limit
        SC_SCG_P5V_MON_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_P5V_MON' ) then 
        SC_SBE_P5V_MON_limits(1) = lower_limit
        SC_SBE_P5V_MON_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_SBE_P12V_NSW_MON' ) then 
        SC_SBE_P12V_NSW_MON_limits(1) = lower_limit
        SC_SBE_P12V_NSW_MON_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_STS_FIFO_ERR' ) then 
        SC_STS_FIFO_ERR_limits(1) = lower_limit
        SC_STS_FIFO_ERR_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_STS_SCAT_LVPS_OVR_CUR' ) then 
        SC_STS_SCAT_LVPS_OVR_CUR_limits(1) = lower_limit
        SC_STS_SCAT_LVPS_OVR_CUR_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_STS_SCAT_LVPS_BUS_VLT' ) then 
        SC_STS_SCAT_LVPS_BUS_VLT_limits(1) = lower_limit
        SC_STS_SCAT_LVPS_BUS_VLT_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_STS_CG_LTCH_PRM' ) then 
        SC_STS_CG_LTCH_PRM_limits(1) = lower_limit
        SC_STS_CG_LTCH_PRM_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'SC_STS_CG_LTCH_RED' ) then 
        SC_STS_CG_LTCH_RED_limits(1) = lower_limit
        SC_STS_CG_LTCH_RED_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_OMT1_H_PROBE_TMP' ) then 
        ET_OMT1_H_PROBE_TMP_limits(1) = lower_limit
        ET_OMT1_H_PROBE_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_OMT1_V_PROBE_TMP' ) then 
        ET_OMT1_V_PROBE_TMP_limits(1) = lower_limit
        ET_OMT1_V_PROBE_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_OMT2_H_PROBE_TMP' ) then 
        ET_OMT2_H_PROBE_TMP_limits(1) = lower_limit
        ET_OMT2_H_PROBE_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_OMT2_V_PROBE_TMP' ) then 
        ET_OMT2_V_PROBE_TMP_limits(1) = lower_limit
        ET_OMT2_V_PROBE_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_OMT3_H_PROBE_TMP' ) then 
        ET_OMT3_H_PROBE_TMP_limits(1) = lower_limit
        ET_OMT3_H_PROBE_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_OMT3_V_PROBE_TMP' ) then 
        ET_OMT3_V_PROBE_TMP_limits(1) = lower_limit
        ET_OMT3_V_PROBE_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_DPLX_1H_TMP' ) then 
        ET_DPLX_1H_TMP_limits(1) = lower_limit
        ET_DPLX_1H_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_DPLX_1V_TMP' ) then 
        ET_DPLX_1V_TMP_limits(1) = lower_limit
        ET_DPLX_1V_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_DPLX_2H_TMP' ) then 
        ET_DPLX_2H_TMP_limits(1) = lower_limit
        ET_DPLX_2H_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_DPLX_2V_TMP' ) then 
        ET_DPLX_2V_TMP_limits(1) = lower_limit
        ET_DPLX_2V_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_DPLX_3H_TMP' ) then 
        ET_DPLX_3H_TMP_limits(1) = lower_limit
        ET_DPLX_3H_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_DPLX_3V_TMP' ) then 
        ET_DPLX_3V_TMP_limits(1) = lower_limit
        ET_DPLX_3V_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_CPLR_1H_TMP' ) then 
        ET_CPLR_1H_TMP_limits(1) = lower_limit
        ET_CPLR_1H_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_CPLR_1V_TMP' ) then 
        ET_CPLR_1V_TMP_limits(1) = lower_limit
        ET_CPLR_1V_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_CPLR_2H_TMP' ) then 
        ET_CPLR_2H_TMP_limits(1) = lower_limit
        ET_CPLR_2H_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_CPLR_2V_TMP' ) then 
        ET_CPLR_2V_TMP_limits(1) = lower_limit
        ET_CPLR_2V_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_CPLR_3H_TMP' ) then 
        ET_CPLR_3H_TMP_limits(1) = lower_limit
        ET_CPLR_3H_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_CPLR_3V_TMP' ) then 
        ET_CPLR_3V_TMP_limits(1) = lower_limit
        ET_CPLR_3V_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_SFE_H1_COAX_TMP' ) then 
        ET_SFE_H1_COAX_TMP_limits(1) = lower_limit
        ET_SFE_H1_COAX_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_SFE_H2_COAX_TMP' ) then 
        ET_SFE_H2_COAX_TMP_limits(1) = lower_limit
        ET_SFE_H2_COAX_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_SFE_H3_COAX_TMP' ) then 
        ET_SFE_H3_COAX_TMP_limits(1) = lower_limit
        ET_SFE_H3_COAX_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_SFE_V1_COAX_TMP' ) then 
        ET_SFE_V1_COAX_TMP_limits(1) = lower_limit
        ET_SFE_V1_COAX_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_SFE_V2_COAX_TMP' ) then 
        ET_SFE_V2_COAX_TMP_limits(1) = lower_limit
        ET_SFE_V2_COAX_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ET_SFE_V3_COAX_TMP' ) then 
        ET_SFE_V3_COAX_TMP_limits(1) = lower_limit
        ET_SFE_V3_COAX_TMP_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'IE_ICDS_TLM_CAL_RES1' ) then 
        IE_ICDS_TLM_CAL_RES1_limits(1) = lower_limit
        IE_ICDS_TLM_CAL_RES1_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'IE_ICDS_TLM_CAL_RES2' ) then 
        IE_ICDS_TLM_CAL_RES2_limits(1) = lower_limit
        IE_ICDS_TLM_CAL_RES2_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'IE_ICDS_TLM_CAL_RES3' ) then 
        IE_ICDS_TLM_CAL_RES3_limits(1) = lower_limit
        IE_ICDS_TLM_CAL_RES3_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'IE_ICDS_TLM_CAL_RES4' ) then 
        IE_ICDS_TLM_CAL_RES4_limits(1) = lower_limit
        IE_ICDS_TLM_CAL_RES4_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1HV_LB_PWR' ) then 
        LB_PWR_limits(1,1,1) = lower_limit
        LB_PWR_limits(2,1,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1VV_LB_PWR' ) then 
        LB_PWR_limits(1,2,1) = lower_limit
        LB_PWR_limits(2,2,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1VH_LB_PWR' ) then 
        LB_PWR_limits(1,3,1) = lower_limit
        LB_PWR_limits(2,3,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1HH_LB_PWR' ) then 
        LB_PWR_limits(1,4,1) = lower_limit
        LB_PWR_limits(2,4,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2HV_LB_PWR' ) then 
        LB_PWR_limits(1,1,2) = lower_limit
        LB_PWR_limits(2,1,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2VV_LB_PWR' ) then 
        LB_PWR_limits(1,2,2) = lower_limit
        LB_PWR_limits(2,2,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2VH_LB_PWR' ) then 
        LB_PWR_limits(1,3,2) = lower_limit
        LB_PWR_limits(2,3,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2HH_LB_PWR' ) then 
        LB_PWR_limits(1,4,2) = lower_limit
        LB_PWR_limits(2,4,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3HV_LB_PWR' ) then 
        LB_PWR_limits(1,1,3) = lower_limit
        LB_PWR_limits(2,1,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3VV_LB_PWR' ) then 
        LB_PWR_limits(1,2,3) = lower_limit
        LB_PWR_limits(2,2,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3VH_LB_PWR' ) then 
        LB_PWR_limits(1,3,3) = lower_limit
        LB_PWR_limits(2,3,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3HH_LB_PWR' ) then 
        LB_PWR_limits(1,4,3) = lower_limit
        LB_PWR_limits(2,4,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1HV_PWR' ) then 
        ECHO_PWR_limits(1,1,1) = lower_limit
        ECHO_PWR_limits(2,1,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1VV_PWR' ) then 
        ECHO_PWR_limits(1,2,1) = lower_limit
        ECHO_PWR_limits(2,2,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1VH_PWR' ) then 
        ECHO_PWR_limits(1,3,1) = lower_limit
        ECHO_PWR_limits(2,3,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1HH_PWR' ) then 
        ECHO_PWR_limits(1,4,1) = lower_limit
        ECHO_PWR_limits(2,4,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2HV_PWR' ) then 
        ECHO_PWR_limits(1,1,2) = lower_limit
        ECHO_PWR_limits(2,1,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2VV_PWR' ) then 
        ECHO_PWR_limits(1,2,2) = lower_limit
        ECHO_PWR_limits(2,2,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2VH_PWR' ) then 
        ECHO_PWR_limits(1,3,2) = lower_limit
        ECHO_PWR_limits(2,3,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2HH_PWR' ) then 
        ECHO_PWR_limits(1,4,2) = lower_limit
        ECHO_PWR_limits(2,4,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3HV_PWR' ) then 
        ECHO_PWR_limits(1,1,3) = lower_limit
        ECHO_PWR_limits(2,1,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3VV_PWR' ) then 
        ECHO_PWR_limits(1,2,3) = lower_limit
        ECHO_PWR_limits(2,2,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3VH_PWR' ) then 
        ECHO_PWR_limits(1,3,3) = lower_limit
        ECHO_PWR_limits(2,3,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3HH_PWR' ) then 
        ECHO_PWR_limits(1,4,3) = lower_limit
        ECHO_PWR_limits(2,4,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1nV_PWR' ) then 
        NOISE_PWR_limits(1,1,1) = lower_limit
        NOISE_PWR_limits(2,1,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1nH_PWR' ) then 
        NOISE_PWR_limits(1,2,1) = lower_limit
        NOISE_PWR_limits(2,2,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2nV_PWR' ) then 
        NOISE_PWR_limits(1,1,2) = lower_limit
        NOISE_PWR_limits(2,1,2) = upper_limit
        
      elseif( name_tag(1:i_len) .eq. 'B2nH_PWR' ) then 
        NOISE_PWR_limits(1,2,2) = lower_limit
        NOISE_PWR_limits(2,2,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3nV_PWR' ) then 
        NOISE_PWR_limits(1,1,3) = lower_limit
        NOISE_PWR_limits(2,1,3) = upper_limit
        
      elseif( name_tag(1:i_len) .eq. 'B3nH_PWR' ) then 
        NOISE_PWR_limits(1,2,3) = lower_limit
        NOISE_PWR_limits(2,2,3) = upper_limit
        
      elseif( name_tag(1:i_len) .eq. 'B1nV_CND_PWR' ) then 
        CND_PWR_limits(1,1) = lower_limit
        CND_PWR_limits(2,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2nV_CND_PWR' ) then 
        CND_PWR_limits(1,2) = lower_limit
        CND_PWR_limits(2,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3nV_CND_PWR' ) then 
        CND_PWR_limits(1,3) = lower_limit
        CND_PWR_limits(2,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B1V_Gain' ) then 
        Gain_limits(1,1) = lower_limit
        Gain_limits(2,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B2V_Gain' ) then 
        Gain_limits(1,2) = lower_limit
        Gain_limits(2,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'B3V_Gain' ) then 
        Gain_limits(1,3) = lower_limit
        Gain_limits(2,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'LOOK_ANGLE_BEAM_1' ) then
        LOOK_ANGLE_limits(1,1) = lower_limit
        LOOK_ANGLE_limits(2,1) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'LOOK_ANGLE_BEAM_2' ) then 
        LOOK_ANGLE_limits(1,2) = lower_limit
        LOOK_ANGLE_limits(2,2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'LOOK_ANGLE_BEAM_3' ) then 
        LOOK_ANGLE_limits(1,3) = lower_limit
        LOOK_ANGLE_limits(2,3) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'LAND_FRACTION' ) then 
        LAND_FRACTION_limits(1) = lower_limit
        LAND_FRACTION_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'ICE_FRACTION' ) then 
        ICE_FRACTION_limits(1) = lower_limit
        ICE_FRACTION_limits(2) = upper_limit

      elseif( name_tag(1:i_len) .eq. 'TIME_TAG_ERROR' ) then 
        TIME_TAG_ERROR_limits(1) = lower_limit
        TIME_TAG_ERROR_limits(2) = upper_limit

      else
        write(6,*) 'L1B_read_limits_file: WARNING: Unknown tag found! ', name_tag(1:i_len)
      endif
      goto 100
      
123   continue      
      close(30)
      
      if( i_dbg_level .ge. 1 ) then
        write(6,'((a50),2f12.6)') 'SC_LVPS_BOX_TEMP_limits: ', SC_LVPS_BOX_TEMP_limits
        write(6,'((a50),2f12.6)') 'SC_SSPA_RF_DCK_TMP_limits: ', SC_SSPA_RF_DCK_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SCG_TMP_limits: ', SC_SCG_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_LNA_TMP_limits: ', SC_SBE_LNA_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_TX_CHN_TMP_limits: ', SC_SBE_TX_CHN_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_RX_CHN_TMP_limits: ', SC_SBE_RX_CHN_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SFE_TX_LOAD_TMP_limits: ', SC_SFE_TX_LOAD_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_STP_ATTEN_TMP_limits: ', SC_SBE_STP_ATTEN_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SFE_LBK_ATTEN_TMP_limits: ', SC_SFE_LBK_ATTEN_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SFE_LBK_SW_TMP_limits: ', SC_SFE_LBK_SW_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SFE_BM_SW_TMP_limits: ', SC_SFE_BM_SW_TMP_limits
        write(6,'((a50),2f12.6)') 'SC_SFE_GND_MON_limits: ', SC_SFE_GND_MON_limits
        write(6,'((a50),2f12.6)') 'SC_SFE_N15_VLT_MON_limits: ', SC_SFE_N15_VLT_MON_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_PLM1_TUNG_VLT_limits: ', SC_SBE_PLM1_TUNG_VLT_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_PLM2_TUNG_VLT_limits: ', SC_SBE_PLM2_TUNG_VLT_limits
        write(6,'((a50),2f12.6)') 'SC_8MHZ_STLO_OUT_PWR_LVL_limits: ', SC_8MHZ_STLO_OUT_PWR_LVL_limits
        write(6,'((a50),2f12.6)') 'SC_16MHZ_PWR_LVL_limits: ', SC_16MHZ_PWR_LVL_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_PLM1_PWR_LVL_limits: ', SC_SBE_PLM1_PWR_LVL_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_PLM2_PWR_LVL_limits: ', SC_SBE_PLM2_PWR_LVL_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_TX_EXCTR_PWR_MON_limits: ', SC_SBE_TX_EXCTR_PWR_MON_limits
        write(6,'((a50),2f12.6)') 'SC_LVPS_CNVRTR_CURR_limits: ', SC_LVPS_CNVRTR_CURR_limits
        write(6,'((a50),2f12.6)') 'SC_SSPA_OUTPT_STG_VLT_limits: ', SC_SSPA_OUTPT_STG_VLT_limits
        write(6,'((a50),2f12.6)') 'SC_SSPA_INTRM_STG_VLT_limits: ', SC_SSPA_INTRM_STG_VLT_limits
        write(6,'((a50),2f12.6)') 'SC_SSPA_INPT_STG_VLT_limits: ', SC_SSPA_INPT_STG_VLT_limits
        write(6,'((a50),2f12.6)') 'SC_SFE_P5V_MON_limits: ', SC_SFE_P5V_MON_limits
        write(6,'((a50),2f12.6)') 'SC_SCG_P5V_MON_limits: ', SC_SCG_P5V_MON_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_P5V_MON_limits: ', SC_SBE_P5V_MON_limits
        write(6,'((a50),2f12.6)') 'SC_SBE_P12V_NSW_MON_limits: ', SC_SBE_P12V_NSW_MON_limits
        write(6,'((a50),2f12.6)') 'SC_STS_FIFO_ERR_limits: ', SC_STS_FIFO_ERR_limits
        write(6,'((a50),2f12.6)') 'SC_STS_SCAT_LVPS_OVR_CUR_limits: ', SC_STS_SCAT_LVPS_OVR_CUR_limits
        write(6,'((a50),2f12.6)') 'SC_STS_SCAT_LVPS_BUS_VLT_limits: ', SC_STS_SCAT_LVPS_BUS_VLT_limits
        write(6,'((a50),2f12.6)') 'SC_STS_CG_LTCH_PRM_limits: ', SC_STS_CG_LTCH_PRM_limits
        write(6,'((a50),2f12.6)') 'SC_STS_CG_LTCH_RED_limits: ', SC_STS_CG_LTCH_RED_limits
        write(6,'((a50),2f12.6)') 'ET_OMT1_H_PROBE_TMP_limits: ', ET_OMT1_H_PROBE_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_OMT1_V_PROBE_TMP_limits: ', ET_OMT1_V_PROBE_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_OMT2_H_PROBE_TMP_limits: ', ET_OMT2_H_PROBE_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_OMT2_V_PROBE_TMP_limits: ', ET_OMT2_V_PROBE_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_OMT3_H_PROBE_TMP_limits: ', ET_OMT3_H_PROBE_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_OMT3_V_PROBE_TMP_limits: ', ET_OMT3_V_PROBE_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_DPLX_1H_TMP_limits: ', ET_DPLX_1H_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_DPLX_1V_TMP_limits: ', ET_DPLX_1V_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_DPLX_2H_TMP_limits: ', ET_DPLX_2H_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_DPLX_2V_TMP_limits: ', ET_DPLX_2V_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_DPLX_3H_TMP_limits: ', ET_DPLX_3H_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_DPLX_3V_TMP_limits: ', ET_DPLX_3V_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_CPLR_1H_TMP_limits: ', ET_CPLR_1H_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_CPLR_1V_TMP_limits: ', ET_CPLR_1V_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_CPLR_2H_TMP_limits: ', ET_CPLR_2H_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_CPLR_2V_TMP_limits: ', ET_CPLR_2V_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_CPLR_3H_TMP_limits: ', ET_CPLR_3H_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_CPLR_3V_TMP_limits: ', ET_CPLR_3V_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_SFE_H1_COAX_TMP_limits: ', ET_SFE_H1_COAX_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_SFE_H2_COAX_TMP_limits: ', ET_SFE_H2_COAX_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_SFE_H3_COAX_TMP_limits: ', ET_SFE_H3_COAX_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_SFE_V1_COAX_TMP_limits: ', ET_SFE_V1_COAX_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_SFE_V2_COAX_TMP_limits: ', ET_SFE_V2_COAX_TMP_limits
        write(6,'((a50),2f12.6)') 'ET_SFE_V3_COAX_TMP_limits: ', ET_SFE_V3_COAX_TMP_limits
        write(6,'((a50),2f12.6)') 'IE_ICDS_TLM_CAL_RES1_limits: ', IE_ICDS_TLM_CAL_RES1_limits
        write(6,'((a50),2f12.6)') 'IE_ICDS_TLM_CAL_RES2_limits: ', IE_ICDS_TLM_CAL_RES2_limits
        write(6,'((a50),2f12.6)') 'IE_ICDS_TLM_CAL_RES3_limits: ', IE_ICDS_TLM_CAL_RES3_limits
        write(6,'((a50),2f12.6)') 'IE_ICDS_TLM_CAL_RES4_limits: ', IE_ICDS_TLM_CAL_RES4_limits
        write(6,'((a50),2f12.6)') 'B1HV_LB_PWR_limits: ', (LB_PWR_limits(ii,1,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1VV_LB_PWR_limits: ', (LB_PWR_limits(ii,2,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1VH_LB_PWR_limits: ', (LB_PWR_limits(ii,3,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1HH_LB_PWR_limits: ', (LB_PWR_limits(ii,4,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2HV_LB_PWR_limits: ', (LB_PWR_limits(ii,1,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2VV_LB_PWR_limits: ', (LB_PWR_limits(ii,2,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2VH_LB_PWR_limits: ', (LB_PWR_limits(ii,3,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2HH_LB_PWR_limits: ', (LB_PWR_limits(ii,4,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3HV_LB_PWR_limits: ', (LB_PWR_limits(ii,1,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3VV_LB_PWR_limits: ', (LB_PWR_limits(ii,2,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3VH_LB_PWR_limits: ', (LB_PWR_limits(ii,3,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3HH_LB_PWR_limits: ', (LB_PWR_limits(ii,4,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1HV_PWR_limits: ', (ECHO_PWR_limits(ii,1,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1VV_PWR_limits: ', (ECHO_PWR_limits(ii,2,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1VH_PWR_limits: ', (ECHO_PWR_limits(ii,3,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1HH_PWR_limits: ', (ECHO_PWR_limits(ii,4,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2HV_PWR_limits: ', (ECHO_PWR_limits(ii,1,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2VV_PWR_limits: ', (ECHO_PWR_limits(ii,2,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2VH_PWR_limits: ', (ECHO_PWR_limits(ii,3,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2HH_PWR_limits: ', (ECHO_PWR_limits(ii,4,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3HV_PWR_limits: ', (ECHO_PWR_limits(ii,1,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3VV_PWR_limits: ', (ECHO_PWR_limits(ii,2,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3VH_PWR_limits: ', (ECHO_PWR_limits(ii,3,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3HH_PWR_limits: ', (ECHO_PWR_limits(ii,4,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1nV_PWR_limits: ', (NOISE_PWR_limits(ii,1,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1nH_PWR_limits: ', (NOISE_PWR_limits(ii,2,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2nV_PWR_limits: ', (NOISE_PWR_limits(ii,1,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2nH_PWR_limits: ', (NOISE_PWR_limits(ii,2,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3nV_PWR_limits: ', (NOISE_PWR_limits(ii,1,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3nH_PWR_limits: ', (NOISE_PWR_limits(ii,2,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1nV_CND_PWR_limits: ', (CND_PWR_limits(ii,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2nV_CND_PWR_limits: ', (CND_PWR_limits(ii,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3nV_CND_PWR_limits: ', (CND_PWR_limits(ii,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'B1V_Gain_limits: ', (Gain_limits(ii,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'B2V_Gain_limits: ', (Gain_limits(ii,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'B3V_Gain_limits: ', (Gain_limits(ii,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'LOOK_ANGLE_BEAM_1_limits: ',(LOOK_ANGLE_limits(ii,1),ii=1,2)
        write(6,'((a50),2f12.6)') 'LOOK_ANGLE_BEAM_2_limits: ',(LOOK_ANGLE_limits(ii,2),ii=1,2)
        write(6,'((a50),2f12.6)') 'LOOK_ANGLE_BEAM_3_limits: ',(LOOK_ANGLE_limits(ii,3),ii=1,2)
        write(6,'((a50),2f12.6)') 'LAND_FRACTION_limits: ', LAND_FRACTION_limits
        write(6,'((a50),2f12.6)') 'ICE_FRACTION_limits: ', ICE_FRACTION_limits
        write(6,'((a50),2f12.6)') 'TIME_TAG_ERROR_limits: ', TIME_TAG_ERROR_limits

      endif
      end
