C--$Header: /u/caretr2/scatsim/CVSROOT/L1A_to_L2/L2_compute_sigma_exp.f,v 1.2 2012/02/07 20:47:58 fore Exp $
c*****************************************************************      
      subroutine L2_compute_sigma_exp( wind_speed_ancilliary,
     $                                 relazang_in,
     $                                 L1B_inc_angle,
     $                                 L2_land_fraction,
     $                                 L2_ice_fraction,
     $                                 L2_sigma_exp )
c*****************************************************************      
c**   
c**   FILE NAME: L2_compute_sigma_exp.f
c**   
c**   DATE WRITTEN: 1/23/2012
c**   
c**   PROGRAMMER: Alex Fore
c**   
c**   FUNCTIONAL DESCRIPTION:  Compute expected sigma0
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**     
c*****************************************************************   
      implicit none
      include 'L1B.inc' 
c     PARAMETER STATEMENTS
      integer stdout, stderr, stdin
      parameter( stdout = 6, stderr = 0, stdin = 5 )
c     INPUT VARIABLES
      real*8 wind_speed_ancilliary
      real*8 relazang_in
      real*8 L1B_inc_angle
      real*8 L2_land_fraction
      real*8 L2_ice_fraction
c     OUTPUT VARIABLES
      real*8 L2_sigma_exp(4)
c     LOCAL VARIABLES      
      real*8 relazang
      real*8 sigma0_gmf(3)
c     DATA STATEMENTS
c     COMMON BLOCKS
c     FUNCTION STATEMENTS
c     PROCESSING STEPS

      ! switch wind direction conventions to use S. Yueh's subroutines
      relazang = relazang_in + 180.0
      if( relazang .ge. 180 ) relazang = relazang - 360
      if( relazang .lt.-180 ) relazang = relazang + 360
      
      if( L2_land_fraction.lt.LAND_FRACTION_limits(2) .and.
     $    L2_ice_fraction .lt.ICE_FRACTION_limits(2) ) then
      
        call aqradargmf_op(L1B_inc_angle,wind_speed_ancilliary,relazang,sigma0_gmf)
      
        L2_sigma_exp(1) = 10.0*log10(sigma0_gmf(3)) ! HV
        L2_sigma_exp(2) = 10.0*log10(sigma0_gmf(1)) ! VV
        L2_sigma_exp(3) = 10.0*log10(sigma0_gmf(3)) ! VH (HV==VH)
        L2_sigma_exp(4) = 10.0*log10(sigma0_gmf(2)) ! HH
      else
        L2_sigma_exp(1) = -999
        L2_sigma_exp(2) = -999
        L2_sigma_exp(3) = -999
        L2_sigma_exp(4) = -999
      endif
      
      end
