C--$Header: /mnt/caretr2/scatsim/CVSROOT/L1A_to_L2/L2_populate_output_buffer.f,v 1.6 2009/10/26 18:47:37 fore Exp $
c*****************************************************************      
      subroutine L2_populate_output_buffer( i_block,
     $                                      block_start,
     $                                      NUM_BLOCKS,
     $                                      icds_blknum,
     $                                      L2_time,
     $                                      L2_scat_wind_speed,
     $                                      L2_scat_wind_speed_err,
     $                                      L2_excess_surf_emiss,
     $                                      L2_excess_surf_emiss_err,     
     $                                      L2_anc_wind_speed,
     $                                      L2_anc_wind_dir,
     $                                      L2_faraday_rotation_angle,
     $                                      L2_beam_clat,
     $                                      L2_beam_clon,
     $                                      L2_beam_elat,
     $                                      L2_beam_elon,
     $                                      L2_sigma_ANT,
     $                                      L2_sigma_TOA,
     $                                      L2_sigma_Far,
     $                                      L2_tot_sigma_TOA,
     $                                      L2_KPC_ANT,
     $                                      L2_KPC_TOA,
     $                                      L2_tot_KPC_TOA,
     $                                      L2_scat_samples,
     $                                      L2_scatterometer_flags,
     $                                      L2_scat_rfi_flags,
     $                                      L2_land_fraction,
     $                                      L2_ice_fraction,
     $                                      L2_polarization_roll,
     $                                      L2_sigma_exp,
     $                                      L2_prefix    )
c*****************************************************************      
c**   
c**   FILE NAME: L2_populate_output_buffer.f
c**   
c**   DATE WRITTEN: 9/22/2009
c**   
c**   PROGRAMMER: Alex Fore
c**   
c**   FUNCTIONAL DESCRIPTION:  
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**   04/19/2011         Change iblock to       JMG
c**                      iblk when writing
c**                      flags/RFI flags
c*****************************************************************   
      implicit none
      include 'L1A.inc'
c     PARAMETER STATEMENTS
      integer stdout, stderr, stdin
      parameter( stdout = 6, stderr = 0, stdin = 5 )
c     INPUT VARIABLES
      integer i_block, i_blk
      integer block_start
      integer NUM_BLOCKS
      integer*4 icds_blknum
      
      real*8  L2_time
      real*8  L2_scat_wind_speed(3)
      real*8  L2_scat_wind_speed_err(3)

      real*8  L2_excess_surf_emiss(2,3)
      real*8  L2_excess_surf_emiss_err(2,3)
      real*8  L2_faraday_rotation_angle(3) ! Estimated faraday rotation angle used for faraday rotation corrections [deg]
      real*8  L2_beam_clat(3)
      real*8  L2_beam_clon(3)
      real*8  L2_beam_elat(4,3)
      real*8  L2_beam_elon(4,3)
      real*8  L2_sigma_ANT(4,3)
      real*8  L2_sigma_TOA(4,3)
      real*8  L2_sigma_Far(4,3)
      real*8  L2_tot_sigma_TOA(3)
      real*8  L2_KPC_ANT(4,3) ! KPC for antenna sigma 0
      real*8  L2_KPC_TOA(4,3) ! KPC for top of atmosphere sigma 0
      real*8  L2_tot_KPC_TOA(3) ! KPC for top of atmosphere total sigma 0
      real*8  L2_anc_wind_speed(3)
      real*8  L2_anc_wind_dir(3)
      real*8  L2_land_fraction(3)
      real*8  L2_ice_fraction(3)
      real*8  L2_polarization_roll(3)
      real*8  L2_sigma_exp(4,3)

      integer L2_scat_samples(3)
      integer L2_scatterometer_flags(3)
      
      integer*1 L2_scat_rfi_flags(3,2) ! beam, RX-polarization (1-V,2-H)

      character*320 L2_prefix


c     OUTPUT VARIABLES
c     LOCAL VARIABLES
      integer i_beam
      integer i_chan
      integer ii
      
      integer i_year
      integer i_month
      integer i_day
      integer i_day2
      integer i_hour
      integer i_minute
      integer i_second
      real*8  r_frac_seconds
      
      real*8 L2_output_time(                    MAX_NUM_BLOCKS ) ! i_block
      real*8 L2_output_scat_wind_speed(      3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8 L2_output_scat_wind_speed_err(  3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8 L2_output_faraday_rotation_angle(3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8 L2_output_excess_surf_emiss(    2, 3, MAX_NUM_BLOCKS ) ! i_rx_pol, i_beam, i_block  (i_rx_pol order V,H)
      real*8 L2_output_excess_surf_emiss_err(2, 3, MAX_NUM_BLOCKS ) ! i_rx_pol, i_beam, i_block  (i_rx_pol order V,H)
      real*8  L2_output_beam_clat(           3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8  L2_output_beam_clon(           3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8  L2_output_beam_elat(        3, 4, MAX_NUM_BLOCKS ) ! i_beam, i_point, i_block
      real*8  L2_output_beam_elon(        3, 4, MAX_NUM_BLOCKS ) ! i_beam, i_point, i_block
      real*8  L2_output_sigma_ANT(        4, 3, MAX_NUM_BLOCKS ) ! i_chan, i_beam, i_block
      real*8  L2_output_sigma_TOA(        4, 3, MAX_NUM_BLOCKS ) ! i_chan, i_beam, i_block
      real*8  L2_output_sigma_Far(        4, 3, MAX_NUM_BLOCKS ) ! i_chan, i_beam, i_block
      real*8  L2_output_tot_sigma_TOA(       3, MAX_NUM_BLOCKS ) !         i_beam, i_block
      real*8  L2_output_KPC_ANT(         4, 3, MAX_NUM_BLOCKS )  ! i_chan, i_beam, i_block
      real*8  L2_output_KPC_TOA(         4, 3, MAX_NUM_BLOCKS )  ! i_chan, i_beam, i_block
      real*8  L2_output_tot_KPC_TOA(        3, MAX_NUM_BLOCKS )  !         i_beam, i_block

      real*8 L2_output_anc_wind_speed(       3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8 L2_output_anc_wind_dir(         3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      
      real*8 L2_output_land_fraction(        3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8 L2_output_ice_fraction(         3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      real*8 L2_output_polarization_roll(    3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      
      real*8 L2_output_sigma_exp(         4, 3, MAX_NUM_BLOCKS ) ! i_chan, i_beam, i_block

      integer L2_output_scat_samples(        3, MAX_NUM_BLOCKS ) ! i_beam, i_block
      integer L2_output_scatterometer_flags( 3, MAX_NUM_BLOCKS ) ! i_chan, i_beam, i_block
      
      integer L2_output_icds_blknum( MAX_NUM_BLOCKS)

      integer*1 L2_output_scat_rfi_flags(3, 2, MAX_NUM_BLOCKS) ! beam, rx_polarization, i_block
      
      character*320 L2_output_file

      integer*4 i4_L2_tmp_out_flags_b1(2), i4_L2_tmp_out_flags_b2(2), i4_L2_tmp_out_flags_b3(2)
      integer*8 i8_L2_tmp_out_flags_b1, i8_L2_tmp_out_flags_b2, i8_L2_tmp_out_flags_b3
      
      integer*2 i2_L2_tmp_out_rfi_flags_b1v,    i2_L2_tmp_out_rfi_flags_b2v,    i2_L2_tmp_out_rfi_flags_b3v
      integer*1 i1_L2_tmp_out_rfi_flags_b1v(2), i1_L2_tmp_out_rfi_flags_b2v(2), i1_L2_tmp_out_rfi_flags_b3v(2)
      integer*2 i2_L2_tmp_out_rfi_flags_b1h,    i2_L2_tmp_out_rfi_flags_b2h,    i2_L2_tmp_out_rfi_flags_b3h
      integer*1 i1_L2_tmp_out_rfi_flags_b1h(2), i1_L2_tmp_out_rfi_flags_b2h(2), i1_L2_tmp_out_rfi_flags_b3h(2)
            
c     DATA STATEMENTS
C     EQUIVALENCE STATEMENTS
      equivalence (i4_L2_tmp_out_flags_b1,i8_L2_tmp_out_flags_b1)
      equivalence (i4_L2_tmp_out_flags_b2,i8_L2_tmp_out_flags_b2)
      equivalence (i4_L2_tmp_out_flags_b3,i8_L2_tmp_out_flags_b3)
      equivalence (i1_L2_tmp_out_rfi_flags_b1v,i2_L2_tmp_out_rfi_flags_b1v)
      equivalence (i1_L2_tmp_out_rfi_flags_b2v,i2_L2_tmp_out_rfi_flags_b2v)
      equivalence (i1_L2_tmp_out_rfi_flags_b3v,i2_L2_tmp_out_rfi_flags_b3v)
      equivalence (i1_L2_tmp_out_rfi_flags_b1h,i2_L2_tmp_out_rfi_flags_b1h)
      equivalence (i1_L2_tmp_out_rfi_flags_b2h,i2_L2_tmp_out_rfi_flags_b2h)
      equivalence (i1_L2_tmp_out_rfi_flags_b3h,i2_L2_tmp_out_rfi_flags_b3h)
c     COMMON BLOCKS
      character*200 AQ_SCAT_SIM_DIR_OUT, AQ_SCAT_SIM_DIR_DAT, AQ_SCAT_SIM_DIR_SCRATCH
      common /AQ_SCAT_SIM_DIRS/ AQ_SCAT_SIM_DIR_OUT, AQ_SCAT_SIM_DIR_DAT,
     $ AQ_SCAT_SIM_DIR_SCRATCH   

      integer i_dbg_level
      common /debug/ i_dbg_level

c     FUNCTION STATEMENTS
      integer lnblnk
c     PROCESSING STEPS
      save L2_output_time, L2_output_scat_wind_speed, L2_output_scat_wind_speed_err
      save L2_output_faraday_rotation_angle
      save L2_output_excess_surf_emiss, L2_output_excess_surf_emiss_err
      save L2_output_beam_clat, L2_output_beam_clon
      save L2_output_beam_elat, L2_output_beam_elon
      save L2_output_sigma_ANT, L2_output_sigma_TOA
      save L2_output_sigma_Far, L2_output_tot_sigma_TOA
      save L2_output_scat_samples, L2_output_scatterometer_flags
      save L2_output_scat_rfi_flags, L2_output_icds_blknum
      save L2_output_polarization_roll
      save L2_output_sigma_exp

C--Copy data to L2 output buffers      
      L2_output_time( i_block ) = L2_time
      L2_output_icds_blknum( i_block ) = icds_blknum

      do i_beam = 1, 3
        L2_output_scat_wind_speed( i_beam, i_block ) = L2_scat_wind_speed( i_beam )
        L2_output_scat_wind_speed_err( i_beam, i_block ) = L2_scat_wind_speed_err( i_beam )
        L2_output_faraday_rotation_angle( i_beam, i_block ) = L2_faraday_rotation_angle( i_beam )
        L2_output_beam_clat( i_beam, i_block ) = L2_beam_clat( i_beam )
        L2_output_beam_clon( i_beam, i_block ) = L2_beam_clon( i_beam )
        
        L2_output_anc_wind_speed( i_beam, i_block) = L2_anc_wind_speed( i_beam )
        L2_output_anc_wind_dir( i_beam, i_block)   = L2_anc_wind_dir( i_beam )
        
        L2_output_land_fraction(i_beam, i_block)   = L2_land_fraction( i_beam )
        L2_output_ice_fraction(i_beam, i_block)    = L2_ice_fraction( i_beam )
        
        L2_output_tot_sigma_TOA( i_beam, i_block ) = L2_tot_sigma_TOA( i_beam )
        L2_output_tot_KPC_TOA( i_beam, i_block ) = L2_tot_KPC_TOA( i_beam )

        
        do i_chan = 1, 4
          L2_output_sigma_ANT( i_chan, i_beam, i_block ) = L2_sigma_ANT( i_chan, i_beam )
          L2_output_sigma_TOA( i_chan, i_beam, i_block ) = L2_sigma_TOA( i_chan, i_beam )
          L2_output_sigma_Far( i_chan, i_beam, i_block ) = L2_sigma_Far( i_chan, i_beam )
          L2_output_sigma_exp( i_chan, i_beam, i_block ) = L2_sigma_exp( i_chan, i_beam )

          L2_output_KPC_ANT( i_chan, i_beam, i_block ) = L2_KPC_ANT( i_chan, i_beam )
          L2_output_KPC_TOA( i_chan, i_beam, i_block ) = L2_KPC_TOA( i_chan, i_beam )
        enddo

        L2_output_scatterometer_flags( i_beam, i_block ) = L2_scatterometer_flags( i_beam )

        L2_output_polarization_roll( i_beam, i_block ) = L2_polarization_roll( i_beam )

        do ii = 1, 2
          L2_output_excess_surf_emiss( ii, i_beam, i_block )     = L2_excess_surf_emiss( ii, i_beam )
          L2_output_excess_surf_emiss_err( ii, i_beam, i_block ) = L2_excess_surf_emiss_err( ii, i_beam )
        enddo
        
        do ii = 1, 4
          L2_output_beam_elat( i_beam, ii, i_block ) = L2_beam_elat( ii, i_beam)
          L2_output_beam_elon( i_beam, ii, i_block ) = L2_beam_elon( ii, i_beam)
        enddo
        
        do ii = 1, 2
          L2_output_scat_rfi_flags( i_beam, ii, i_block ) = L2_scat_rfi_flags( i_beam, ii )
        enddo
        
        L2_output_scat_samples( i_beam, i_block ) = L2_scat_samples( i_beam )
        
      enddo
      
      
      if( i_block .eq. NUM_BLOCKS ) then ! write L2 output
        
C--Generate prefix for L2 output files
        call JD2CAL(L2_output_time(block_start), i_year, i_month, i_day, i_hour, 
     $ i_minute, i_second, r_frac_seconds)
      
        call convert_day_and_month_to_dayofyear(i_year, i_day, 
     $ i_month, i_day2)
     
900     format('Q',I4.4,I3.3,I2.2,I2.2,I2.2) 

!        write(L2_prefix,900) i_year, i_day2, i_hour, i_minute, i_second
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_sigma_ANT.txt'
        open(80,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_sigma_TOA.txt'
        open(81,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_sigma_Far.txt'
        open(82,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_center_lon_lat.txt'
        open(83,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_edges_lon_lat.txt'
        open(84,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_flags.txt'
        open(85,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
            
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_samples.txt'
        open(86,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_wind_speed.txt'
        open(87,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_wind_speed_err.txt'
        open(95,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_faraday_rotation_angle.txt'
        open(96,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_polarization_roll.txt'
        open(99,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_sigma_exp.txt'
        open(79,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_excess_surface_emissivity.txt'
        open(97,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_excess_surface_emissivity_err.txt'
        open(98,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_anc_wind.txt'
        open(88,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_land_ice_fractions.txt'
        open(89,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_scat_RFI_flags.txt'
        open(90,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_tot_sigma_TOA.txt'
        open(91,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_KPC_ANT.txt'
        open(92,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
        
        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_KPC_TOA.txt'
        open(93,file=L2_output_file,status='unknown')
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))

        L2_output_file = AQ_SCAT_SIM_DIR_OUT(1:lnblnk(AQ_SCAT_SIM_DIR_OUT)) //  '/' // L2_prefix(1:lnblnk(L2_prefix)) // 
     1                   '_L2_tot_KPC_TOA.txt'
        open(94,file=L2_output_file,status='unknown')        
        write(6,*) 'Writing L2 output file: ',L2_output_file(1:lnblnk(L2_output_file))
                
        do i_blk = block_start, NUM_BLOCKS
  
          write(80,'(i12,f20.10,12e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_sigma_ANT(ii,1,i_blk),ii=1,4),
     $                          (L2_output_sigma_ANT(ii,2,i_blk),ii=1,4),
     $                          (L2_output_sigma_ANT(ii,3,i_blk),ii=1,4)

          write(81,'(i12,f20.10,12e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_sigma_TOA(ii,1,i_blk),ii=1,4),
     $                          (L2_output_sigma_TOA(ii,2,i_blk),ii=1,4),
     $                          (L2_output_sigma_TOA(ii,3,i_blk),ii=1,4)

          write(82,'(i12,f20.10,12e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_sigma_Far(ii,1,i_blk),ii=1,4),
     $                          (L2_output_sigma_Far(ii,2,i_blk),ii=1,4),
     $                          (L2_output_sigma_Far(ii,3,i_blk),ii=1,4)

          write(79,'(i12,f20.10,12e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_sigma_exp(ii,1,i_blk),ii=1,4),
     $                          (L2_output_sigma_exp(ii,2,i_blk),ii=1,4),
     $                          (L2_output_sigma_exp(ii,3,i_blk),ii=1,4)

          write(83,'(i12,f20.10,6e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                         L2_output_beam_clon(1,i_blk), L2_output_beam_clat(1,i_blk),
     $                         L2_output_beam_clon(2,i_blk), L2_output_beam_clat(2,i_blk),
     $                         L2_output_beam_clon(3,i_blk), L2_output_beam_clat(3,i_blk)

          write(84,'(i12,f20.10,24e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_beam_elon(1,ii,i_blk),ii=1,4), (L2_output_beam_elat(1,ii,i_blk),ii=1,4),
     $                          (L2_output_beam_elon(2,ii,i_blk),ii=1,4), (L2_output_beam_elat(2,ii,i_blk),ii=1,4),
     $                          (L2_output_beam_elon(3,ii,i_blk),ii=1,4), (L2_output_beam_elat(3,ii,i_blk),ii=1,4)

          i4_L2_tmp_out_flags_b1(1) = L2_output_scatterometer_flags(1,i_blk)
          i4_L2_tmp_out_flags_b1(2) = 0
          
          i4_L2_tmp_out_flags_b2(1) = L2_output_scatterometer_flags(2,i_blk)
          i4_L2_tmp_out_flags_b2(2) = 0

          i4_L2_tmp_out_flags_b3(1) = L2_output_scatterometer_flags(3,i_blk)
          i4_L2_tmp_out_flags_b3(2) = 0
          
          i1_L2_tmp_out_rfi_flags_b1v(1) = L2_output_scat_rfi_flags(1,1,i_blk)
          i1_L2_tmp_out_rfi_flags_b1v(2) = 0

          i1_L2_tmp_out_rfi_flags_b1h(1) = L2_output_scat_rfi_flags(1,2,i_blk)
          i1_L2_tmp_out_rfi_flags_b1h(2) = 0          

          i1_L2_tmp_out_rfi_flags_b2v(1) = L2_output_scat_rfi_flags(2,1,i_blk)
          i1_L2_tmp_out_rfi_flags_b2v(2) = 0

          i1_L2_tmp_out_rfi_flags_b2h(1) = L2_output_scat_rfi_flags(2,2,i_blk)
          i1_L2_tmp_out_rfi_flags_b2h(2) = 0          
          
          i1_L2_tmp_out_rfi_flags_b3v(1) = L2_output_scat_rfi_flags(3,1,i_blk)
          i1_L2_tmp_out_rfi_flags_b3v(2) = 0

          i1_L2_tmp_out_rfi_flags_b3h(1) = L2_output_scat_rfi_flags(3,2,i_blk)
          i1_L2_tmp_out_rfi_flags_b3h(2) = 0          
          
          write(85,'(i12,f20.10,I20,I20,I20)')  L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                             i8_L2_tmp_out_flags_b1, i8_L2_tmp_out_flags_b2, i8_L2_tmp_out_flags_b3   

          write(86,'(i12,f20.10,3I10)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                             (L2_output_scat_samples(ii,i_blk),ii=1,3)     

          write(87,'(i12,f20.10,3e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                         L2_output_scat_wind_speed(1,i_blk),
     $                         L2_output_scat_wind_speed(2,i_blk),
     $                         L2_output_scat_wind_speed(3,i_blk)

          write(95,'(i12,f20.10,3e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                         L2_output_scat_wind_speed_err(1,i_blk),
     $                         L2_output_scat_wind_speed_err(2,i_blk),
     $                         L2_output_scat_wind_speed_err(3,i_blk)

          write(96,'(i12,f20.10,3e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                         L2_output_faraday_rotation_angle(1,i_blk),
     $                         L2_output_faraday_rotation_angle(2,i_blk),
     $                         L2_output_faraday_rotation_angle(3,i_blk)

          write(99,'(i12,f20.10,3e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                         L2_output_polarization_roll(1,i_blk),
     $                         L2_output_polarization_roll(2,i_blk),
     $                         L2_output_polarization_roll(3,i_blk)

          write(97,'(i12,f20.10,6e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_excess_surf_emiss(ii,1,i_blk),ii=1,2),
     $                          (L2_output_excess_surf_emiss(ii,2,i_blk),ii=1,2),
     $                          (L2_output_excess_surf_emiss(ii,3,i_blk),ii=1,2)

          write(98,'(i12,f20.10,6e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_excess_surf_emiss_err(ii,1,i_blk),ii=1,2),
     $                          (L2_output_excess_surf_emiss_err(ii,2,i_blk),ii=1,2),
     $                          (L2_output_excess_surf_emiss_err(ii,3,i_blk),ii=1,2)

          write(88,'(i12,f20.10,6e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                         L2_output_anc_wind_speed(1,i_blk), L2_output_anc_wind_dir(1,i_blk),
     $                         L2_output_anc_wind_speed(2,i_blk), L2_output_anc_wind_dir(2,i_blk),
     $                         L2_output_anc_wind_speed(3,i_blk), L2_output_anc_wind_dir(3,i_blk)
          
          write(89,'(i12,f20.10,6e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                                (L2_output_land_fraction( ii, i_blk),ii=1,3),
     $                                (L2_output_ice_fraction(  ii, i_blk),ii=1,3)
          
          write(90,'(i12,f20.10,6I10)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $       i2_L2_tmp_out_rfi_flags_b1v, i2_L2_tmp_out_rfi_flags_b2v, i2_L2_tmp_out_rfi_flags_b3v,
     $       i2_L2_tmp_out_rfi_flags_b1h, i2_L2_tmp_out_rfi_flags_b2h, i2_L2_tmp_out_rfi_flags_b3h

          write(91,'(i12,f20.10,3e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                               (L2_output_tot_sigma_TOA(i_beam,i_blk),i_beam=1,3)
          
          write(92,'(i12,f20.10,12e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_KPC_ANT(ii,1,i_blk),ii=1,4),
     $                          (L2_output_KPC_ANT(ii,2,i_blk),ii=1,4),
     $                          (L2_output_KPC_ANT(ii,3,i_blk),ii=1,4)

          write(93,'(i12,f20.10,12e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                          (L2_output_KPC_TOA(ii,1,i_blk),ii=1,4),
     $                          (L2_output_KPC_TOA(ii,2,i_blk),ii=1,4),
     $                          (L2_output_KPC_TOA(ii,3,i_blk),ii=1,4)

          write(94,'(i12,f20.10,3e14.6)') L2_output_icds_blknum( i_blk ), L2_output_time( i_blk ),
     $                               (L2_output_tot_KPC_TOA(i_beam,i_blk),i_beam=1,3)


        enddo
        write (*,*)  i_blk, block_start, NUM_BLOCKS
        close(80)
        close(81)
        close(82)
        close(83)
        close(84)
        close(85)
        close(86)
        close(87)
        close(88)
        close(89)
        close(90)
        close(91)
        close(92)
        close(93)
        close(94)
        close(95)
        close(96)
        close(97)
        close(98)
        close(99)
        close(79)

      endif
      end
