C--$Header: /mnt/caretr2/scatsim/CVSROOT/L1A_to_L2/write_telem_eu.f,v 1.3 2009/10/07 15:46:18 fore Exp $
c*****************************************************************      
      subroutine write_telem_eu( telemetry_out_directory,
     $                           external_temperatures_eu,
     $                           scat_telemetry_eu,
     $                           icds_engineering_telemetry_eu,
     $                           icds_processing_status_eu,     
     $                           blk_sec,     
     $                           RX_power,     
     $                           LB_power,          
     $                           DC_offset,      
     $                           julian_time_0,
     $                           block_start,
     $                           NUM_BLOCKS                      )
c*****************************************************************      
c**   
c**   FILE NAME:
c**   
c**   DATE WRITTEN:
c**   
c**   PROGRAMMER:
c**   
c**   FUNCTIONAL DESCRIPTION:  
c**
c**   ROUTINES CALLED: 
c**   
c**   NOTES: 
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**     
c*****************************************************************   
      implicit none
      include 'L1A.inc'
c     PARAMETER STATEMENTS
      integer stdout, stderr, stdin
      parameter( stdout = 6, stderr = 0, stdin = 5 )
c     INPUT VARIABLES
      character*(*) telemetry_out_directory
      real*4    external_temperatures_eu(      38, MAX_NUM_BLOCKS )
      real*4    scat_telemetry_eu(             38, MAX_NUM_BLOCKS )
      real*4    icds_engineering_telemetry_eu( 24, MAX_NUM_BLOCKS )
      integer*4 icds_processing_status_eu(      4, MAX_NUM_BLOCKS )

      real*8  blk_sec(         MAX_NUM_BLOCKS )

      real*8 RX_power( 6, 3, 8, MAX_NUM_BLOCKS ) ! pol, beam, seq, block
      real*8 LB_power( 6, 3,    MAX_NUM_BLOCKS ) ! pol, beam,      block
      real*8 DC_offset(      2, MAX_NUM_BLOCKS ) ! pol,            block
      
      real*8 julian_time_0
      
      integer block_start
      integer NUM_BLOCKS
      integer lnblnk

c     OUTPUT VARIABLES
c     LOCAL VARIABLES
      real*8 julian_time, block_time
      character*320 filename
      integer i_block, i_seq, i_beam, i_chan, ii
c     DATA STATEMENTS
c     COMMON BLOCKS
c     FUNCTION STATEMENTS
c     PROCESSING STEPS


        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'external_temperatures_eu.txt'
        open(70,file=filename,status='unknown')
        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'scat_telemetry_eu.txt'
        open(71,file=filename,status='unknown')
        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'icds_engineering_telemetry_eu.txt'
        open(72,file=filename,status='unknown')
        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'icds_processing_status_eu.txt'
        open(73,file=filename,status='unknown')
        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'block_time.txt'
        open(74,file=filename,status='unknown')
        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'RX_power.txt'
        open(75,file=filename,status='unknown')
        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'LB_power.txt'
        open(76,file=filename,status='unknown')
        filename = telemetry_out_directory(1:lnblnk(telemetry_out_directory)) // 'DC_offset.txt'
        open(77,file=filename,status='unknown')
        
        do i_block = block_start, NUM_BLOCKS
          block_time = blk_sec(i_block)
          
          julian_time = julian_time_0 + block_time / ( 24.0d0*60.0d0*60.0d0 )
          
          write(70,'(I6,38f12.5)') i_block, 
     $                             (external_temperatures_eu( ii, i_block), ii=1, 38)
          
          write(71,'(I6,38f12.5)') i_block, 
     $                             (scat_telemetry_eu( ii, i_block), ii=1, 38)
     
          write(72,'(I6,38f12.5)') i_block, 
     $                             (icds_engineering_telemetry_eu( ii, i_block), ii=1, 24)
     
          write(73,'(I6,4I12)')    i_block,
     $                             (icds_processing_status_eu( ii, i_block ), ii=1,4)
          
          write(74,'(I6,f24.10)') i_block, julian_time
          
          
          write(77,'(I6,2f12.6)') i_block, DC_offset(1,i_block), DC_offset(2,i_block)
          
          do i_seq = 1, 8
            do i_beam = 1, 3
              write(75,'(3I6,6f12.5)') i_block, i_seq, i_beam, 
     $                               (RX_power(i_chan,i_beam,i_seq,i_block),i_chan=1,6)
              
              if( i_seq .eq. 1)then
                write(76,'(2I6,6f12.5)') i_block, i_beam,
     $                                   (LB_power(i_chan,i_beam,i_block),i_chan=1,6)
              endif
            enddo
          enddo
        enddo
        
        close(70)
        close(71)
        close(72)
        close(73)
        close(74)
        close(75)
        close(76)
        close(77)
        
        write(6,*) 'Converted L0 telemetry has been written out...'


      end
