!     sss climatology
!     derived from Aquarius
!     V7.6
!     HH wind speeds
!     include updated DEW(SST)
!     whole AQ period 
!     see make_AQ_HH_monthly_SSS_map_V50.f90

subroutine fd_aq_sss_clm(imon,xlat,xlon, staticdata, sss) 

use static_data_module
  
implicit none                                 
      
integer(4), intent(in) :: imon 
real(4), intent(in)    :: xlon, xlat
type(static_data_struct), intent(in)    :: staticdata
real(4), intent(out)   :: sss

integer(4), parameter                       ::  mmonth=12
integer(4), parameter                       ::  ires=2
integer(4), parameter                       ::  mlat=180/ires, mlon=360/ires
real(4), parameter                                  ::  blat=float(ires), blon=float(ires)
real(4), parameter                                  ::  lat0=-90.0, lon0=0.0

integer(4)       :: ilat, ilon

ilat = floor((xlat-lat0)/blat) + 1
if (ilat < 1)     ilat=1
if (ilat > mlat)  ilat=mlat                             
ilon = floor((xlon-lon0)/blon) + 1
if (ilon < 1)     ilon=1
if (ilon > mlon)  ilon=mlon       
 
sss= staticdata%climate_sal(imon,ilon,ilat)
                                                                            
return                                                            
end subroutine fd_aq_sss_clm 

