!//
!//  test1 - vegetation opacity.cpp
!//
!//  Yan Soldo, 7/3/15.
!//
!
!#include "test1 - vegetation opacity.h"

!subroutine fd_tausq(idayjl,xlat,xlon,tht, itau, tausq)
subroutine fd_gammasq(idayjl,xlat,xlon,tht, gamma_squared, land_roughness, albedo)


! INITIALIZE VARIABLES
integer(4), intent(in)  :: idayjl
real(4)   , intent(in)  :: xlat,xlon,tht   ! INPUT
character*320           :: read_ancillary_dir    ! INPUT. Folder with NDVI products
Integer*4                                 :: i, j, ii, jj
Byte                                      :: lct
Integer*4                                 :: yy, mm, dd, jd, nyr, doy, ddy
Real                                      :: mdv, ndv, nndv, vwc, bfac, ft, ntau, minndvi, hr
Integer*2, Dimension(7200)                :: ndv1d
Integer*2, Dimension(7200,3600)           :: ndv2d, nndv2d, mdv2d, minndvi2d
Byte, Dimension(7200)                     :: lct1d
Byte, Dimension(7200,3600)                :: lct2d
Byte, Dimension(7200)                     :: rough1d
Byte, Dimension(7200,3600)                :: rough2d
Integer*2, Dimension(7200)                :: albedo1d
Integer*2, Dimension(7200,3600)           :: albedo2d

character inyr*4,indt*3,inff*26,ser0*4,ser*4,mmstr*2,tend*1,nser0*4,nser*4
integer i_len             ! typically used to hold the length of a string
Integer                                   :: hdferr ! Error flag.
Real                    :: gamma_squared   ! OUTPUT
Real                    :: land_roughness   ! OUTPUT
Real                    :: albedo   ! OUTPUT
Integer*2               :: first=1
real(4) xlon180

save first, lct2d, mdv2d, minndvi2d, ndv2d, nndv2d, rough2d, albedo2d

if (first.eq.1) then

   call getenv('OCDATAROOT', read_ancillary_dir)
   read_ancillary_dir = read_ancillary_dir(1:lnblnk(read_ancillary_dir)) // '/aquarius/radiometer/soil_moisture'

   ! READ LAND COVER (lct2d)
   write(*,*) 'Reading land cover ...'
   open(1,file=read_ancillary_dir(1:lnblnk(read_ancillary_dir))//'/Aquarius_land_cover_5km.dat', &
        convert='little_endian',status='old',form='unformatted',access='direct',recl=7200)
   do i=1,3600
      read(1,rec=i) lct1d
      do j=1,7200
         lct2d(j,i) = lct1d(j)
      end do
   end do
   close(1)
   write(*,*) 'Reading land cover is done.'


   ! READ NDVI MAX (mdv2d)
   write(*,*) 'Reading MODIS/NDVI max ...'
   open(4,file=read_ancillary_dir(1:lnblnk(read_ancillary_dir))//'/ndvi_max.dat', &
        convert='little_endian',status='old',form='unformatted',access='direct',recl=14400)
   do ii=1,3600
      read(4,rec=ii) ndv1d
      do jj=1,7200
         mdv2d(jj,ii)=ndv1d(jj)
      enddo
   enddo
   close(4)
   write(*,*) 'Reading MODIS/NDVI max is done.'


   ! READ NDVI MIN (minndvi2d)
   write(*,*) 'Reading MODIS/NDVI min ...'
   open(4,file=read_ancillary_dir(1:lnblnk(read_ancillary_dir))//'/ndvi_min.dat', &
        convert='little_endian',status='old',form='unformatted',access='direct',recl=14400)
   do ii=1,3600
      read(4,rec=ii) ndv1d
      do jj=1,7200
        minndvi2d(jj,ii)=ndv1d(jj)
     enddo
  enddo
  close(4)
  write(*,*) 'Reading MODIS/NDVI min is done.'

   ! READ LAND ROUGHNESS
   write(*,*) 'Reading Land roughness parameter ...'
   open(4,file=read_ancillary_dir(1:lnblnk(read_ancillary_dir))//'/land_roughness.dat', &
        status='old',form='unformatted',access='direct',recl=7200)
   do ii=1,3600
      read(4,rec=ii) rough1d
      do jj=1,7200
        rough2d(jj,ii)=rough1d(jj)
     enddo
  enddo
  close(4)
  write(*,*) 'Reading Land roughness parameter is done.'

   ! READ SS ALBEDO
   write(*,*) 'Reading single scattering albedo parameter ...'
   open(4,file=read_ancillary_dir(1:lnblnk(read_ancillary_dir))//'/single-scattering_albedo.dat', &
        status='old',form='unformatted',access='direct',recl=14400)
   do ii=1,3600
      read(4,rec=ii) albedo1d
      do jj=1,7200
        albedo2d(jj,ii)=albedo1d(jj)
     enddo
  enddo
  close(4)
  write(*,*) 'Reading single scattering albedo is done.'

endif

nyr = idayjl / 1000
doy = idayjl - 1000 * nyr

jd=jday(nyr,1,doy)
call gdate(jd-4,yy,mm,dd)
if (mm.eq.1) mmstr='01'
if (mm.eq.2) mmstr='02'
if (mm.eq.3) mmstr='03'
if (mm.eq.4) mmstr='04'
if (mm.eq.5) mmstr='05'
if (mm.eq.6) mmstr='06'
if (mm.eq.7) mmstr='07'
if (mm.eq.8) mmstr='08'
if (mm.eq.9) mmstr='09'
if (mm.eq.10) mmstr='10'
if (mm.eq.11) mmstr='11'
if (mm.eq.12) mmstr='12'

! tend SERVES TO LOAD THE CORRESPONDING NDVI FILE
! ddy (0 <= ddy <= 9) IS ONLY USED FOR THE FINAL EXPRESSION OF ndv. IT IS THE WEIGHT BETWEEN THE TWO SETS OF  NDVI
if (dd.le.10) then
    tend='1'
    ddy=dd-1
endif
if (dd.gt.10.and.dd.le.20) then
    tend='2'
    ddy=dd-11
endif
if (dd.gt.20) then
    tend='3'
    ddy=dd-21
endif


! READ THE 'PREVIOUS' NDVI FILE (ndv2d)
ser0='00_0'
ser=mmstr//'_'//tend
if (ser0.ne.ser.and.first.eq.1) then
write(*,*) 'Reading MODIS/NDVI '//ser//' ...'
    open(4,file=read_ancillary_dir(1:lnblnk(read_ancillary_dir))//'/ndvi_cmg_'//ser//'.dat', &
                convert='little_endian',status='old',form='unformatted',access='direct',recl=14400)
    do ii=1,3600
        read(4,rec=ii) ndv1d
        do jj=1,7200
            ndv2d(jj,ii)=ndv1d(jj)
        enddo
    enddo
    close(4)

    write(*,*) 'Reading MODIS/NDVI is done.'
endif
ser0=ser


! READ THE DATE OF THE AQ PRODUCT AGAIN, IN ORDER TO LOAD THE 'NEXT' NDVI FILE

jd=jday(nyr,1,doy)
call gdate(jd+6,yy,mm,dd)   ! SETS THE DATE TO 6 DAYS AFTER
if (mm.eq.1) mmstr='01'
if (mm.eq.2) mmstr='02'
if (mm.eq.3) mmstr='03'
if (mm.eq.4) mmstr='04'
if (mm.eq.5) mmstr='05'
if (mm.eq.6) mmstr='06'
if (mm.eq.7) mmstr='07'
if (mm.eq.8) mmstr='08'
if (mm.eq.9) mmstr='09'
if (mm.eq.10) mmstr='10'
if (mm.eq.11) mmstr='11'
if (mm.eq.12) mmstr='12'

if (dd.le.10) tend='1'
if (dd.gt.10.and.dd.le.20) tend='2'
if (dd.gt.20) tend='3'


! READ THE 'NEXT' NDVI FILE (nndv2d)
nser0='00_0'
nser=mmstr//'_'//tend
if (nser0.ne.nser.and.first.eq.1) then
    write(*,*) 'Reading MODIS/NDVI '//nser//' ...'
    open(4,file=read_ancillary_dir(1:lnblnk(read_ancillary_dir))//'/ndvi_cmg_'//nser//'.dat', &
                convert='little_endian',status='old',form='unformatted',access='direct',recl=14400)
    do ii=1,3600
        read(4,rec=ii) ndv1d
        do jj=1,7200
            nndv2d(jj,ii)=ndv1d(jj)
        enddo
    enddo
    close(4)
    write(*,*) 'Reading MODIS/NDVI is done.'
endif
nser0=nser

first = 0

! default parameters:
!bfac  = 0.12
ntau  = 0.0

! COMPUTES THE OPTICAL THICKNESS OF VEGETATION

xlon180 = xlon
if (xlon.gt.180) xlon180 = xlon - 360

if ((xlat.le.90).and.(xlat.ge.-90).and.(xlon180.le.180).and.(xlon180.ge.-180)) then


    ! Byte is really signed char integer so value about 128 are wrapped
    land_roughness = rough2d(int((xlon180+180)/0.05)+1,int((90-xlat)/0.05)+1) * 0.001
    if (land_roughness .lt. 0) land_roughness = land_roughness + 0.256

    albedo = albedo2d(int((xlon180+180)/0.05)+1,int((90-xlat)/0.05)+1) * 0.001
!    if (albedo .gt. 0) write(*,*) xlon180, xlat, albedo

    lct   = lct2d(int((xlon180+180)/0.05)+1,int((90-xlat)/0.05)+1)

    ft=0.0        ! STEM FACTOR
    if (lct.eq.1) ft=15.96
    if (lct.eq.2) ft=19.15
    if (lct.eq.3) ft=7.98
    if (lct.eq.4) ft=12.77
    if (lct.eq.5) ft=12.77
    if (lct.eq.6) ft=3.0
    if (lct.eq.7) ft=1.5
    if (lct.eq.8) ft=4.0
    if (lct.eq.9) ft=3.0
    if (lct.eq.10) ft=1.5
    if (lct.eq.11) ft=4.0
    if (lct.eq.12) ft=3.5
    if (lct.eq.13) ft=6.49
    if (lct.eq.14) ft=3.25
    if (lct.eq.15) ft=0.0
    if (lct.eq.16) ft=0.0
    if ((lct.eq.7).or.(lct.eq.10).or.(lct.eq.16)) hr=0.3

!    bfac=0.0        ! "b" factor (from table 3 in the SMAP L2&3 passive ATBD, version 4.0)
    if (lct.eq.1) bfac=0.1
    if (lct.eq.2) bfac=0.1
    if (lct.eq.3) bfac=0.12
    if (lct.eq.4) bfac=0.12
    if (lct.eq.5) bfac=0.11
    if (lct.eq.6) bfac=0.11
    if (lct.eq.7) bfac=0.11
    if (lct.eq.8) bfac=0.11
    if (lct.eq.9) bfac=0.11
    if (lct.eq.10) bfac=0.13
    if (lct.eq.11) bfac=0.0
    if (lct.eq.12) bfac=0.11
    if (lct.eq.13) bfac=0.1
    if (lct.eq.14) bfac=0.11
    if (lct.eq.15) bfac=0.0
    if (lct.eq.16) bfac=0.0
!    if ((lct.eq.7).or.(lct.eq.10).or.(lct.eq.16)) bfac=0.13

    !  if (ft.lt.2.0) bfac=0.1

    ndv   = ndv2d(int((xlon180+180)/0.05)+1,int((90-xlat)/0.05)+1)*0.0001        ! FIRST SET OF NDVI
    nndv  = nndv2d(int((xlon180+180)/0.05)+1,int((90-xlat)/0.05)+1)*0.0001       ! SECOND SET OF NDVI
    mdv   = mdv2d(int((xlon180+180)/0.05)+1,int((90-xlat)/0.05)+1)*0.0001        ! = max NDVI. ONLY USED FOR THE vwc
    minndvi = minndvi2d(int((xlon180+180)/0.05)+1,int((90-xlat)/0.05)+1)*0.0001  ! = min NDVI. ONLY USED AS LOWER LIMIT OF ndv AND nndv

    if (ndv.lt.minndvi) ndv=minndvi
    if (nndv.lt.minndvi) nndv=minndvi

! INTERPOLATE THE NDVI BETWEEN THE TWO FILES LOADED (ndv AND nndv), USING ddy [0,9] AS THE WEIGHT BETWEEN THE TWO
    ndv=ndv+(nndv-ndv)*ddy/10.0

    if (lct.le.5) ft=ft/2.0

    vwc   = 1.9134*ndv*ndv-0.3215*ndv+ft*(mdv-0.1)/0.9        ! SEE PATTON ND HORNBUCKLE, 2014


    if ((lct.eq.10).or.(lct.eq.12).or.(lct.eq.14)) vwc=1.9134*ndv*ndv-0.3215*ndv+ft*(ndv-0.1)/0.9  ! USE ndv INSTEAD OF mdv.
    if (vwc.lt.0) vwc=0.0

    ntau=vwc*bfac

! gamma_squared replaces the tausq in the Aq-SSS code
! tht is the incidence angle
    gamma_squared=exp(-2*ntau/cos(tht*3.14159265359/180))

else
    lct=255
    ndv=-999.0
    mdv=-999.0
    vwc=-999.0
endif

if (ndv.lt.0) then
    vwc=-999.0
    ntau=-999.0
    gamma_squared=-999
endif

Return
end







!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

Integer Function jday (Year,Month,Day)
    ! computes the Julian date given a gregorian calendar date (year,month,day)
    Integer Year,Month,Day,Yi,Mj,Dk
    Yi= Year
    Mj= Month
    Dk= Day
    jday= Dk-32075+1461*(Yi+4800+(Mj-14)/12)/4+367*(Mj-2-(Mj-14)/12*12)/12-3*((Yi+4900+(Mj-14)/12)/100)/4
    Return
End Function jday

Subroutine gdate (Julianday, Year,Month,Day)
    ! computes the gregorian calendar date (year,month,day) given the julian date
    Integer Julianday,Year,Month,Day,Yi,Mj,Dk
    L= Julianday+68569
    N= 4*L/146097
    L= L-(146097*N+3)/4
    Yi= 4000*(L+1)/1461001
    L= L-1461*Yi/4+31
    Mj= 80*L/2447
    Dk= L-2447*Mj/80
    L= Mj/11
    Mj= Mj+2-12*L
    Yi= 100*(N-49)+Yi+L
    Year= Yi
    Month= Mj
    Day= Dk
    Return
End Subroutine gdate

