

      ! This routine implements a nearest neighbor interpolation
      ! in order to replace the fill values in the SM ancillary data files.
      ! This is to avoid having sharp changes of SM near the coastlines
      !
      ! Yan Soldo, 8/12/15
      !

      subroutine interp_sm(sm_in,sm_out)
       real, dimension(360,181), intent(in) :: sm_in
       real, dimension(360,181), intent(out) :: sm_out
       integer :: k1,j1,k2,j2,k,j
       real :: s

       sm_out = sm_in
       do k1 = 1,360
        do j1 = 2,180

           if (sm_in(k1,j1) .gt. 1) then

            ! nearest neighbor interpolation

              n = 0
              s = 0.0
              do k2 = -1,1
                 k = k1+k2
                 if (k.gt.360) k = 1
                 if (k.lt.1) k = 360
                 do j2 = -1,1
                    j = j1+j2   
                    if (sm_in(k,j) .le. 1) then
                       n = n+1
                       s = s+sm_in(k,j)
                    endif
                 end do
              end do

              if (n.ge.1) sm_out(k1,j1) = (s/n)
         endif

      end do
      end do

      return
      end 



