        subroutine printMatrix(matrix, n,m)

        integer m,n,i,j
        real*8 matrix(n,m)

        do i=1,n
           write(*,*) '{',matrix(i,1),',',matrix(i,2),',',matrix(i,3),',',matrix(i,4),'}'
        end do 

        return
        end



        subroutine null_matrix(n,m,matrix)

        integer i,j,n,m
        real*8  matrix(n,m)

        do i=1,n
           do j=1,m
              matrix(i,j)= 0.0d0
           end do
        end do


        return
        end

        subroutine Muller_matrix_ocean_scattering(r_sig0, matrix)

        real*8  matrix(4,4),r_sig0(9)


        matrix(1,1)= r_sig0(3)
        matrix(1,2)= r_sig0(2)
        matrix(1,3)= r_sig0(8)
        matrix(1,4)= r_sig0(9)
        matrix(2,1)= r_sig0(2)
        matrix(2,2)= r_sig0(1)
        matrix(2,3)= r_sig0(6)
        matrix(2,4)= r_sig0(7)
        matrix(3,1)= 2.0d0*r_sig0(8)
        matrix(3,2)= 2.0d0*r_sig0(6)
        matrix(3,3)= r_sig0(4) + r_sig0(2)
        matrix(3,4)= -r_sig0(5)
        matrix(4,1)= 2.0d0*r_sig0(9)
        matrix(4,2)= 2.0d0*r_sig0(7)
        matrix(4,3)= r_sig0(5)
        matrix(4,4)= r_sig0(4) - r_sig0(2)


        return
        end


        subroutine complex_multiplication(a1,b1,a2,b2,a,b)
        real*8 a1,b1,a2,b2,a,b

        a=a1*a2-b1*b2
        b=a2*b1+b2*a1

        return
        end



        subroutine Muller_matrix_antenna_gain(real_ghh,imag_ghh ,real_gvh,imag_gvh,real_gvv,imag_gvv,real_ghv,imag_ghv ,matrix)

        real*8 matrix(4,4),real_ghh,imag_ghh ,real_ghv,imag_ghv,real_gvv,imag_gvv,real_gvh,imag_gvh 
        real*8  real_gvhvv, imag_gvhvv, real_ghhhv, imag_ghhhv, real_gvhhv, imag_gvhhv
        real*8 real_gvvhv, imag_gvvhv, real_gvhhh, imag_gvhhh, real_gvvhh, imag_gvvhh


        call complex_multiplication(real_gvh,imag_gvh,real_gvv,-imag_gvv, real_gvhvv, imag_gvhvv)
        call complex_multiplication(real_ghh,imag_ghh,real_ghv,-imag_ghv, real_ghhhv, imag_ghhhv)
        call complex_multiplication(real_gvv,imag_gvv,real_ghv,-imag_ghv, real_gvvhv, imag_gvvhv)
        call complex_multiplication(real_gvh,imag_gvh,real_ghh,-imag_ghh, real_gvhhh, imag_gvhhh)
        call complex_multiplication(real_gvv,imag_gvv,real_ghh,-imag_ghh, real_gvvhh, imag_gvvhh)
        call complex_multiplication(real_gvh,imag_gvh,real_ghv,-imag_ghv, real_gvhhv, imag_gvhhv)



        matrix(1,1)= real_gvv**2 + imag_gvv**2
        matrix(1,2)= real_gvh**2 + imag_gvh**2
        matrix(1,3)= real_gvhvv
        matrix(1,4)= imag_gvhvv
        matrix(2,1)= real_ghv**2 + imag_ghv**2
        matrix(2,2)= real_ghh**2 + imag_ghh**2
        matrix(2,3)= real_ghhhv
        matrix(2,4)= imag_ghhhv
        matrix(3,1)= 2.0d0 * real_gvvhv
        matrix(3,2)= 2.0d0 * real_gvhhh 
        matrix(3,3)= real_gvvhh + real_gvhhv
        matrix(3,4)= -(imag_gvvhh - imag_gvhhv)
        matrix(4,1)= 2.0d0 * imag_gvvhv
        matrix(4,2)= 2.0d0 * imag_gvhhh 
        matrix(4,3)= imag_gvvhh + imag_gvhhv
        matrix(4,4)= real_gvvhh - real_gvhhv

        return
        end





        subroutine Muller_matrix_polarization_roll(tita, matrix)
        real*8 tita, matrix(4,4)
        matrix(1,1)= dcos(tita)**2
        matrix(1,2)= dsin(tita)**2
        matrix(1,3)= dcos(tita)*dsin(tita)
        matrix(1,4)= 0.0d0
        matrix(2,1)= dsin(tita)**2
        matrix(2,2)= dcos(tita)**2
        matrix(2,3)= -dcos(tita)*dsin(tita)
        matrix(2,4)= 0.0d0
        matrix(3,1)= -2.0d0*dcos(tita)*dsin(tita)
        matrix(3,2)= 2.0d0*dcos(tita)*dsin(tita)
        matrix(3,3)= dcos(2.0d0*tita)
        matrix(3,4)= 0.0d0 
        matrix(4,1)= 0.0d0
        matrix(4,2)= 0.0d0
        matrix(4,3)= 0.0d0
        matrix(4,4)= 1.0d0
        return
        end
        
c*****************************************************************      
      subroutine Muller_matrix_polarization_basis(h_beam, v_beam, 
     $ h_ground, v_ground, matrix_tx, matrix_rx)
c*****************************************************************      
c**   
c**   FILE NAME: aquarius_geometry_subroutines.f
c**   
c**   DATE WRITTEN: 10/17/2008
c**   
c**   PROGRAMMER: Alex Fore
c**   
c**   FUNCTIONAL DESCRIPTION:  Computes the Mueller matrix for the
c**    polarization change of basis from the beam coordinates 
c**    (h_beam, v_beam) on transmit to the ground coordinates 
c**    (v_ground, h_ground).  Then it computes the Mueller
c**    matrix for the inverse conversion on receive.
c**
c**   ROUTINES CALLED: compute_dot_product
c**   
c**   NOTES: 
c*****************************************************************
      implicit none
c     PARAMETER STATEMENTS
c     INPUT VARIABLES
      real*8 h_beam(3),         ! h-pol beam basis vector
     $ v_beam(3),               ! v-pol beam basis vector
     $ h_ground(3),                     ! h-pol ground basis vector
     $ v_ground(3)                      ! v-pol ground basis vector
                                        ! ground basis is orthonormal.
                                        ! beam basis is not!

c     OUTPUT VARIABLES
      real*8 matrix_tx(4,4), matrix_rx(4,4)
      
c     LOCAL VARIABLES
      real*8 det, S_vv, S_vh, S_hv, S_hh
      
c     DATA STATEMENTS
c     FUNCTION STATEMENTS
      real*8 compute_dot_product
      
c     PROCESSING STEPS

c  Change of polarization basis on transmit is simple since we
c   can just project onto an orthonormal basis.
      S_vv = compute_dot_product( v_beam, v_ground )
      S_vh = compute_dot_product( h_beam, v_ground )
      S_hv = compute_dot_product( v_beam, h_ground )
      S_hh = compute_dot_product( h_beam, h_ground )
      
C Conversion from scattering matrix to mueller matrix
      matrix_tx(1,1) = S_vv**2
      matrix_tx(1,2) = S_vh**2
      matrix_tx(1,3) = S_vv * S_vh
      matrix_tx(1,4) = 0.0d0
      
      matrix_tx(2,1) = S_hv**2
      matrix_tx(2,2) = S_hh**2
      matrix_tx(2,3) = S_hv * S_hh
      matrix_tx(2,4) = 0.0d0
      
      matrix_tx(3,1) = 2 * S_vv * S_hv
      matrix_tx(3,2) = 2 * S_vh * S_hh
      matrix_tx(3,3) = S_vv * S_hh + S_hv * S_vh
      matrix_tx(3,4) = 0.0d0
      
      matrix_tx(4,1) = 0.0d0
      matrix_tx(4,2) = 0.0d0
      matrix_tx(4,3) = 0.0d0
      matrix_tx(4,4) = S_vv * S_hh - S_hv * S_vh

C  Change of polarization basis on recieve is more complicated
C   so we use the 2x2 matrix inverse formula.
      
C  Add small number to determinant avoid division by zero.      
      det = S_vv * S_hh - S_hv * S_vh + 1.0d-16
      
      S_vv =   compute_dot_product(h_beam, h_ground) / det
      S_vh = - compute_dot_product(h_beam, v_ground) / det
      S_hv = - compute_dot_product(v_beam, h_ground) / det
      S_hh =   compute_dot_product(v_beam, v_ground) / det

      matrix_rx(1,1) = S_vv**2
      matrix_rx(1,2) = S_vh**2
      matrix_rx(1,3) = S_vv * S_vh
      matrix_rx(1,4) = 0.0d0
      
      matrix_rx(2,1) = S_hv**2
      matrix_rx(2,2) = S_hh**2
      matrix_rx(2,3) = S_hv * S_hh
      matrix_rx(2,4) = 0.0d0
      
      matrix_rx(3,1) = 2 * S_vv * S_hv
      matrix_rx(3,2) = 2 * S_vh * S_hh
      matrix_rx(3,3) = S_vv * S_hh + S_hv * S_vh
      matrix_rx(3,4) = 0.0d0
      
      matrix_rx(4,1) = 0.0d0
      matrix_rx(4,2) = 0.0d0
      matrix_rx(4,3) = 0.0d0
      matrix_rx(4,4) = S_vv * S_hh - S_hv * S_vh
      end

        subroutine matrix_multiplication_by_vector(matrixA,n,m, vectorA, vector)

        integer i,j,k,n,m
        real*8 matrixA(n,m),vectorA(m), vector(n)

        do i=1,n
           vector(i)=0.0d0
           do j=1,m
              vector(i)= vector(i) + matrixA(i,j) * vectorA(j)
           end do
        end do

        return
        end


    

        subroutine matrix_multiplication(matrixA,na,m, matrixB,nb, matrix)

        integer i,j,k,na,nb,m
        real*8 matrixA(m,na),matrixB(nb,m), matrix(nb,na)

        do k=1,na
           do i=1,nb
              matrix(i,k)=0.0d0
              do j=1,m
                 matrix(i,k)= matrix(i,k) +  matrixB(i,j) * matrixA(j,k)
              end do
           end do
        end do

        return
        end


      subroutine mat_mult_4x4(A,B,C)
C     C(i,k) = sum( B(i,j) * A(j,k) ) over j=1,4
      implicit none
      real*8 C(4,4), A(4,4), B(4,4)
      
      C(1,1) = B(1,1)*A(1,1) + B(1,2)*A(2,1) + B(1,3)*A(3,1) + B(1,4)*A(4,1)
      C(2,1) = B(2,1)*A(1,1) + B(2,2)*A(2,1) + B(2,3)*A(3,1) + B(2,4)*A(4,1)
      C(3,1) = B(3,1)*A(1,1) + B(3,2)*A(2,1) + B(3,3)*A(3,1) + B(3,4)*A(4,1)
      C(4,1) = B(4,1)*A(1,1) + B(4,2)*A(2,1) + B(4,3)*A(3,1) + B(4,4)*A(4,1)
      
      C(1,2) = B(1,1)*A(1,2) + B(1,2)*A(2,2) + B(1,3)*A(3,2) + B(1,4)*A(4,2)
      C(2,2) = B(2,1)*A(1,2) + B(2,2)*A(2,2) + B(2,3)*A(3,2) + B(2,4)*A(4,2)
      C(3,2) = B(3,1)*A(1,2) + B(3,2)*A(2,2) + B(3,3)*A(3,2) + B(3,4)*A(4,2)
      C(4,2) = B(4,1)*A(1,2) + B(4,2)*A(2,2) + B(4,3)*A(3,2) + B(4,4)*A(4,2)
      
      C(1,3) = B(1,1)*A(1,3) + B(1,2)*A(2,3) + B(1,3)*A(3,3) + B(1,4)*A(4,3)
      C(2,3) = B(2,1)*A(1,3) + B(2,2)*A(2,3) + B(2,3)*A(3,3) + B(2,4)*A(4,3)
      C(3,3) = B(3,1)*A(1,3) + B(3,2)*A(2,3) + B(3,3)*A(3,3) + B(3,4)*A(4,3)
      C(4,3) = B(4,1)*A(1,3) + B(4,2)*A(2,3) + B(4,3)*A(3,3) + B(4,4)*A(4,3)
      
      C(1,4) = B(1,1)*A(1,4) + B(1,2)*A(2,4) + B(1,3)*A(3,4) + B(1,4)*A(4,4)
      C(2,4) = B(2,1)*A(1,4) + B(2,2)*A(2,4) + B(2,3)*A(3,4) + B(2,4)*A(4,4)
      C(3,4) = B(3,1)*A(1,4) + B(3,2)*A(2,4) + B(3,3)*A(3,4) + B(3,4)*A(4,4)
      C(4,4) = B(4,1)*A(1,4) + B(4,2)*A(2,4) + B(4,3)*A(3,4) + B(4,4)*A(4,4)
      
      return
      end


        subroutine matrix_multiplication_by_scalar(matrixA,n,m,scalar, matrix)

        integer i,j,n,m
        real*8 matrixA(n,m), matrix(n,m), scalar

        do j=1,m
           do i=1,n
              matrix(i,j)= scalar * matrixA(i,j)
           end do
        end do
        
        return
        end


        subroutine matrix_sum(matrixA,matrixB,n,m, matrix)

        integer i,j,n,m
        real*8 matrixA(n,m), matrixB(n,m), matrix(n,m)

        do j=1,m
           do i=1,n
              matrix(i,j)=  matrixA(i,j) + matrixB(i,j)
           end do
        end do
        
        return
        end






        subroutine transpose(matrix)


        real*8 matrix(3,3), temp_matrix(3,3)
        

        temp_matrix(1,1)= matrix(1,1)
        temp_matrix(1,2)= matrix(2,1)
        temp_matrix(1,3)= matrix(3,1)
        temp_matrix(2,1)= matrix(1,2)
        temp_matrix(2,2)= matrix(2,2)
        temp_matrix(2,3)= matrix(3,2)
        temp_matrix(3,1)= matrix(1,3)
        temp_matrix(3,2)= matrix(2,3)
        temp_matrix(3,3)= matrix(3,3)


        matrix(1,1)= temp_matrix(1,1)
        matrix(1,2)= temp_matrix(1,2)
        matrix(1,3)= temp_matrix(1,3)
        matrix(2,1)= temp_matrix(2,1)
        matrix(2,2)= temp_matrix(2,2)
        matrix(2,3)= temp_matrix(2,3)
        matrix(3,1)= temp_matrix(3,1)
        matrix(3,2)= temp_matrix(3,2)
        matrix(3,3)= temp_matrix(3,3)



        return
        end

        subroutine identity(m,matrix)

        integer i,j,m
        real*8  matrix(m,m)

        do j=1,m
              do i=1,m
              if(i.eq.j) then
                 matrix(i,j)= 1.0d0
              else
                 matrix(i,j)= 0.0d0
              endif
           end do
        end do


        return
        end

        subroutine compute_beam_rotations_nadirfixed(beam, beam_rot_VPol, beam_rot_HPol)
C--Updated to use new beam pointing 6/10/2009
C--These rotation matricies correct just the nadir angle of the perturbations
C--introduced in the operational simulation.
        integer beam  
        real*8  beam_rot_VPol(3,3), beam_rot_HPol(3,3) 


        if(beam.eq.2) then
       beam_rot_VPol(1,1)=0
       beam_rot_VPol(1,2)=0
       beam_rot_VPol(1,3)=0
       beam_rot_VPol(2,1)=0
       beam_rot_VPol(2,2)=0
       beam_rot_VPol(2,3)=0
       beam_rot_VPol(3,1)=0
       beam_rot_VPol(3,2)=0
       beam_rot_VPol(3,3)=0

       beam_rot_HPol(1,1) =  0.222759989179250
       beam_rot_HPol(1,2) = -0.964201247148427
       beam_rot_HPol(1,3) =  0.143851657683456
       beam_rot_HPol(2,1) =  0.974861044161070
       beam_rot_HPol(2,2) =  0.219607792424069
       beam_rot_HPol(2,3) = -0.037624552938426
       beam_rot_HPol(3,1) =  0.004687748178326
       beam_rot_HPol(3,2) =  0.148618636653596
       beam_rot_HPol(3,3) =  0.988882633458715
        else if(beam.eq.3) then
       beam_rot_VPol(1,1) = 0
       beam_rot_VPol(1,2) = 0
       beam_rot_VPol(1,3) = 0
       beam_rot_VPol(2,1) = 0
       beam_rot_VPol(2,2) = 0
       beam_rot_VPol(2,3) = 0
       beam_rot_VPol(3,1) = 0
       beam_rot_VPol(3,2) = 0
       beam_rot_VPol(3,3) = 0

       beam_rot_HPol(1,1) = -0.095000233881737
       beam_rot_HPol(1,2) = -0.993579859244883
       beam_rot_HPol(1,3) = -0.061481913318740
       beam_rot_HPol(2,1) =  0.988514834311673
       beam_rot_HPol(2,2) = -0.086858439665361
       beam_rot_HPol(2,3) = -0.123698655225773
       beam_rot_HPol(3,1) =  0.117561600318997
       beam_rot_HPol(3,2) = -0.072527283383849
       beam_rot_HPol(3,3) =  0.990417574912418
        else
       beam_rot_VPol(1,1)=0
       beam_rot_VPol(1,2)=0
       beam_rot_VPol(1,3)=0
       beam_rot_VPol(2,1)=0
       beam_rot_VPol(2,2)=0
       beam_rot_VPol(2,3)=0
       beam_rot_VPol(3,1)=0
       beam_rot_VPol(3,2)=0
       beam_rot_VPol(3,3)=0

       beam_rot_HPol(1,1) = -0.142280023921603
       beam_rot_HPol(1,2) = -0.985510013807851
       beam_rot_HPol(1,3) = -0.092369815834597
       beam_rot_HPol(2,1) =  0.981678393203006
       beam_rot_HPol(2,2) = -0.152441181786321
       beam_rot_HPol(2,3) =  0.114317952282019
       beam_rot_HPol(3,1) = -0.126744032455586 
       beam_rot_HPol(3,2) = -0.074412393342748
       beam_rot_HPol(3,3) =  0.989145093934101
        endif


        return
        end

        subroutine compute_beam_rotations(beam, beam_rot_VPol, beam_rot_HPol)
C--Updated to use new beam pointing 6/10/2009
        integer beam  
        real*8  beam_rot_VPol(3,3), beam_rot_HPol(3,3) 


        if(beam.eq.2) then
       beam_rot_VPol(1,1)=0.97488
       beam_rot_VPol(1,2)=0.22067
       beam_rot_VPol(1,3)=-0.03026
       beam_rot_VPol(2,1)=-0.22272
       beam_rot_VPol(2,2)=0.96419
       beam_rot_VPol(2,3)=-0.14401
       beam_rot_VPol(3,1)=-0.00260
       beam_rot_VPol(3,2)=0.14713
       beam_rot_VPol(3,3)=0.98911

       beam_rot_HPol(1,1)=0.22276
       beam_rot_HPol(1,2)=-0.96420
       beam_rot_HPol(1,3)=0.14386
       beam_rot_HPol(2,1)=0.97487
       beam_rot_HPol(2,2)=0.22064
       beam_rot_HPol(2,3)=-0.03072
       beam_rot_HPol(3,1)=-0.00212
       beam_rot_HPol(3,2)=0.14709
       beam_rot_HPol(3,3)=0.98912
        else if(beam.eq.3) then
       beam_rot_VPol(1,1)=0.98765
       beam_rot_VPol(1,2)=-0.08634
       beam_rot_VPol(1,3)=-0.13076
       beam_rot_VPol(2,1)=0.09501
       beam_rot_VPol(2,2)=0.99357
       beam_rot_VPol(2,3)=0.06164
       beam_rot_VPol(3,1)=0.12460
       beam_rot_VPol(3,2)=-0.07331
       beam_rot_VPol(3,3)=0.98950

       beam_rot_HPol(1,1)=-0.09500
       beam_rot_HPol(1,2)=-0.99358
       beam_rot_HPol(1,3)=-0.06148
       beam_rot_HPol(2,1)=0.98767
       beam_rot_HPol(2,2)=-0.08635
       beam_rot_HPol(2,3)=-0.13061
       beam_rot_HPol(3,1)=0.12446
       beam_rot_HPol(3,2)=-0.07313
       beam_rot_HPol(3,3)=0.98953
        else
       beam_rot_VPol(1,1)=0.98120
       beam_rot_VPol(1,2)=-0.15271
       beam_rot_VPol(1,3)=0.11803
       beam_rot_VPol(2,1)=0.14227
       beam_rot_VPol(2,2)=0.98551
       beam_rot_VPol(2,3)=0.09237
       beam_rot_VPol(3,1)=-0.13043
       beam_rot_VPol(3,2)=-0.07384
       beam_rot_VPol(3,3)=0.98870

       beam_rot_HPol(1,1)=-0.14228
       beam_rot_HPol(1,2)=-0.98551
       beam_rot_HPol(1,3)=-0.09237
       beam_rot_HPol(2,1)=0.98123
       beam_rot_HPol(2,2)=-0.15270
       beam_rot_HPol(2,3)=0.11777
       beam_rot_HPol(3,1)=-0.13017
       beam_rot_HPol(3,2)=-0.07388
       beam_rot_HPol(3,3)=0.98874
        endif


        return
        end

        subroutine compute_beam_rotations_old(beam, beam_rot_VPol, beam_rot_HPol)

        integer beam  
        real*8  beam_rot_VPol(3,3), beam_rot_HPol(3,3) 



        if(beam.eq.2) then
           beam_rot_VPol(1,1)=0.97488
           beam_rot_VPol(1,2)=0.22075
           beam_rot_VPol(1,3)=-0.02976
           beam_rot_VPol(2,1)=-0.22272
           beam_rot_VPol(2,2)= 0.9642
           beam_rot_VPol(2,3)= -0.14394
           beam_rot_VPol(3,1)=-0.00308
           beam_rot_VPol(3,2)=0.14695
           beam_rot_VPol(3,3)=0.98914

           beam_rot_HPol(1,1)=0.2217
           beam_rot_HPol(1,2)=-0.96443
           beam_rot_HPol(1,3)=0.14397
           beam_rot_HPol(2,1)=0.97511
           beam_rot_HPol(2,2)=0.21974
           beam_rot_HPol(2,3)= -0.0296
           beam_rot_HPol(3,1)= -0.00308
           beam_rot_HPol(3,2)=0.14695
           beam_rot_HPol(3,3)= 0.98914
        else if(beam.eq.3) then
           beam_rot_VPol(1,1)=0.98769
           beam_rot_VPol(1,2)=-0.08631
           beam_rot_VPol(1,3)=-0.13044
           beam_rot_VPol(2,1)=0.09496
           beam_rot_VPol(2,2)=0.99357
           beam_rot_VPol(2,3)= 0.06167
           beam_rot_VPol(3,1)= 0.12428
           beam_rot_VPol(3,2)=-0.0733
           beam_rot_VPol(3,3)= 0.98954

           beam_rot_HPol(1,1)=-0.09496
           beam_rot_HPol(1,2)=-0.99357
           beam_rot_HPol(1,3)=-0.06167
           beam_rot_HPol(2,1)=0.98769
           beam_rot_HPol(2,2)= -0.08631
           beam_rot_HPol(2,3)= -0.13044
           beam_rot_HPol(3,1)=0.12428
           beam_rot_HPol(3,2)= -0.0733
           beam_rot_HPol(3,3)= 0.98954
        else
           beam_rot_VPol(1,1)=0.98119
           beam_rot_VPol(1,2)=-0.15264
           beam_rot_VPol(1,3)=0.1182
           beam_rot_VPol(2,1)=0.14219
           beam_rot_VPol(2,2)=0.98552
           beam_rot_VPol(2,3)=0.09234
           beam_rot_VPol(3,1)=-0.13058
           beam_rot_VPol(3,2)=-0.0738
           beam_rot_VPol(3,3)=0.98869

           beam_rot_HPol(1,1)=-0.14219
           beam_rot_HPol(1,2)=-0.98552
           beam_rot_HPol(1,3)=-0.09234
           beam_rot_HPol(2,1)=0.98119
           beam_rot_HPol(2,2)= -0.15264
           beam_rot_HPol(2,3)=0.1182
           beam_rot_HPol(3,1)=-0.13058
           beam_rot_HPol(3,2)= -0.0738
           beam_rot_HPol(3,3)=0.98869
        endif


        return
        end




        subroutine compute_instrument_rotation(inst_rotation_matrix)

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        real*8 inst_rotation_matrix(3,3)
        real*8 tita
        tita = 33.0d0 *  deg_to_rad
        inst_rotation_matrix(1,1)=0.0d0
        inst_rotation_matrix(2,1)=-1.0d0
        inst_rotation_matrix(3,1)=0.0d0
        inst_rotation_matrix(1,2)=dcos(tita)
        inst_rotation_matrix(2,2)=0.0d0
        inst_rotation_matrix(3,2)=dsin(tita)
        inst_rotation_matrix(1,3)=-dsin(tita)
        inst_rotation_matrix(2,3)=0.0d0
        inst_rotation_matrix(3,3)=dcos(tita)

c        call identity(3,inst_rotation_matrix)
        return
        end


        subroutine return_normalized_vector(vector1, vector2)
        implicit none
        real*8 vector1(3), vector2(3)
        real*8 magnitude

        magnitude = sqrt(vector1(1)**2 + vector1(2)**2 + vector1(3)**2)
        vector2(1) = vector1(1)/magnitude
        vector2(2) = vector1(2)/magnitude
        vector2(3) = vector1(3)/magnitude

        return
        end
        
        
      subroutine return_angle_between_vectors( vector1, vector2, angle)
      implicit none
      real*8 vector1(3), vector2(3)
      real*8 angle, dot

      real*8 earth_radius_eq, earth_radius_pole
      real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
      real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
      common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

      dot = ( vector1(1)*vector2(1) + vector1(2)*vector2(2) + 
     $ vector1(3)*vector2(3) ) / sqrt( (vector1(1)**2 + vector1(2)**2 + 
     $ vector1(3)**2) * ( vector2(1)**2 + vector2(2)**2 + vector2(3)**2))
          
c      write(*,901) dot
 901    format(1f30.16)

      angle = rad_to_deg * dacos(dot)  ! angle is in degrees

      return
      end

        
        
        subroutine return_angle_between_vectors_orig( vector1, vector2, angle)
        implicit none
        real*8 vector1(3), vector2(3)
        real*8 vector1n(3), vector2n(3)
        real*8 angle
        real*8 dot, dot_x, dot_y

        
        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength


        call return_normalized_vector(vector1, vector1n)
        call return_normalized_vector(vector2, vector2n)

c       find the dot product
        dot = vector1n(1)*vector2n(1) + vector1n(2)*vector2n(2) + vector1n(3)*vector2n(3)
c       find the angle between the vectors
        angle = rad_to_deg*dacos(dot)  ! angle is in degrees
c       write(*,901) dot
 901    format(1f30.16)

        return
        end


        subroutine rotate2_system_due_to_precession(iy,im,id,spacecraft_position_in,  spacecraft_velocity_in, 
     &                                             spacecraft_position_out, spacecraft_velocity_out )
        implicit none
        real*8 spacecraft_position_out(3), spacecraft_velocity_out(3)
        real*8 spacecraft_position_in(3), spacecraft_velocity_in(3)
        real*8 rotate_precession(3,3)

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        integer iy, im, id, jflag
        real*8 djm0_2, djm_2
        real*8 rb(3,3), rp(3,3), rbp(3,3)
        integer ii, jj

c$$$          iy = 2009
c$$$          im = 10
c$$$          id = 8
          call iau_CAL2JD ( IY, IM, ID, DJM0_2, DJM_2, jflag )
          call iau_BP00   ( djm0_2, djm_2, rb, rp, rbp)

          do ii = 1,3
            do jj = 1,3
              rotate_precession(ii,jj) =  rp(jj,ii)
            enddo
          enddo

cc      rp matrix ij order
c       rotate_precession(1,1) =   0.999997164600319
c       rotate_precession(2,1) =  -0.002184064915522
c       rotate_precession(3,1) =  -0.000949026747185
c       rotate_precession(1,2) =   0.002184064926848
c       rotate_precession(2,2) =   0.999997614926828
c       rotate_precession(3,2) =  -0.000001024435061
c       rotate_precession(1,3) =   0.000949026721119
c       rotate_precession(2,3) =  -0.000001048303877
c       rotate_precession(3,3) =   0.999999549673490


        call matrix_vector_multiply(rotate_precession, spacecraft_position_in, spacecraft_position_out)
        call matrix_vector_multiply(rotate_precession, spacecraft_velocity_in, spacecraft_velocity_out)


        return
        end


        subroutine rotate_system_due_to_precession(spacecraft_position_in,  spacecraft_velocity_in, 
     &                                             spacecraft_position_out, spacecraft_velocity_out )
        implicit none
        real*8 spacecraft_position_out(3), spacecraft_velocity_out(3)
        real*8 spacecraft_position_in(3), spacecraft_velocity_in(3)
        real*8 angle_x, angle_y
        real*8 rotate_x(3,3)
        real*8 rotate_y(3,3)
        real*8 rotate_precession(3,3)

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        real*8 sintheta, costheta

c       this is for SAC_C, based on 28 Apr 2006
c       angle_x = .0025497485033805d0
c       angle_y = .034947218339905d0


c       this is for SAC_D, based on 8 Oct 2009
        angle_x = .0011934121811328d0
        angle_y = .055946062370581d0

        sintheta = dsin((angle_x)*deg_to_rad)
        costheta = dcos((angle_x)*deg_to_rad)
        rotate_x(1,1) =  1.d0
        rotate_x(1,2) =  0.d0
        rotate_x(1,3) =  0.d0
        rotate_x(2,1) =  0.d0
        rotate_x(2,2) =  costheta
        rotate_x(2,3) = -sintheta
        rotate_x(3,1) =  0.d0
        rotate_x(3,2) =  sintheta
        rotate_x(3,3) =  costheta


        sintheta = dsin((angle_y)*deg_to_rad)
        costheta = dcos((angle_y)*deg_to_rad)
        rotate_y(1,1) =  costheta
        rotate_y(1,2) =  0.d0
        rotate_y(1,3) =  sintheta
        rotate_y(2,1) =  0.d0
        rotate_y(2,2) =  1.d0
        rotate_y(2,3) =  0.d0
        rotate_y(3,1) = -sintheta
        rotate_y(3,2) =  0.d0
        rotate_y(3,3) =  costheta


        call matrix_multiply(rotate_x, rotate_y, rotate_precession)

        call matrix_vector_multiply(rotate_precession, spacecraft_position_in, spacecraft_position_out)
        call matrix_vector_multiply(rotate_precession, spacecraft_velocity_in, spacecraft_velocity_out)


        return
        end

        subroutine convert_local_to_rect_system(sc_s, sc_t, sc_u, v_in, v_out)
        implicit none
        real*8 v_in(3), v_out(3)
        real*8 sc_s(3), sc_t(3), sc_u(3)

        v_out(1) = v_in(1)*sc_s(1) + v_in(2)*sc_t(1) + v_in(3)*sc_u(1)
        v_out(2) = v_in(1)*sc_s(2) + v_in(2)*sc_t(2) + v_in(3)*sc_u(2)
        v_out(3) = v_in(1)*sc_s(3) + v_in(2)*sc_t(3) + v_in(3)*sc_u(3)

        return
        end

        subroutine compute_antenna_pointing_vector(rotation_matrix, antenna_pointing_vector)
        implicit none
        real*8 rotation_matrix(3,3)
        real*8 normal_vector(3)
        real*8 antenna_pointing_vector(3)
c       real*8 xlook_angle, az_angle

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength


c       (from seawinds book, roll, yaw, and pitch ignored, since their information is in rotation_matrix)
c       antenna_pointing_vector(1) = dsin(xlook_angle*deg_to_rad) * dcos(az_angle * deg_to_rad)
c       antenna_pointing_vector(2) = dsin(xlook_angle*deg_to_rad) * dsin(az_angle * deg_to_rad)
c       antenna_pointing_vector(3) = dcos(xlook_angle*deg_to_rad)


c       write(*,*) " "
c       write(*,*) " good vector: ", xlook_angle, az_angle
c       call write_vector(antenna_pointing_vector)


c       (from rotation vector)
        normal_vector(1) = 0.d0
        normal_vector(2) = 0.d0
        normal_vector(3) = 1.d0
        call matrix_vector_multiply(rotation_matrix, normal_vector, antenna_pointing_vector)
c$$$
c$$$    normal_vector(1) = 1.d0
c$$$    normal_vector(2) = 0.d0
c$$$    normal_vector(3) = 0.d0
c$$$    call matrix_vector_multiply(rotation_matrix, normal_vector, antenna_pointing_vector_H)
c$$$
c$$$    normal_vector(1) = 0.d0
c$$$    normal_vector(2) = 1.d0
c$$$    normal_vector(3) = 0.d0
c$$$    call matrix_vector_multiply(rotation_matrix, normal_vector, antenna_pointing_vector_V)

c       write(*,*) " "
c       write(*,*) " second vector: ", xlook_angle, az_angle
c       call write_vector(antenna_pointing_vector)
c       write(*,*) " "
c       write(*,*) " "


        return
        end

        subroutine compute_lat_long(earth_position, latitude_geocentric_deg, latitude_deg, longitude_deg)
        implicit none
        real*8 earth_position(3)
        real*8 latitude_geocentric_deg, longitude_deg, latitude_deg
        real*8 latitude_geocentric_rad
        real*8 h, x, y, z

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        x = earth_position(1)
        y = earth_position(2)
        z = earth_position(3)

        h = dsqrt(x**2 + y**2 + z**2)
        longitude_deg  = datan2(y,x) * rad_to_deg
        if ( longitude_deg .lt. 0. ) then
          longitude_deg = longitude_deg + 360.
        endif
        latitude_geocentric_rad = dasin(z/h) 

        latitude_deg = datan( dtan(latitude_geocentric_rad)/one_minus_earth_eccentricity_sq   ) * rad_to_deg
        latitude_geocentric_deg = latitude_geocentric_rad * rad_to_deg

        return
        end

        subroutine compute_incidence_angle(earth_position, ant_pointing, incidence_angle_deg, xnormal)
        implicit none
        real*8 ant_pointing(3)
        real*8 earth_position(3)
        real*8 incidence_angle_deg
        real*8 xnormal(3)
        real*8 result
        real*8 angle
        real*8 aa, bb
        real*8 compute_dot_product

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        aa = earth_radius_eq**2
        bb = earth_radius_pole**2

        xnormal(1) = two*earth_position(1)/aa
        xnormal(2) = two*earth_position(2)/aa
        xnormal(3) = two*earth_position(3)/bb

        call convert_to_unit_vector(xnormal)
        result = compute_dot_product(xnormal, ant_pointing)
        angle = acos(result)
c       incidence_angle_deg = 180.- 180.*angle/pi
        incidence_angle_deg = 180.d0*(1.d0 - angle/pi)

        return
        end


        real*8 function compute_dot_product(vector1, vector2)
        implicit none
        real*8 vector1(3)
        real*8 vector2(3)

        compute_dot_product = vector1(1)*vector2(1) + vector1(2)*vector2(2) + vector1(3)*vector2(3)

        return
        end



        subroutine locate_cell_on_earth(sc_position, ant_pointing, earth_position, slant_range, good_solution)
        implicit none
        real*8 sc_position(3)
        real*8 ant_pointing(3)
        real*8 earth_position(3)
        real*8 vector(3)
        real*8 root
        real*8 slant_range
        real*8 cofficients(3)
        logical good_solution

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        cofficients(1) = ant_pointing(1)**2 + ant_pointing(2)**2 + (ant_pointing(3)**2)/one_minus_earth_eccentricity_sq

        cofficients(2) = (sc_position(1)*ant_pointing(1) + sc_position(2)*ant_pointing(2) + 
     &       (sc_position(3)*ant_pointing(3))/one_minus_earth_eccentricity_sq)*two

        cofficients(3) = sc_position(1)**2 + sc_position(2)**2 + 
     &       (sc_position(3)**2)/one_minus_earth_eccentricity_sq - earth_radius_eq**2

        call solve_quadratic_eq(cofficients, root, good_solution)

c        root = (earth_radius_eq-sc_position(3))/ant_pointing(3) //Intesect with plane

c       write(*,*) '{',ant_pointing(1),',',ant_pointing(2),',',ant_pointing(3),'}'
c       write(*,*) '{',sc_position(1),',',sc_position(2),',',sc_position(3),'}'
c       write(*,*) cofficients(1), cofficients(2), cofficients(3)


        if ( good_solution .eqv. .true. ) then
          slant_range = root

          vector(1) = ant_pointing(1)*root
          vector(2) = ant_pointing(2)*root
          vector(3) = ant_pointing(3)*root

          earth_position(1) = vector(1) + sc_position(1)        
          earth_position(2) = vector(2) + sc_position(2)        
          earth_position(3) = vector(3) + sc_position(3)        
        else
          slant_range = root

          vector(1) = ant_pointing(1)*root
          vector(2) = ant_pointing(2)*root
          vector(3) = ant_pointing(3)*root

          earth_position(1) = 0.0d0
          earth_position(2) = 0.0d0
          earth_position(3) = 0.0d0

        endif

        return
        end



        subroutine locate_cell_on_ionosphere(sc_position, ant_pointing, iono_position, slant_range, good_solution)
        implicit none
        real*8 sc_position(3)
        real*8 ant_pointing(3)
        real*8 iono_position(3)
        real*8 vector(3)
        real*8 root
        real*8 slant_range
        real*8 cofficients(3)
        logical good_solution

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength, eff_iono
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        eff_iono = 420000.
        cofficients(1) = ant_pointing(1)**2 + ant_pointing(2)**2 + (ant_pointing(3)**2)/one_minus_earth_eccentricity_sq

        cofficients(2) = (sc_position(1)*ant_pointing(1) + sc_position(2)*ant_pointing(2) + 
     &       (sc_position(3)*ant_pointing(3))/one_minus_earth_eccentricity_sq)*two

        cofficients(3) = sc_position(1)**2 + sc_position(2)**2 + 
     &       (sc_position(3)**2)/one_minus_earth_eccentricity_sq - (earth_radius_eq+eff_iono)**2

        call solve_quadratic_eq(cofficients, root, good_solution)



c        root = (earth_radius_eq-sc_position(3))/ant_pointing(3) //Intesect with plane

c       write(*,*) '{',ant_pointing(1),',',ant_pointing(2),',',ant_pointing(3),'}'
c       write(*,*) '{',sc_position(1),',',sc_position(2),',',sc_position(3),'}'
c       write(*,*) cofficients(1), cofficients(2), cofficients(3)


        if ( good_solution .eqv. .true. ) then
          slant_range = root

          vector(1) = ant_pointing(1)*root
          vector(2) = ant_pointing(2)*root
          vector(3) = ant_pointing(3)*root

          iono_position(1) = vector(1) + sc_position(1) 
          iono_position(2) = vector(2) + sc_position(2) 
          iono_position(3) = vector(3) + sc_position(3) 
        else
          slant_range = root

          vector(1) = ant_pointing(1)*root
          vector(2) = ant_pointing(2)*root
          vector(3) = ant_pointing(3)*root

          iono_position(1) = 0.0d0
          iono_position(2) = 0.0d0
          iono_position(3) = 0.0d0

        endif

        return
        end


        subroutine solve_quadratic_eq(poly, root, good_solution)
        implicit none
        real*8 poly(3)
        logical good_solution
        real*8 a, b, c
        real*8 t1, t2, four, two
        real*8 root1, root2, root

        four = 4.d0
        two  = 2.d0
        a = poly(1)     
        b = poly(2)     
        c = poly(3)     

        t1 = b**2 - four*a*c

        root1 = 0.d0
        root2 = 0.d0
        if ( t1 .gt. 0.d0 ) then
          good_solution = .true.
          t2 = dsqrt(t1)
          root1 = (-b + t2)/(two*a)
          root2 = (-b - t2)/(two*a)

          if ( root1 .lt. root2 ) then
            root = root1
          else
            root = root2
          endif

        else
          good_solution = .false.
          root = 0.d0
        endif   


        return
        end


        subroutine compute_antenna_rotation_matrix(xlook_angle, azimuth_angle, rotation_matrix)
        implicit none
        real*8 rotation_matrix(3,3)
        real*8 xlook_angle, azimuth_angle

        real*8 rotate_look(3,3)
        real*8 rotate_azimuth(3,3)
c       real*8 matrix_product(3,3)


        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        real*8 sintheta
        real*8 costheta

c       zzzz
c       this is how seawinds operates
c        sintheta = dsin((azimuth_angle)*deg_to_rad)
c        costheta = dcos((azimuth_angle)*deg_to_rad)
c        rotate_azimuth(1,1) =  costheta
c        rotate_azimuth(1,2) =  sintheta
c        rotate_azimuth(1,3) = 0.d0
c        rotate_azimuth(2,1) = -sintheta
c        rotate_azimuth(2,2) =  costheta
c        rotate_azimuth(2,3) = 0.d0
c        rotate_azimuth(3,1) = 0.d0
c        rotate_azimuth(3,2) = 0.d0
c        rotate_azimuth(3,3) = 1.d0
c
c
c        sintheta = dsin(xlook_angle*deg_to_rad)
c        costheta = dcos(xlook_angle*deg_to_rad)
c        rotate_look(1,1) = costheta
c        rotate_look(1,2) = 0.d0
c        rotate_look(1,3) = -sintheta
c        rotate_look(2,1) = 0.d0
c        rotate_look(2,2) = 1.d0
c        rotate_look(2,3) = 0.d0
c        rotate_look(3,1) = sintheta
c        rotate_look(3,2) = 0.d0
c        rotate_look(3,3) = costheta



c       this follows wentz convention for aquarius
        sintheta = dsin((azimuth_angle)*deg_to_rad)
        costheta = dcos((azimuth_angle)*deg_to_rad)
        rotate_azimuth(1,1) =  costheta
        rotate_azimuth(1,2) = -sintheta
        rotate_azimuth(1,3) = 0.d0
        rotate_azimuth(2,1) =  sintheta
        rotate_azimuth(2,2) =  costheta
        rotate_azimuth(2,3) = 0.d0
        rotate_azimuth(3,1) = 0.d0
        rotate_azimuth(3,2) = 0.d0
        rotate_azimuth(3,3) = 1.d0

c$$$    write(*,*)  azimuth_angle, costheta,  sintheta 
c$$$    write(*,*)  rotate_azimuth(1,1), rotate_azimuth(1,2), rotate_azimuth(1,3)
c$$$
c$$$    write(*,*)  rotate_azimuth(2,1), rotate_azimuth(2,2), rotate_azimuth(2,3)
c$$$
c$$$    write(*,*)  rotate_azimuth(3,1), rotate_azimuth(3,2), rotate_azimuth(3,3)

        sintheta = dsin(xlook_angle*deg_to_rad)
        costheta = dcos(xlook_angle*deg_to_rad)
        rotate_look(1,1) = 1.d0
        rotate_look(1,2) = 0.d0
        rotate_look(1,3) = 0.d0
        rotate_look(2,1) = 0.d0
        rotate_look(2,2) =  costheta
        rotate_look(2,3) = -sintheta
        rotate_look(3,1) = 0.d0
        rotate_look(3,2) =  sintheta
        rotate_look(3,3) =  costheta
c$$$
c$$$    write(*,*)  xlook_angle, costheta,  sintheta 
c$$$    write(*,*)  rotate_look(1,1),rotate_look(1,2),rotate_look(1,3)
c$$$    write(*,*)  rotate_look(2,1),rotate_look(2,2),rotate_look(2,3)
c$$$    write(*,*)  rotate_look(3,1),rotate_look(3,2),rotate_look(3,3)

        call matrix_multiply(rotate_azimuth, rotate_look, rotation_matrix)

c$$$    write(*,*)rotation_matrix(1,1),rotation_matrix(1,2),rotation_matrix(1,3)
c$$$    write(*,*)rotation_matrix(2,1),rotation_matrix(2,2),rotation_matrix(2,3)
c$$$    write(*,*)rotation_matrix(3,1),rotation_matrix(3,2),rotation_matrix(3,3)
c$$$    pause
        return
        end

        subroutine compute_attitude_rotation_matrix_rhs(roll, pitch, yaw, rotation_matrix)
C--Uses positive angles mean right-handed postive rotations convention  
        implicit none
        real*8 rotation_matrix(3,3)
        real*8 roll, yaw, pitch


        real*8 rotate_pitch(3,3)
        real*8 rotate_roll(3,3)
        real*8 rotate_yaw(3,3)
        real*8 matrix_product(3,3)

        real*8 sintheta
        real*8 costheta

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength



c       r1 and r2 are columns
c       example:  matrix_pitch(column,row)

        sintheta = dsin(yaw*deg_to_rad)
        costheta = dcos(yaw*deg_to_rad)
        rotate_yaw(1,1) =  costheta
        rotate_yaw(1,2) =  sintheta
        rotate_yaw(1,3) =  0.d0
        rotate_yaw(2,1) = -sintheta
        rotate_yaw(2,2) =  costheta
        rotate_yaw(2,3) =  0.d0
        rotate_yaw(3,1) =  0.d0
        rotate_yaw(3,2) =  0.d0
        rotate_yaw(3,3) =  1.d0


        sintheta = dsin(pitch*deg_to_rad)
        costheta = dcos(pitch*deg_to_rad)
        rotate_pitch(1,1) =  costheta
        rotate_pitch(1,2) =  0.d0
        rotate_pitch(1,3) = -sintheta
        rotate_pitch(2,1) =  0.d0
        rotate_pitch(2,2) =  1.d0
        rotate_pitch(2,3) =  0.d0
        rotate_pitch(3,1) =  sintheta
        rotate_pitch(3,2) =  0.d0
        rotate_pitch(3,3) =  costheta


        sintheta = dsin(roll*deg_to_rad)
        costheta = dcos(roll*deg_to_rad)
        rotate_roll(1,1) =  1.d0
        rotate_roll(1,2) =  0.d0
        rotate_roll(1,3) =  0.d0
        rotate_roll(2,1) =  0.d0
        rotate_roll(2,2) =  costheta
        rotate_roll(2,3) =  sintheta
        rotate_roll(3,1) =  0.d0
        rotate_roll(3,2) = -sintheta
        rotate_roll(3,3) =  costheta

        call matrix_multiply(rotate_pitch, rotate_roll, matrix_product)
C--AGF commented out the 1st line below and replaced with 2nd line
C--I belive that we want to use the convention:
C--1st rotate about x (rotate_roll)
C--2nd rotate about y (rotate_pitch)
C--3rd rotate about z (rotate_yaw)
C       call matrix_multiply(matrix_product, rotate_yaw, rotation_matrix)
        call matrix_multiply(rotate_yaw, matrix_product, rotation_matrix)
        return
        end


        subroutine compute_attitude_rotation_matrix(roll, pitch, yaw, rotation_matrix)
        implicit none
        real*8 rotation_matrix(3,3)
        real*8 roll, yaw, pitch


        real*8 rotate_pitch(3,3)
        real*8 rotate_roll(3,3)
        real*8 rotate_yaw(3,3)
        real*8 matrix_product(3,3)

        real*8 sintheta
        real*8 costheta

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength



c       r1 and r2 are columns
c       example:  matrix_pitch(column,row)

        sintheta = dsin(yaw*deg_to_rad)
        costheta = dcos(yaw*deg_to_rad)
        rotate_yaw(1,1) =  costheta
        rotate_yaw(1,2) = -sintheta
        rotate_yaw(1,3) = 0.d0
        rotate_yaw(2,1) = sintheta
        rotate_yaw(2,2) = costheta
        rotate_yaw(2,3) = 0.d0
        rotate_yaw(3,1) = 0.d0
        rotate_yaw(3,2) = 0.d0
        rotate_yaw(3,3) = 1.d0


        sintheta = dsin(pitch*deg_to_rad)
        costheta = dcos(pitch*deg_to_rad)
        rotate_pitch(1,1) = costheta
        rotate_pitch(1,2) = 0.d0
        rotate_pitch(1,3) = sintheta
        rotate_pitch(2,1) = 0.d0
        rotate_pitch(2,2) = 1.d0
        rotate_pitch(2,3) = 0.d0
        rotate_pitch(3,1) = -sintheta
        rotate_pitch(3,2) =  0.d0
        rotate_pitch(3,3) =  costheta


        sintheta = dsin(roll*deg_to_rad)
        costheta = dcos(roll*deg_to_rad)
        rotate_roll(1,1) = 1.d0
        rotate_roll(1,2) = 0.d0
        rotate_roll(1,3) = 0.d0
        rotate_roll(2,1) = 0.d0
        rotate_roll(2,2) =  costheta
        rotate_roll(2,3) = -sintheta
        rotate_roll(3,1) = 0.d0
        rotate_roll(3,2) =  sintheta
        rotate_roll(3,3) =  costheta

        call matrix_multiply(rotate_pitch, rotate_roll, matrix_product)
C--AGF commented out the 1st line below and replaced with 2nd line
C--I belive that we want to use the convention:
C--1st rotate about x (rotate_roll)
C--2nd rotate about y (rotate_pitch)
C--3rd rotate about z (rotate_yaw)
C       call matrix_multiply(matrix_product, rotate_yaw, rotation_matrix)
        call matrix_multiply(rotate_yaw, matrix_product, rotation_matrix)
        return
        end

        subroutine compute_sc_nadir_components(sc_position,spacecraft_lon,
     &     spacecraft_lat,spacecraft_altitude,spacecraft_nadir_vector)
        implicit none

        real*8 spacecraft_nadir_vector(3)
c       inputs: x,y,z
c       outputs: long,lat,spacecraft_altitude

        real*8 sc_position(3)
        real*8 x, y, z
        real*8 spacecraft_lon, spacecraft_lat
        real*8 f, f1, f2
        real*8 rho, r 
        real*8 dr, dz
        real*8 g0, g1, g2,x1,y1,z1
        real*8 phi, spacecraft_altitude
        real*8 temp_sp, temp_cp
        real*8 dh, dp
        real*8 aatan
        character*200 file_name_out
        integer j
        integer lnblnk

        real*8 phi_geocentric_rad
        real*8 sin_phi_geocentric_rad, earth_radius_at_nadir

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        character*200 AQ_SCAT_SIM_DIR_OUT, AQ_SCAT_SIM_DIR_DAT, AQ_SCAT_SIM_DIR_SCRATCH
        common /AQ_SCAT_SIM_DIRS/ AQ_SCAT_SIM_DIR_OUT, AQ_SCAT_SIM_DIR_DAT,
     $ AQ_SCAT_SIM_DIR_SCRATCH
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

c       file_name_out = '/Users/fore/Documents/AQUARIUS/scat_science/output/nadir.dat'
        
!       file_name_out = AQ_SCAT_SIM_DIR_DAT(1:lnblnk(AQ_SCAT_SIM_DIR_DAT)) // '/nadir.dat'
        !!/u/palsr1/gn/aquarius_data/out/nadir.dat'
        !!open(88,file=file_name_out,status='unknown')

        f = one - earth_radius_pole/earth_radius_eq
        f1 = earth_radius_pole/earth_radius_eq
        f2 = f*(two-f)

        x = sc_position(1)
        y = sc_position(2)
        z = sc_position(3)

        rho = dsqrt(x**2 + y**2 + z**2)
        r   = dsqrt(x**2 + y**2)

c       spacecraft_lon = aatan(y,x)
        spacecraft_lon = atan2(y,x)
        spacecraft_lon = spacecraft_lon * rad_to_deg
        if ( spacecraft_lon .lt. 0. ) spacecraft_lon = spacecraft_lon + 360.d0

        phi = dasin(z/rho)
        spacecraft_altitude   = rho - earth_radius_eq*(one - f*dsin(phi)**2 )

        x1=0.0d0
        y1=0.0d0
        z1=0.0d0
        do while (sqrt((x1-x)**2+(y1-y)**2+(z1-z)**2)>1.d-6)
          temp_sp = dsin(phi)
          temp_cp = dcos(phi)
          g0 = earth_radius_eq/dsqrt(one - f2*temp_sp**2 )
          g1 = g0 + spacecraft_altitude
          g2 = g0*(1-f)**2 + spacecraft_altitude
          dr = r - g1*temp_cp
          dz = z - g2*temp_sp
          dh = dr*temp_cp + dz*temp_sp
          dp = (dz*temp_cp - dr*temp_sp)/(earth_radius_eq+spacecraft_altitude+dh)
          phi = phi + dp
          spacecraft_altitude = spacecraft_altitude + dh
          x1=g1*dcos(phi)*dcos(spacecraft_lon * deg_to_rad)
          y1=g1*dcos(phi)*dsin(spacecraft_lon * deg_to_rad)
          z1=g2*dsin(phi)

        enddo
223     format(i3, 2g23.5)
c       pause
        phi_geocentric_rad = datan( dtan(phi)*one_minus_earth_eccentricity_sq   )  ! convert geodetic to geocentric
        phi = phi*rad_to_deg  ! geodetic (degrees)

        spacecraft_lat = phi


        sin_phi_geocentric_rad = dsin(phi_geocentric_rad)
        earth_radius_at_nadir = earth_radius_eq *(one - f*sin_phi_geocentric_rad**2)

        spacecraft_nadir_vector(1) = earth_radius_at_nadir * dcos(phi_geocentric_rad)* dcos(spacecraft_lon*deg_to_rad)
        spacecraft_nadir_vector(2) = earth_radius_at_nadir * dcos(phi_geocentric_rad)* dsin(spacecraft_lon*deg_to_rad)
        spacecraft_nadir_vector(3) = earth_radius_at_nadir * dsin(phi_geocentric_rad)
c       write(*,*) spacecraft_nadir_vector(1),spacecraft_nadir_vector(2),spacecraft_nadir_vector(3),earth_radius_at_nadir, earth_radius_eq,phi_geocentric_rad
c       pause

        return
        end

        subroutine cross_product(vector1_in, vector2_in, vector_out)
        implicit none
        real*8 vector1_in(3)
        real*8 vector2_in(3)
        real*8 vector_out(3)

        vector_out(1) = vector1_in(2)*vector2_in(3) - vector1_in(3)*vector2_in(2)
        vector_out(2) = vector1_in(3)*vector2_in(1) - vector1_in(1)*vector2_in(3)
        vector_out(3) = vector1_in(1)*vector2_in(2) - vector1_in(2)*vector2_in(1)

        return

        end

        subroutine write_matrix(matrix)
        implicit none
        real*8 matrix(3,3)

          write(*,*) matrix(1,1), matrix(2,1), matrix(3,1)
          write(*,*) matrix(1,2), matrix(2,2), matrix(3,2)
          write(*,*) matrix(1,3), matrix(2,3), matrix(3,3)
          write(*,*) " "


        return
        end

        subroutine write_vector(vector)
        implicit none
        real*8 vector(3)
        real*8 rho


        rho = dsqrt(vector(1)**2 + vector(2)**2 + vector(3)**2)
        
        write(*,*) "      x: ", vector(1)
        write(*,*) "      y: ", vector(2)
        write(*,*) "      z: ", vector(3)
        write(*,*) " length: ", rho

        return
        end



        subroutine matrix_multiply(matrix_1, matrix_2, matrix_product)
        implicit none
        real*8 matrix_1(3,3)
        real*8 matrix_2(3,3)
        real*8 matrix_product(3,3)


        matrix_product(1,1) = matrix_1(1,1)*matrix_2(1,1) +  matrix_1(2,1)*matrix_2(1,2) +  matrix_1(3,1)*matrix_2(1,3)
        matrix_product(1,2) = matrix_1(1,2)*matrix_2(1,1) +  matrix_1(2,2)*matrix_2(1,2) +  matrix_1(3,2)*matrix_2(1,3)
        matrix_product(1,3) = matrix_1(1,3)*matrix_2(1,1) +  matrix_1(2,3)*matrix_2(1,2) +  matrix_1(3,3)*matrix_2(1,3)


        matrix_product(2,1) = matrix_1(1,1)*matrix_2(2,1) +  matrix_1(2,1)*matrix_2(2,2) +  matrix_1(3,1)*matrix_2(2,3)
        matrix_product(2,2) = matrix_1(1,2)*matrix_2(2,1) +  matrix_1(2,2)*matrix_2(2,2) +  matrix_1(3,2)*matrix_2(2,3)
        matrix_product(2,3) = matrix_1(1,3)*matrix_2(2,1) +  matrix_1(2,3)*matrix_2(2,2) +  matrix_1(3,3)*matrix_2(2,3)

        matrix_product(3,1) = matrix_1(1,1)*matrix_2(3,1) +  matrix_1(2,1)*matrix_2(3,2) +  matrix_1(3,1)*matrix_2(3,3)
        matrix_product(3,2) = matrix_1(1,2)*matrix_2(3,1) +  matrix_1(2,2)*matrix_2(3,2) +  matrix_1(3,2)*matrix_2(3,3)
        matrix_product(3,3) = matrix_1(1,3)*matrix_2(3,1) +  matrix_1(2,3)*matrix_2(3,2) +  matrix_1(3,3)*matrix_2(3,3)



        return
        end

        subroutine matrix_vector_multiply(rotation_matrix, vector_in, vector_out)
        implicit none
        real*8 rotation_matrix(3,3)
        real*8 vector_in(3)
        real*8 vector_out(3)


        vector_out(1)=vector_in(1)*rotation_matrix(1,1) + vector_in(2)*rotation_matrix(2,1) + vector_in(3)*rotation_matrix(3,1)
        vector_out(2)=vector_in(1)*rotation_matrix(1,2) + vector_in(2)*rotation_matrix(2,2) + vector_in(3)*rotation_matrix(3,2)
        vector_out(3)=vector_in(1)*rotation_matrix(1,3) + vector_in(2)*rotation_matrix(2,3) + vector_in(3)*rotation_matrix(3,3)


        return
        end

        subroutine usage

          write(*,*) ' usage: [-x X][-y Y][-z Z][-xv XV][-yv YV][-zv ZV][-ant_az A][-ant_lk L]'
          write(*,*) '   '
          write(*,*) '   '
          write(*,*) '   X  : X position'
          write(*,*) '   Y  : Y position'
          write(*,*) '   Z  : Z position'
          write(*,*) '   XV : X velocity'
          write(*,*) '   YV : Y velocity'
          write(*,*) '   ZV : Z velocity'
          write(*,*) '   A  : antenna azimuth (deg)'
          write(*,*) '   L  : antenna look angle (deg)'
          write(*,*) '   '

        return
        end

        subroutine read_sc_lla_d_file(sc_lla_name, z_lat, z_lon, z_alt, zhour)
        implicit none
        character*200 sc_lla_name
        real*8 z_lat, z_lon, z_alt, zhour
        real*8 antenna_azimuth_angle
        real*8 roll_deg, pitch_deg, yaw_deg
        real*8 sc_alt, sc_lon, sc_lat
        real*8 cell_longitude_deg, cell_latitude_deg
        real*8 cell_azimuth, cell_incidence
        character*24 spacer
        logical flag
        integer ifirst/1/

        if ( ifirst .eq. 1 ) then
          open(26,file=sc_lla_name,status='unknown')
          read(26,*,end=1001,err=1001) spacer  ! read header
          read(26,*,end=1001,err=1001) spacer  ! read header
          read(26,*,end=1001,err=1001) spacer  ! read header
          read(26,*,end=1001,err=1001) spacer  ! read header
          read(26,*,end=1001,err=1001) spacer  ! read header
          read(26,*,end=1001,err=1001) spacer  ! read header
          ifirst = 2
        endif

        read(26,277,end=1001,err=1001) spacer, z_lat, z_lon, z_alt

277     format(a24, 2f13.3, f14.6)

        flag = .false.
        return
1001    continue

        close(26)
        flag = .true.

        return
        end




        subroutine read_sc_xyz_d_file(sc_file_name, x_pos, y_pos, z_pos, x_vel, y_vel, z_vel, flag, 
     &                          iyear, imonth,iday, ihour, iminute, second)
        implicit none
        character*200 sc_file_name
        real*8 x_pos, y_pos, z_pos
        real*8 x_vel, y_vel, z_vel,time

c       real*8 antenna_azimuth_angle
c       real*8 roll_deg, pitch_deg, yaw_deg
c       real*8 sc_alt, sc_lon, sc_lat
c       real*8 cell_longitude_deg, cell_latitude_deg
c       real*8 cell_azimuth, cell_incidence

        character*24 spacer
        character*3 cmonth
        logical flag
        integer ifirst/1/
        integer iyear, imonth, iday
        integer ihour, iminute
        real*8  second

        if ( ifirst .eq. 1 ) then
          write(*,*) " first read spacecraft file ",sc_file_name
          open(25,file=sc_file_name,status='unknown')
          read(25,*,end=1001,err=1001) spacer  ! read header
          read(25,*,end=1001,err=1001) spacer  ! read header
          read(25,*,end=1001,err=1001) spacer  ! read header
          read(25,*,end=1001,err=1001) spacer  ! read header
          read(25,*,end=1001,err=1001) spacer  ! read header
          read(25,*,end=1001,err=1001) spacer  ! read header
          write(*,*) spacer
          ifirst = 2
        endif

        read(25,277,end=1001,err=1001) spacer, x_pos, y_pos, z_pos, x_vel, y_vel, z_vel

c       write(*,*) spacer, x_pos, y_pos, z_pos, x_vel, y_vel, z_vel
c       pause


        read(spacer(1:2),*) iday
        read(spacer(8:11),*) iyear
        read(spacer(13:14),*) ihour
        read(spacer(16:17),*) iminute
        read(spacer(19:24),*) second
        cmonth = spacer(4:6)

        if ( cmonth .eq. "Oct" ) then
          imonth = 10
        endif


277     format(a24, 3f16.6, 3f15.6)


c       convert to meters
        x_pos = x_pos * 1000.d0
        y_pos = y_pos * 1000.d0
        z_pos = z_pos * 1000.d0

        x_vel = x_vel * 1000.d0
        y_vel = y_vel * 1000.d0
        z_vel = z_vel * 1000.d0

        flag = .false.
        return
1001    continue

        close(25)
        ifirst = 1
        flag = .true.

        return
        end

        real*8 function aatan (y,x)
        real*8 y, x, angle, angle2

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        angle = datan(y/x)*rad_to_deg


        if ( y .ge. 0. ) then
          if ( x .ge. 0. ) then
            angle2 = angle
          else
            angle2 = angle + 180.d0
          endif
        else
          if ( x .ge. 0. ) then
            angle2 = angle + 360.d0
          else
            angle2 = angle + 180.d0
          endif
        endif

        aatan = angle2

        return
        end


        subroutine read_sc_xyz_d_file_conae(sc_file_name, x_pos, y_pos, z_pos, x_vel, y_vel, z_vel, flag, 
     &                          iyear, imonth,iday, ihour, iminute, second)
        implicit none
        character*200 sc_file_name
        real*8 x_pos, y_pos, z_pos
        real*8 x_vel, y_vel, z_vel,time

c       real*8 antenna_azimuth_angle
c       real*8 roll_deg, pitch_deg, yaw_deg
c       real*8 sc_alt, sc_lon, sc_lat
c       real*8 cell_longitude_deg, cell_latitude_deg
c       real*8 cell_azimuth, cell_incidence

        character*28 spacer
        character*3 cmonth
        logical flag
        integer ifirst/1/
        integer iyear, imonth, iday
        integer ihour, iminute
        real*8  second

        if ( ifirst .eq. 1 ) then
          write(*,*) " first read spacecraft file ",sc_file_name
          open(25,file=sc_file_name,status='old') ! Alex F. changed status from unknown to old
          read(25,*,end=1001,err=1001) spacer  ! read header
c         write(*,*) spacer
          ifirst = 2
        endif

        read(25,278,end=1001,err=1001) spacer, x_pos, y_pos, z_pos, x_vel, y_vel, z_vel

c       write(*,*) spacer, x_pos, y_pos, z_pos, x_vel, y_vel, z_vel
c       pause

        read(spacer(1:4),*) iyear
        read(spacer(6:7),*) imonth
        read(spacer(9:10),*) iday
        read(spacer(12:13),*) ihour
        read(spacer(15:16),*) iminute
        read(spacer(18:28),*) second

c       if ( cmonth .eq. "Oct" ) then
c         imonth = 10
c       endif


278     format(a28, 3f14.6, 3f14.10)


c       convert to meters
        x_pos = x_pos * 1000.d0
        y_pos = y_pos * 1000.d0
        z_pos = z_pos * 1000.d0

        x_vel = x_vel * 1000.d0
        y_vel = y_vel * 1000.d0
        z_vel = z_vel * 1000.d0

        flag = .false.
        return
1001    continue

        close(25)
        ifirst = 1
        flag = .true.

        return
        end


        subroutine initialize_constants
        implicit none

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,wavelength
        real*8 wgs84_inverse_flattening,R_SOL,freq
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength


        R_SOL=299792458.0d0            ! speed of light in vacuum in m/s
        freq=1.26d9                    !Hz
        earth_radius_eq=6378137.     !equatorial earth radius in meters
c        earth_radius_eq=100000000.     !equatorial earth radius in meters
c        earth_radius_eq=6378136.6     !equatorial earth radius in meters (from the usno almanac)
c        earth_radius_pole=6356752.3  !polar earth radius in meters  (calculated from flattening)
        wgs84_inverse_flattening =298.257223563  !WGS84 inverse flattening
c        wgs84_inverse_flattening =298.25642      !inverse flattening ( from the usno almanac)
c        wgs84_inverse_flattening = 100000000000000000.d0 !inverse flattening ( from the usno almanac)


        wavelength = R_SOL/freq
        pi=3.14159265358979323846264338327950288d0
        one = 1.0d0
        two = 2.0d0
        one_eighty = 180.d0
        rad_to_deg = one_eighty/pi
        deg_to_rad = pi/one_eighty
c        write(*,*) earth_radius_pole
        earth_radius_pole=  earth_radius_eq *(1.d0 - 1.d0/wgs84_inverse_flattening)
c       write(*,*) earth_radius_pole
        earth_eccentricity = dsqrt(one-(earth_radius_pole/earth_radius_eq)**2)
c       write(*,*) earth_radius_pole,   earth_eccentricity
        earth_eccentricity_sq = one-(earth_radius_pole/earth_radius_eq)**2
        one_minus_earth_eccentricity_sq = (earth_radius_pole/earth_radius_eq)**2

        return
        end

        subroutine compute_local_coordinates(sc_position, sc_velocity, sc_s, sc_t, sc_u)
        implicit none

        real*8 sc_position(3)
        real*8 sc_velocity(3)
        real*8 sc_s(3)
        real*8 sc_t(3)
        real*8 sc_u(3)


        sc_u(1) = -sc_position(1)
        sc_u(2) = -sc_position(2)
        sc_u(3) = -sc_position(3)

        call convert_to_unit_vector(sc_u)
        call cross_product(sc_u, sc_velocity, sc_t)
        call convert_to_unit_vector(sc_t)
        call cross_product(sc_t, sc_u, sc_s)


        return
        end


        subroutine compute_geodetic_to_geocentric_matrix(sc_s, sc_t, sc_u, sc_position, sc_velocity, 
     &      spacecraft_nadir_vector, rotation_matrix)
        implicit none

        real*8 sc_u(3), sc_t(3), sc_s(3), spacecraft_nadir_vector(3)
c       real*8 spacecraft_earth_pos(3)
c       real*8 spacecraft_cross_orbit_plane(3)
c       real*8 orbit_plane_angular_momentum(3)
        real*8 uu_vector(3)
        real*8 sc_position(3)
        real*8 sc_velocity(3)
        real*8 rotation_matrix(3,3)
        real*8 compute_dot_product
        real*8 sc_uu(3), sc_tt(3), sc_ss(3)
        
c     COMMON BLOCKS
      integer i_dbg_level
      common /debug_level/ i_dbg_level


        uu_vector(1) = -(spacecraft_nadir_vector(1) - sc_position(1))
        uu_vector(2) = -(spacecraft_nadir_vector(2) - sc_position(2))
        uu_vector(3) = -(spacecraft_nadir_vector(3) - sc_position(3))

        call compute_local_coordinates(uu_vector, sc_velocity, sc_ss, sc_tt, sc_uu)

        if ( i_dbg_level .ge. 2 ) then
          write(*,*) " "
          write(*,*) " uu_vector"
          call write_vector(uu_vector)
          write(*,*) " "
          write(*,*) " sc_ss"
          call write_vector(sc_ss)
          write(*,*) " "
          write(*,*) " sc_tt"
          call write_vector(sc_tt)
          write(*,*) " "
          write(*,*) " sc_uu" 
          call write_vector(sc_uu)
        endif


          rotation_matrix(1,1) = compute_dot_product(sc_ss, sc_s)
          rotation_matrix(1,2) = compute_dot_product(sc_ss, sc_t)
          rotation_matrix(1,3) = compute_dot_product(sc_ss, sc_u)
          rotation_matrix(2,1) = compute_dot_product(sc_tt, sc_s)
          rotation_matrix(2,2) = compute_dot_product(sc_tt, sc_t)
          rotation_matrix(2,3) = compute_dot_product(sc_tt, sc_u)
          rotation_matrix(3,1) = compute_dot_product(sc_uu, sc_s)
          rotation_matrix(3,2) = compute_dot_product(sc_uu, sc_t)
          rotation_matrix(3,3) = compute_dot_product(sc_uu, sc_u)

c          call identity(3,rotation_matrix)

        return
        end

        subroutine convert_to_unit_vector(vector)
        implicit none
        real*8 vector(3)
        real*8 rho

        rho = dsqrt(vector(1)**2 + vector(2)**2 + vector(3)**2)
        vector(1) = vector(1)/rho
        vector(2) = vector(2)/rho
        vector(3) = vector(3)/rho

        return
        end

        subroutine compute_geocentric_to_geographic_matrix(earth_position, geocentric_to_geographic_matrix)
        implicit none
        
        real*8 earth_position(3)
        real*8 geocentric_to_geographic_matrix(3,3)
        real*8 vector_magnitude
        real*8 cell_vector_magnitude
        real*8 st, ct, cn, sn
        real*8 geoc_lat, geod_lat, lon

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,wavelength
        real*8 wgs84_inverse_flattening,R_SOL,freq
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

    
        call compute_lat_long(earth_position, geoc_lat, geod_lat, lon)
    
        st = sin( geod_lat * deg_to_rad )
        ct = cos( geod_lat * deg_to_rad )
        cn = cos( lon * deg_to_rad )
        sn = sin( lon * deg_to_rad )


c        geocentric_to_geographic_matrix(1,1) = -st*cn
c        geocentric_to_geographic_matrix(2,1) = -sn
c        geocentric_to_geographic_matrix(3,1) = -ct*cn
c        geocentric_to_geographic_matrix(1,2) = -st*sn
c        geocentric_to_geographic_matrix(2,2) =  cn
c        geocentric_to_geographic_matrix(3,2) = -ct*sn
c        geocentric_to_geographic_matrix(1,3) =  ct
c        geocentric_to_geographic_matrix(2,3) =  0.0d0
c        geocentric_to_geographic_matrix(3,3) = -st


        geocentric_to_geographic_matrix(1,1) = -st*cn
        geocentric_to_geographic_matrix(1,2) = -sn
        geocentric_to_geographic_matrix(1,3) = -ct*cn
        geocentric_to_geographic_matrix(2,1) = -st*sn
        geocentric_to_geographic_matrix(2,2) =  cn
        geocentric_to_geographic_matrix(2,3) = -ct*sn
        geocentric_to_geographic_matrix(3,1) =  ct
        geocentric_to_geographic_matrix(3,2) =  0.0d0
        geocentric_to_geographic_matrix(3,3) = -st



        return
        end

        subroutine compute_cell_azimuth(earth_position, antenna_pointing_vector_rect, cell_azimuth)
        implicit none
        
        real*8 earth_position(3)
        real*8 geocentric_to_geographic_matrix(3,3)
        real*8 antenna_pointing_vector_rect(3)
        real*8 geographic_vector(3)
        real*8 cell_azimuth
        real*8 aatan,R_SOL

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,wavelength
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength


        call compute_geocentric_to_geographic_matrix(earth_position, geocentric_to_geographic_matrix)
        call matrix_vector_multiply(geocentric_to_geographic_matrix, antenna_pointing_vector_rect, geographic_vector)
c       cell_azimuth = datan2(geographic_vector(2),geographic_vector(1)) * rad_to_deg
        cell_azimuth = aatan(geographic_vector(2),geographic_vector(1))

        if ( cell_azimuth .lt. -180. ) then
          cell_azimuth = cell_azimuth + 360.d0
        endif
        if ( cell_azimuth .gt.  180. ) then
          cell_azimuth = cell_azimuth - 360.d0
        endif

        return
        end

        subroutine reformat_julian_time(julian_time, time_c)
        implicit none
        character*24 time_c
        character*3 cmonth
        character*3 cmon(12)
        real*8 julian_time
        real*8 j2, j3, j4, j5, j2nd
        integer iyear, imonth, iday, ihour, iminute, isecond, iisecond

        INTEGER            YEAR
        INTEGER            MONTH
        INTEGER            DAY
        INTEGER            HOUR
        INTEGER            MINUTE
        INTEGER            SECOND
        real*8             FRAC
        

        cmon(1)='Jan'
        cmon(2)='Feb'
        cmon(3)='Mar'
        cmon(4)='Apr'
        cmon(5)='May'
        cmon(6)='Jun'
        cmon(7)='Jul'
        cmon(8)='Aug'
        cmon(9)='Sep'
        cmon(10)='Oct'
        cmon(11)='Nov'
        cmon(12)='Dec'


c$$$    j2 = julian_time - 2453853.5d0
c$$$    iday = int(j2)
c$$$    j2nd = j2 - float(iday)
c$$$    ihour = int(j2nd*24.d0)
c$$$    j3 = j2nd*24.d0 - float(ihour)
c$$$    iminute = int(j3*60.d0)
c$$$    j4 = j3*60.d0 - float(iminute)
c$$$    isecond = int(j4*60.d0)
c$$$    j5 = j4*60.d0 - float(isecond)
c$$$c   iisecond = int(j5*100000000.d0)
c$$$    iisecond = int(j5*1000.d0)
c$$$
c$$$
c$$$    if ( iday .eq. 0 ) then
c$$$      iyear  = 2006
c$$$      imonth = 4
c$$$      iday   = 28
c$$$      cmonth='Apr'
c$$$    else if ( iday .eq. 1 ) then
c$$$      iyear  = 2006
c$$$      imonth = 4
c$$$      iday   = 29
c$$$      cmonth='Apr'
c$$$    else if ( iday .eq. 2 ) then
c$$$      iyear  = 2006
c$$$      imonth = 4
c$$$      iday   = 30
c$$$      cmonth='Apr'
c$$$    else if ( iday .eq. 3 ) then
c$$$      iyear  = 2006
c$$$      imonth = 5
c$$$      iday   = 1
c$$$      cmonth='May'
c$$$    endif
c$$$
c$$$    if ( iday .eq. 1258 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 7
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1259 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 8
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1260 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 9
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1261 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 10
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1262 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 11
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1263 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 12
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1264 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 13
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1265 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 14
c$$$      cmonth='Oct'
c$$$    else if ( iday .eq. 1266 ) then
c$$$      iyear  = 2009
c$$$      imonth = 10
c$$$      iday   = 15
c$$$      cmonth='Oct'
c$$$    endif


c       write(*,*) "mark ", iyear, imonth, iday, ihour, iminute, isecond,iisecond
c       write(time_c,444) iyear, '/', imonth, '/', iday, ' ', ihour, ':', iminute, ':', isecond, '.', iisecond
c       write(time_c,444) iday,  cmonth,  iyear,  ihour, ':', iminute, ':', isecond, '.', iisecond
c       write(*,*) time_c

        call JD2CAL(julian_time,YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,FRAC)


        write(time_c,444) DAY,  cmon(MONTH),  YEAR,  HOUR, ':', MINUTE, ':', SECOND, '.', FRAC
c       write(*,*)"mark 2",   YEAR, MONTH, DAY,  HOUR,  MINUTE, SECOND,  FRAC
c       write(*,*) time_c


c       pause
444     format(i2.2,1x,a3, 1x, i4.4, 1x, i2.2, a1, i2.2, a1, i2.2, a1, f3.3)
c       write(*,*) time_c

        return
        end



        subroutine gha (utcmjd,greenwich_apparent_hour_angle_rad)
c
c       Find the Greenwich Apparent Hour Angle at a UTC time.  This is
c       equivalent to finding the rotation angle of the coordinate
c       system needed to convert inertial (ECI) state vectors into
c       the rotated-inertial system required by NSCAT.
c
c       Inputs:
c
c         utcmjd    real*8    UTC time as a Modified Julian Date (days).
c
c       Outputs:
c
c         greenwich_apparent_hour_angle_rad   real*8    Greenwich Apparent Hour Angle, in radians.
c
c       Equations for Greenwich Mean Sidereal Time at 0h (GMST-0h) and
c       obliquity of ecliptic (for nutation correction to apparent ST)
c       include a time argument in Julian centuries referred to the
c       J2000 epoch (e2000 = JD2451544.5 = MJD51544.0).
c
c       Coefficients for obliquity and constant of nutation have been
c       taken from the Astronomical Almanac, 1989.
c       ---------------------------------------------------------------
c        implicit double precision (a-h,o-z)
        implicit none
        real*8 utcmjd, greenwich_apparent_hour_angle_rad
        real*8 sday1, e2000
        real*8 dtr, rtd, pi, twopi, halfpi
        real*8 time, xjc, alfam, frac, gmst
        real*8 arcsecrad, delphi, eclobl, xnutate, gast
c
c       Coefficients for GMST-0h calculation:
c
        real*8 alfa(4)
        data alfa /0.77905727326389d0, 100.002139037801d0,
     $             1.0775925925926d-6,  -7.1759259259259d-11/
c
c       Other data:
c
        data sday1 /86400.d0/           ! sidereal seconds per rotation
        data e2000 /51544.5d0/          ! MJD of 1 Jan 2000
c
c       Pi constants (in Global constants file):
c
        data dtr,rtd/1.7453292519943295d-2,57.29577951308233d0/
        data pi/3.141592653589793d0/
        data twopi,halfpi/6.283185307179586d0,1.570796326794897d0/
c       ---------------------------------------------------------------
        time = utcmjd

        xjc = (time - e2000)/36525.d0   ! Julian centuries from epoch

        alfam = alfa(1) + xjc*(alfa(2) + xjc*(alfa(3) + xjc*alfa(4)))
        alfam = dmod(alfam,1.d0)
        if (alfam .lt. 0.d0) alfam = alfam + 1.d0
        frac = time - int(time)         ! UTC in fraction of day

        gmst = frac + alfam + 0.5d0
        gmst = dmod(gmst,1.d0)          ! Greenwich Mean Sidereal Time,
c                                       ! as fraction of a rotation
c
c       Now, compute the Greenwich Apparent Sidereal Time (GAST),
c       and we're outta here:
c
        arcsecrad = 180.d0*3600.d0/pi

        delphi = 9.2025d0/arcsecrad     ! nutation constant in radians
c
c       This is the J2000 expression for obliquity
c         (Astronomical Almanac, 1989)
        eclobl = 23.439291d0 + xjc*(-1.30042d-2 + xjc*(-1.60d-6 + 5.04d-7*xjc))
        eclobl = eclobl*dtr

        xnutate = delphi*cos(eclobl)/twopi

        gast = gmst + xnutate   ! Greenwich Apparent Sidereal Time, rotations
        greenwich_apparent_hour_angle_rad = gast*twopi    ! GA Hour Angle in radians (output)

        return
        end



        subroutine rotate_ephemeris(sc_position_unrotated, sc_velocity_unrotated, sc_position, sc_velocity, 
     &                               greenwich_apparent_hour_angle_rad)
        implicit none
        real*8 greenwich_apparent_hour_angle_rad
        real*8 sc_velocity_unrotated(3)
        real*8 sc_position_unrotated(3)
        real*8 sc_velocity(3)
        real*8 sc_position(3)
        real*8 a, b

c  Calculate Greenwich Hour Angle ghrang at the given time
c   NOTE:  the UTC time utcmjd must be given as a Modified Julian Date
c          MJD = JD - 2400000.5
c          where JD can be computed from the year,month,day and
c            the fraction from the hours, mins, seconds

        a = dcos(greenwich_apparent_hour_angle_rad)        ! note: (-) to reverse rotation
        b = dsin(greenwich_apparent_hour_angle_rad)        !

        sc_position(1) =  sc_position_unrotated(1)*a + sc_position_unrotated(2)*b
        sc_position(2) = -sc_position_unrotated(1)*b + sc_position_unrotated(2)*a
        sc_position(3) =  sc_position_unrotated(3)

        sc_velocity(1) =  sc_velocity_unrotated(1)*a + sc_velocity_unrotated(2)*b
        sc_velocity(2) = -sc_velocity_unrotated(1)*b + sc_velocity_unrotated(2)*a
        sc_velocity(3) =  sc_velocity_unrotated(3)

        return
        end
        subroutine write_string_no_space(nfile, cline)
        character*200 cline

        character*200 cformat(1)


210     format(a1)
211     format("(",'a',i1, ")")
212     format("(",'a',i2, ")")
213     format("(",'a',i3, ")")

            nn = lnblnk(cline)
            if ( nn .lt. 10 ) then
              write(cformat,211) nn
            else if ( nn .lt. 100 ) then
              write(cformat,212) nn
            else if ( nn .lt. 1000 ) then
              write(cformat,213) nn
            endif
            write(nfile,cformat) cline(1:nn)


        return
        end



c$$$    subroutine cellgeo(H,lat,antlook,antazi,ainc,Rslant,Rg,Vrc,Vrg,Vphi,Vr)
c$$$
c$$$c$$$% based on S. Yueh's:       
c$$$c$$$% Input:
c$$$c$$$%       H: Spacecraft altitude (km)
c$$$c$$$%       antlook: Elevation angle of the antenna boresight (deg)
c$$$c$$$%       antazi: Azimuth angle of antenna pointing (deg) wrt the sc nadir track
c$$$c$$$% Output:
c$$$c$$$%       ainc: Incidence angle (deg)
c$$$c$$$%       Rslant: slant range from the cell to the spacecraft
c$$$c$$$%       Rg: Ground range of the cell from the spacecraft nadir
c$$$c$$$%       Vrc: Cartesian coordinates of the cell
c$$$c$$$%       Vrg: unit vector tangential to the local surface
c$$$c$$$%               from the spacecraft nadir to the cell
c$$$c$$$%       Vphi: unit vector perpendicular to Vrc and Vrg
c$$$c$$$%       Vr: position vector from the spacecraft to the cell
c$$$
c$$$    real*8 earth_radius_eq, earth_radius_pole
c$$$    real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
c$$$    real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi
c$$$    real*8 wgs84_inverse_flattening, lat
c$$$    common /block/earth_radius_eq, earth_radius_pole, 
c$$$     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
c$$$     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi
c$$$
c$$$        real*8 H,antlook,antazi,Rslant,Rp
c$$$        real*8 Vrc(3),Vrg(3),Vphi(3),Vr(3)
c$$$
c$$$    
c$$$        real*8 ainc,xi,Rg,R2,Re, N
c$$$
c$$$
c$$$
c$$$
c$$$    Re = earth_radius_eq/1000.d0
c$$$    Rp=earth_radius_pole/1000.d0
c$$$    N= Re**2/sqrt( Re**2 * dcos(lat*deg_to_rad)**2 +  Rp**2 * dsin(lat*deg_to_rad)**2)
c$$$    ainc=asin( (H+N)/N*dsin(antlook*deg_to_rad) )*rad_to_deg
c$$$
c$$$    xi=(ainc-antlook)*deg_to_rad
c$$$    Rg=N*xi
c$$$    
c$$$c   N= Re**2/sqrt( Re**2 * dcos(xi)**2 +  Rp**2 * dsin(xi)**2)
c$$$    Vrc(1)=N*dsin(xi)*dcos(antazi*deg_to_rad)
c$$$    Vrc(2)=N*dsin(xi)*dsin(antazi*deg_to_rad)
c$$$    Vrc(3)=N*dcos(xi)
c$$$c   Vrc(3)= Rp**2/Re**2*N*dcos(xi)
c$$$    
c$$$    
c$$$    Vrg(1)=dcos(xi)*dcos(antazi*deg_to_rad)
c$$$    Vrg(2)=dcos(xi)*dsin(antazi*deg_to_rad)
c$$$    Vrg(3)=-dsin(xi)
c$$$    
c$$$    
c$$$    Vphi(1)=-dsin(antazi*deg_to_rad)
c$$$    Vphi(2)=dcos(antazi*deg_to_rad)
c$$$    Vphi(3)=0;
c$$$    
c$$$    
c$$$    Vr(1)=Vrc(1)
c$$$    Vr(2)=Vrc(2)
c$$$    Vr(3)=Vrc(3)-(H+N)
c$$$    
c$$$    Rslant=(N+H)*dsin(xi)/dsin(ainc*deg_to_rad)
c$$$
c$$$
c$$$
c$$$    return
c$$$    end

        subroutine cellgeo(H,lat,antlook,antazi,ainc,Rslant,Rg,Vrc,Vrg,Vphi,Vr)

c$$$% based on S. Yueh's:       
c$$$% Input:
c$$$%       H: Spacecraft altitude (km)
c$$$%       antlook: Elevation angle of the antenna boresight (deg)
c$$$%       antazi: Azimuth angle of antenna pointing (deg) wrt the sc nadir track
c$$$% Output:
c$$$%       ainc: Incidence angle (deg)
c$$$%       Rslant: slant range from the cell to the spacecraft
c$$$%       Rg: Ground range of the cell from the spacecraft nadir
c$$$%       Vrc: Cartesian coordinates of the cell
c$$$%       Vrg: unit vector tangential to the local surface
c$$$%               from the spacecraft nadir to the cell
c$$$%       Vphi: unit vector perpendicular to Vrc and Vrg
c$$$%       Vr: position vector from the spacecraft to the cell

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi, lat,wavelength
        real*8 wgs84_inverse_flattening,R_SOL
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        real*8 H,antlook,antazi,Rslant
        real*8 Vrc(3),Vrg(3),Vphi(3),Vr(3)


        real*8 ainc,xi,Rg,R2,Re



        Re = earth_radius_eq/1000.d0
        ainc=asin( (H+Re)/Re*dsin(antlook*deg_to_rad) )*rad_to_deg

        xi=(ainc-antlook)*deg_to_rad
        Rg=Re*xi
        
        
        Vrc(1)=Re*dsin(xi)*dcos(antazi*deg_to_rad)
        Vrc(2)=Re*dsin(xi)*dsin(antazi*deg_to_rad)
        Vrc(3)=Re*dcos(xi)
        
        
        Vrg(1)=dcos(xi)*dcos(antazi*deg_to_rad)
        Vrg(2)=dcos(xi)*dsin(antazi*deg_to_rad)
        Vrg(3)=-dsin(xi)
        
        
        Vphi(1)=-dsin(antazi*deg_to_rad)
        Vphi(2)=dcos(antazi*deg_to_rad)
        Vphi(3)=0;
        
        
        Vr(1)=Vrc(1)
        Vr(2)=Vrc(2)
        Vr(3)=Vrc(3)-(H+Re)
        
        Rslant=(Re+H)*dsin(xi)/dsin(ainc*deg_to_rad)



        return
        end


        subroutine cellarea(H,lat,antlook,antazi,beamw1,beamw2,area,a,b,delR,Rslant,ainc)

c$$$% Based on S. Yueh's:  
c$$$% Input:
c$$$%       H: Spacecraft altitude (km)
c$$$%       antlook: Elevation angle of the antenna boresight (deg)
c$$$%       antazi: Azimuth angle of antenna pointing (deg) wrt the sc nadir track
c$$$%       beamw1: Elevation beam width of antenna (deg)
c$$$%       beamw2: Azimuth beam width of antenna (deg)
c$$$% Output:
c$$$%       area: Cell area (kmxkm)
c$$$%       a: Axial length of the footprint in range direction (km)
c$$$%       b: Axial length of the footprint in azimuth direction (km)
c$$$%       delR: difference in slant range from near to far end of cell

        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,wavelength
        real*8 wgs84_inverse_flattening,R_SOL
        common /block/earth_radius_eq, earth_radius_pole, 
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength

        real*8 compute_dot_product
        real*8 H,HKm,antlook,antazi
        real*8 beamw1,beamw2, lat
        real*8 area,a,b,delR


        real*8 Vrc(3),Vrg(3),Vphi(3),Vr(3)


        real*8 ainc,Rg,Rslant
        real*8 Rg1,Rg2,R2,Rslant1,Rslant2
        real*8 antlook1,antlook2

        HKm=H/1000.0d0

        antlook1=antlook-beamw1/2.d0
        call cellgeo(HKm,lat,antlook1,antazi,ainc,Rslant1,Rg1,Vrc,Vrg,Vphi,Vr)

        antlook2=antlook+beamw1/2.d0
        call cellgeo(HKm,lat,antlook2,antazi,ainc,Rslant2,Rg2,Vrc,Vrg,Vphi,Vr)
        a=(Rg2-Rg1)/2.d0
        delR = Rslant2-Rslant1

        call cellgeo(HKm,lat,antlook,antazi,ainc,Rslant,Rg,Vrc,Vrg,Vphi,Vr)

        R2=compute_dot_product(Vr,Vr)
        Rslant=sqrt(R2)
        b=Rslant*beamw2/2.d0*deg_to_rad

c       write(*,*) 'Simon code ',H,antlook,antazi,beamw1,beamw2,Rslant,ainc

        area=pi*a*b;


        return
        end


C       subroutine julian_area(sc_s, sc_t, sc_u,sc_position,antlook,antazi,beamw1H,beamw2H,area,slant_range)
C
C
C       real*8 earth_radius_eq, earth_radius_pole
C       real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
C       real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,wavelength
C       real*8 wgs84_inverse_flattening,R_SOL
C       common /block/earth_radius_eq, earth_radius_pole, 
C     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
C     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength
C
C       real*8 sc_position(3),antlook,antazi,beamw1H,beamw2H,area,slant_range, radius
C       real*8 sc_u(3)
C       real*8 sc_t(3)
C       real*8 sc_s(3), antenna_pointing_vector_local(3)
C       logical good_solution
C       real*8 antenna_pointing_vector_rect(3), earth_position_center(3), earth_position_1(3),earth_position_2(3),earth_position_3(3),earth_position_4(3)
C       real*8 spherical_excess1, spherical_excess2, spherical_excess3, spherical_excess4
C
C
C       antenna_pointing_vector_local(1) = dsin((antlook + beamw1H/2.)*deg_to_rad)*dsin(antazi*deg_to_rad)
C       antenna_pointing_vector_local(2) = dsin((antlook + beamw1H/2.)*deg_to_rad)*dcos(antazi*deg_to_rad)
C       antenna_pointing_vector_local(3) = dcos((antlook + beamw1H/2.)*deg_to_rad)
C
C
C       call convert_local_to_rect_system(sc_s, sc_t, sc_u, antenna_pointing_vector_local, antenna_pointing_vector_rect)
C       call locate_cell_on_earth(sc_position, antenna_pointing_vector_rect, earth_position_2, slant_range, good_solution)
C
C       write(*,*) sc_position
C       write(*,*) antenna_pointing_vector_rect
C       write(*,*) earth_position_2
C       write(*,*) slant_range
C
C       antenna_pointing_vector_local(1) = dsin((antlook - beamw1H/2.)*deg_to_rad)*dsin(antazi*deg_to_rad)
C       antenna_pointing_vector_local(2) = dsin((antlook - beamw1H/2.)*deg_to_rad)*dcos(antazi*deg_to_rad)
C       antenna_pointing_vector_local(3) = dcos((antlook - beamw1H/2.)*deg_to_rad)
C
C
C       call convert_local_to_rect_system(sc_s, sc_t, sc_u, antenna_pointing_vector_local, antenna_pointing_vector_rect)
C       call locate_cell_on_earth(sc_position, antenna_pointing_vector_rect, earth_position_4, slant_range, good_solution)
C
C
C
C       antenna_pointing_vector_local(1) = dsin(antlook*deg_to_rad)*dsin((antazi + beamw2H/2.)*deg_to_rad)
C       antenna_pointing_vector_local(2) = dsin(antlook*deg_to_rad)*dcos((antazi + beamw2H/2.)*deg_to_rad)
C       antenna_pointing_vector_local(3) = dcos(antlook*deg_to_rad)
C
C       call convert_local_to_rect_system(sc_s, sc_t, sc_u, antenna_pointing_vector_local, antenna_pointing_vector_rect)
C       call locate_cell_on_earth(sc_position, antenna_pointing_vector_rect, earth_position_3, slant_range, good_solution)
C
C
C
C
C       antenna_pointing_vector_local(1) = dsin(antlook*deg_to_rad)*dsin((antazi - beamw2H/2.)*deg_to_rad)
C       antenna_pointing_vector_local(2) = dsin(antlook*deg_to_rad)*dcos((antazi - beamw2H/2.)*deg_to_rad)
C       antenna_pointing_vector_local(3) = dcos(antlook*deg_to_rad)
C
C       call convert_local_to_rect_system(sc_s, sc_t, sc_u, antenna_pointing_vector_local, antenna_pointing_vector_rect)
C       call locate_cell_on_earth(sc_position, antenna_pointing_vector_rect, earth_position_1, slant_range, good_solution)
C
C       antenna_pointing_vector_local(1) = dsin(antlook*deg_to_rad)*dsin(antazi*deg_to_rad)
C       antenna_pointing_vector_local(2) = dsin(antlook*deg_to_rad)*dcos(antazi*deg_to_rad)
C       antenna_pointing_vector_local(3) = dcos(antlook*deg_to_rad)
C
C       call convert_local_to_rect_system(sc_s, sc_t, sc_u, antenna_pointing_vector_local, antenna_pointing_vector_rect)
C       call locate_cell_on_earth(sc_position, antenna_pointing_vector_rect, earth_position_center, slant_range, good_solution)
C
C
C       call return_spherical_triangle_excess(earth_position_1, earth_position_2, earth_position_center, spherical_excess1)
C       call return_spherical_triangle_excess(earth_position_2, earth_position_3, earth_position_center, spherical_excess2)
C       call return_spherical_triangle_excess(earth_position_3, earth_position_4, earth_position_center, spherical_excess3)
C       call return_spherical_triangle_excess(earth_position_4, earth_position_1, earth_position_center, spherical_excess4)
C
C       radius = dsqrt(earth_position_center(1)**2 + earth_position_center(2)**2 + earth_position_center(3)**2)
C
C
Cc      write(*,*) spherical_excess1, spherical_excess2 , spherical_excess3 , spherical_excess4
C
C       area = ((spherical_excess1 + spherical_excess2 + spherical_excess3 + spherical_excess4)*radius**2)*1.d-6
C
C
C
C       return
C       end
