        subroutine read_jpl_cut_antenna_pattern_relative(file_name_in, antenna_pattern_relative, max_gain)
        character*200 file_name_in
        real*8 antenna_pattern_relative(360,721,6)
        real*8 antenna_pattern_raw(360,721,4)
        real*8 pattern(800,4)
        real*8 max_gain
        character*200 cline

        nn = lnblnk(file_name_in)
        write(*,*) file_name_in(1:nn)

        open(25,file=file_name_in,status='old')

255     format(a200)
        do 3004 jcut=1, 360
          read(25,*) cline
          read(25,255) cline  ! read past header lines
c         nnn = lnblnk(cline)
c         write(*,*) "mmm", jcut, " ", cline(1:nnn)
          k = 0
          do k = 1, 721
            read(25,*) (pattern(k,j), j=1,4)
          enddo
          do k = 1, 721
            do j = 1, 4
              antenna_pattern_raw(jcut,k,j) = pattern(k,j)
            enddo
          enddo
3004    continue
        close(25)

        co_db_max = 0.0d0

c       prepare to normalize    
        do 3005 jcut=1, 360
          do k = 1, 721 
            co = (antenna_pattern_raw(jcut,k,1)**2 + antenna_pattern_raw(jcut,k,2)**2)
            co_db = 10.d0*log10(co)
            co_db_max = max(co_db_max, co_db)

c           cr = (antenna_pattern_raw(jcut,k,3)**2 + antenna_pattern_raw(jcut,k,4)**2)
c           cr_db = 10.d0*log10(cr)
c           cr_db_max = max(cr_db_max, cr_db)
          enddo
3005    continue


c       normalize to maximum gain  (the maximum relative gain is 0 db)
c       this is the one-way pattern in dB
        do 3006 jcut=1, 360
          do k = 1, 721 
            co = (antenna_pattern_raw(jcut,k,1)**2 + antenna_pattern_raw(jcut,k,2)**2)
            co_db = 10.d0*log10(co)
            co_db_relative = co_db - co_db_max

            cr = (antenna_pattern_raw(jcut,k,3)**2 + antenna_pattern_raw(jcut,k,4)**2)
            cr_db = 10.d0*log10(cr)
            cr_db_relative = cr_db - co_db_max

            antenna_pattern_relative(jcut,k,1) = co_db_relative
            antenna_pattern_relative(jcut,k,2) = cr_db_relative
            antenna_pattern_relative(jcut,k,3) = antenna_pattern_raw(jcut,k,1)/(10.0d0**(co_db_max/20.0d0))
            antenna_pattern_relative(jcut,k,4) = antenna_pattern_raw(jcut,k,2)/(10.0d0**(co_db_max/20.0d0))
            antenna_pattern_relative(jcut,k,5) = antenna_pattern_raw(jcut,k,3)/(10.0d0**(co_db_max/20.0d0))
            antenna_pattern_relative(jcut,k,6) = antenna_pattern_raw(jcut,k,4)/(10.0d0**(co_db_max/20.0d0))


c$$$        write(*,*)  co,  co_db_relative,antenna_pattern_raw(jcut,k,1)**2+ antenna_pattern_raw(jcut,k,2)**2
c$$$        write(*,*)  10.d0*log10((antenna_pattern_raw(jcut,k,1)/(10.0d0**(co_db_max/20.0d0)))**2+ (antenna_pattern_raw(jcut,k,2)/(10.0d0**(co_db_max/20.0d0)))**2)
c$$$        write(*,*)  ((antenna_pattern_raw(jcut,k,1)/(10.0d0**(co_db_max/20.0d0)))**2+ (antenna_pattern_raw(jcut,k,2)/(10.0d0**(co_db_max/20.0d0)))**2)
c$$$        pause



          enddo
3006    continue

        max_gain = co_db_max

        return
        end

