c*****************************************************************
      subroutine sigma0_bias_adj(iyear, idoy, bias_adj)
c*****************************************************************
c**
c**   FILE NAME: sigma0_bias_adj.f
c**
c**   DATE WRITTEN: 3/12/2014
c**
c**   PROGRAMMER: Alex Fore
c**
c**   FUNCTIONAL DESCRIPTION: Applies a sigma0 bias adjustment.
c**
c**   ROUTINES CALLED:
c**
c**   NOTES:
c**
c**   UPDATE LOG:
c**
c**   Date Changed        Reason Changed        CR # and Version #
c**   ------------       ----------------       ------------------
c**
c*****************************************************************
      implicit none
c     PARAMETER STATEMENTS
      integer stdout, stderr, stdin
      parameter( stdout = 6, stderr = 0, stdin = 5 )
c     INPUT VARIABLES
      integer iyear
      integer idoy
c     OUTPUT VARIABLES
      real*4 bias_adj(3,2) ! beam:(1,2,3), polarization: (HH,VV)
c     LOCAL VARIABLES
      real*4 bias_mag
      real*4 offset(3, 2)
      real*4 tau
      real*8 djd
      real*8 jd, jd_start
      integer*4 ibeam, ipol
c     DATA STATEMENTS
c     COMMON BLOCKS
c     FUNCTION STATEMENTS
      real*4 date2j
c     PROCESSING STEPS
      
      tau = 45.0
      bias_mag = -0.12

      offset(1,1) = 0
      offset(1,2) = 0
      offset(2,1) = -0.07
      offset(2,2) = -0.03
      offset(3,1) = -0.05
      offset(3,2) = -0.015
      
      ! days since 2011-Aug-25
      call find_julian_day( 2011, 8, 25, jd_start )
      call find_julian_day( iyear, 1, 1, jd )
      jd = jd + real(idoy-1)
      djd = jd - jd_start
      do ibeam=1,3
        do ipol=1,2
          bias_adj(ibeam,ipol) = bias_mag*exp(-djd/tau)+offset(ibeam,ipol)
        enddo
C        write(6,*) bias_adj(ibeam,1), bias_adj(ibeam,2), jd, jd_start, djd, iyear, idoy
      enddo
      end