        subroutine return_spherical_triangle_excess(earth_position_1, earth_position_2, earth_position_3, spherical_excess)
        implicit none
        real*8 earth_position_1(3)
        real*8 earth_position_2(3)
        real*8 earth_position_3(3)
        real*8 angle_a, angle_b, angle_c
        real*8 distance_a, distance_b, distance_c
        real*8 spherical_excess,R_SOL


        real*8 earth_radius_eq, earth_radius_pole
        real*8 earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq
        real*8 one, two, one_eighty, rad_to_deg, deg_to_rad, pi,wavelength
        common /block/earth_radius_eq, earth_radius_pole,
     &               earth_eccentricity, earth_eccentricity_sq, one_minus_earth_eccentricity_sq,
     &               one, two, one_eighty, rad_to_deg, deg_to_rad, pi,R_SOL,wavelength





c         write(*,*) 'a: ', earth_position_1(1), earth_position_1(2), earth_position_1(3)
c         write(*,*) 'b: ', earth_position_2(1), earth_position_2(2), earth_position_2(3)
c         write(*,*) 'c: ', earth_position_3(1), earth_position_3(2), earth_position_3(3)
c         write(85,855) 'd: ', earth_position_1(1)-earth_position_2(1), earth_position_1(2)-earth_position_2(2), earth_position_1(3)-earth_position_2(3)
c         write(85,855) 'd: ', earth_position_1(1)-earth_position_3(1), earth_position_1(2)-earth_position_3(2), earth_position_1(3)-earth_position_3(3)
855       format(a3, 3e33.25)

          call return_angle_between_vectors(earth_position_1, earth_position_2, angle_a)
          call return_angle_between_vectors(earth_position_2, earth_position_3, angle_b)
          call return_angle_between_vectors(earth_position_1, earth_position_3, angle_c)


          distance_a = deg_to_rad*angle_a
          distance_b = deg_to_rad*angle_b
          distance_c = deg_to_rad*angle_c
          
          call find_spherical_excess(distance_a, distance_b, distance_c, spherical_excess)
c         write(*,*) 'Angles ',  distance_a,  distance_b,  distance_c, spherical_excess
c         area = spherical_excess*earth_radius_eq**2
c         area = spherical_excess*earth_radius_pole**2
c         area = spherical_excess*local_earth_radius**2

c         write(85,866) 'w: ', distance_a, distance_b, distance_c
c         write(85,866) 'z: ', spherical_excess, area
866     format(a3, 4e21.12)

        return
        end

        subroutine find_spherical_excess(distance_a, distance_b, distance_c, spherical_excess)
        implicit none
        real*8 distance_a, distance_b, distance_c
        real*8 spherical_excess
        real*8 s
        real*8 t1, t2, t3, t4, t5, t6
        real*8 a, b, c
        real*8 big


        a = distance_a
        b = distance_b
        c = distance_c

        s = (a + b + c)/2.0d0
c       write(*,903) a,b,c,s
        t1 = dtan(s/2.0d0)
        t2 = dtan((s-a)/2.0d0)
        t3 = dtan((s-b)/2.0d0)
        t4 = dtan((s-c)/2.0d0)


        t5 = t1*t2*t3*t4
c       write(*,903) t1,t2,t3,t4,dsqrt(t5)
        if ( t5 .ge. 0. ) then
          t6 = dsqrt(t5)
          spherical_excess = 4.0d0*datan(t6)
        else
c         write(85,866) 'e: '
          spherical_excess = 0.d0
        endif

c       write(85,866) 'm: ', t1, t2, t3, t4
c       write(85,866) 'r: ', t5, t6, spherical_excess
866     format(a3, 4e21.12)
 903    format(5f30.16)

        return
        end
