      subroutine gps2yds(gpsec,iyr,idy,sec)

c     This routine converts GPS time (seconds since 6 January 1980) 
c      to the equivalent year, day-of-year and seconds-of-day
c
c
c       Arguments
c
c       Name       Type    I/O     Description
c       ----       ----    ---     -----------
c       gpsec      long     I      GPS time
c       iyr        long     O      Year
c       idy        long     O      Day of year
c       sec        long     O      Seconds of day
c
c     Written by Frederick S. Patt, SAIC, September 30, 2010
c
c     Modification History:
c
c     Updated to add leap second on 1 July 2012.  F. S. Patt, SAIC, 
c     June 25, 2012.   
      
      integer*4 gpsec,iyr,idy,sec
      integer*4 nleap,gpsleap,jd
      
c     Get leap seconds for that day
      nleap = gpsleap(gpsec)
c      print,'Leap seconds since GPS epoch',nleap

c     Compute Julian date 
      jd = (gpsec - nleap)/86400 + 2444245

c     Convert to year and day
      call jdate(jd,iyr,idy)

c     Compute seconds of day
      sec = mod((gpsec - nleap),86400)

      return
      end

      function gpsleap(gpsec)

c Determines number of leap seconds since GPS epoch (6 Jan 1980)

      integer gpsleap,gpsec
      integer gpleap(20),i

c  GPS seconds corresponding to leap second epochs
      data gpleap/46828801,78364802,109900803,173059204,252028805, 
     *     315187206,346723207,393984008,425520009,457056010,504489611, 
     *     551750412,599184013,820108814,914803215,1025136016, 
     *     4*2147483647/

      gpsleap = 0
      do i=1,20 
         if (gpsec.gt.gpleap(i)) gpsleap = gpsleap + 1
      end do

      return
      end
