      subroutine yds2ymdhms(iyin,idin,secin,iyr,mon,idm,ihr,min,sec)

c  Convert date and time from year, day-of-year, seconds-of-day to
c   year, month, day, hour, minute, second

c  Calling Arguments:
c
c     Name         Type    I/O     Description
c     --------     ----    ---     -----------
c     iyin         I*4      I      Input year
c     idin         I*4      I      Input day
c     secin        R*8      I      Input seconds
c     iyr          I*4      O      Output year
c     mon          I*4      O      Output month
c     idm          I*4      O      Output day
c     ihr          I*4      O      Output hours
c     min          I*4      O      Output minutes
c     sec          R*8      O      Output seconds

c  By: Frederick S. Patt, July 19, 2011
c
c  Notes:  
c
c  Modification History:

      real*8 secin,sec
      integer*4 iyin,idin,iyr,mon,idm,ihr,min,jday

      jday = jd(iyin,1,idin) + secin/864.d2
      call jddate(jday,iyr,mon,idm)
      sec = dmod(secin,864.d2)
      ihr = sec/3600.d0
      min = dmod(sec,3600.d0)/60.d0
      sec = dmod(sec,60.d0)

      return
      end


      
